<?php
 Session_Start () ;
 If (!IsSet ($_SESSION ["repertoire_config"])) { Header ("Location: ../../") ; }
 Include ("../../include/garennes.cfg") ;
 Include ("../../include/init.php") ;
 Include ("../include/config.inc") ;
 verif_droits ($droit_courant, $_SESSION ["code"]) ;
 
 $id_classe = var_courante ("id_classe", 0, null) ;
 $code = var_courante ("code", 0, $_SESSION ["code"]) ;
 $millesime = millesime (0) ;
 
 If (IsSet ($id_classe))
  {
   If ($id_classe > 0)
    {
     SQL_transmission (4) ;
     $nbr_sous_discipline = 0 ;
     // Recherche des Groupes et contruction de l'affichage
     $groupes = groupes_classe ($id_classe) ;
     $nbr_col_grp = 0 ;
     If (Is_Array ($groupes))
      {
       While (list ($cle, $valeur) = Each ($groupes))
        {
         $nbr_col_grp++ ;
         $serv_prof = SQL_commande ("SELECT sous_discipline,id_service_prof FROM services_prof WHERE service_classe='".$groupes [$cle][1]."' LIMIT 1", $id_sql) ;
         $sp = SQL_ligne_suivante ($serv_prof) ;
	 $grp [$nbr_col_grp][0] = $groupes [$cle][0] ;
         If ((integer)$sp [0] > 0)
          {
           $sous_disc = SQL_commande ("SELECT nom FROM sous_disciplines WHERE id_sous_discipline='".$sp [0]."' LIMIT 1", $id_sql) ;
           $sd = SQL_ligne_suivante ($sous_disc) ;
	   $nbr_sous_discipline++ ;
	   $grp [$nbr_col_grp][1] = $sd [0] ;
	  }
	 Else { $grp [$nbr_col_grp][1] = "" ; }
        }
      }
     // Recherche des Options et contruction de l'affichage
     $resultat = SQL_commande ("SELECT d.nom_bref,s.id_service_classe FROM disciplines d,services_classe s
                                 WHERE d.id_discipline=s.discipline AND s.classe='".$id_classe."' AND s.optionnelle='1' AND s.millesime='".$millesime."' ORDER BY d.nom_bref,s.id_service_classe", $id_sql) ;
     $nbr_col_opt = 0 ;
     If (SQL_nbr_lignes ($resultat) > 0)
      {
       For ($i = 0 ; $i < SQL_nbr_lignes ($resultat) ; $i++)
        {
         $option = SQL_ligne_suivante ($resultat) ;
	 $nbr_col_opt++ ;
         // Recherche service prof correspondant
         $serv_prof = SQL_commande ("SELECT sous_discipline,id_service_prof FROM services_prof WHERE service_classe='".$option [1]."' LIMIT 1", $id_sql) ;
         $sp = SQL_ligne_suivante ($serv_prof) ;
	 $opt [$nbr_col_opt][0] = "(".$sp [1].") ".$option [0] ;
         If ((integer)$sp [0] > 0)
          {
           $sous_disc = SQL_commande ("SELECT nom FROM sous_disciplines WHERE id_sous_discipline='".$sp [0]."' LIMIT 1", $id_sql) ;
           $sd = SQL_ligne_suivante ($sous_disc) ;
	   $nbr_sous_discipline++ ;
	   $opt [$nbr_col_opt][1] = $sd [0] ;
	  }
	 Else { $opt [$nbr_col_opt][1] = "" ; }
        }
      }
     
     If (($nbr_col_grp > 0) Or ($nbr_col_opt > 0))
      {
       Include ("../../include/phppdflib.class.php") ;
       Include ("../../include/tableaux_pdf.inc") ;
     
       $taille_fonte_titre = 12 ;
       $taille_fonte_date = 8 ;
       $taille_fonte_entete = 10 ;
       $taille_fonte_cellules = 9 ;
       $numerotation_lignes = 1 ;
       
       //
       // Construction du tableau
       //
       // RENSEIGNEMENTS GENERAUX SUR LA (OU LES) PAGE(S)
       $table [0][0] = "a4" ; // Format de la page : letter, legal, executive, tabloid, a3, a4, a5
       $table [0][1] = "F" ;  // Orientation : F portrait, I paysage
       $table [0][2] = 2 ;    // Nombre de "titres"
       $table [0][3] = 0 ;    // Nombre de "cellules"
       $table [0][4] = 0 ;    // Nombre de "lignes"
       
       $table [0][5] = 15 ;   // Marge haut
       $table [0][6] = 15 ;   // Marge bas
       $table [0][7] = 15 ;   // Marge gauche
       $table [0][8] = 15 ;   // Marge droite
       
       $table [0][9] = 0 ;    // Lignes des cellules : 0 arret si plus de donnees 1 continu jusqu'au bout
       $table [0][10] = 1 ;
       
       // TITRE 1
       $table [0][11] = "Groupes/Options" ; // Titre 1
       $table [0][12] = "G" ;                             // Type de caracteres : G gras, N normal, I italique, M gras+italique
       $table [0][13] = "N" ;                             // Fond : G grisee, N normal
       $table [0][14] = "M" ;                             // Position : M milieu, G gauche, D droite
       $table [0][15] = "H" ;                             // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
       $table [0][16] = Chr (30+$taille_fonte_titre) ;    // Taille : Chr (30+$taille)
       $table [0][17] = 0 ;                               // Encadrement : 0 non, 1 oui
       
       // TITRE 2 : Classe
       // Sous-discipline
       $classe = SQL_commande ("SELECT nom,nom_bref FROM classes WHERE id_classe='".$id_classe."' LIMIT 1", $id_sql) ;
       $cl = SQL_tableau_associatif ($classe, "") ;
       $table [0][21+10*$nbr_titre] = "Classe : ".$cl ["nom"]." (".$cl ["nom_bref"].")" ;
       $table [0][22+10*$nbr_titre] = "G" ;                                                // Type de caracteres
       $table [0][23+10*$nbr_titre] = "N" ;                                                // Fond
       $table [0][24+10*$nbr_titre] = "M" ;                                                // Position
       $table [0][25+10*$nbr_titre] = "H" ;                                                // Fonte
       $table [0][26+10*$nbr_titre] = Chr (30+$taille_fonte_titre) ;                        // Taille
       $table [0][27+10*$nbr_titre] = 0 ;                                                  // Encadrement : 0 non, 1 oui
       
       // ENTETES : LIGNE DE CELLULES 1
       If ($numerotation_lignes)
        {
         $table [1][11] = "" ;
         $num = 11 ;
         $table [1][0] = "N" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
         $table [1][1] = "N" ;     // Fond des cellules : G grisee, N normal
         $table [1][2] = "G" ;     // Position : M milieu, G gauche, D droite
         $table [1][3] = "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
         $table [1][4] = Chr (30+$taille_fonte_entete) ;
        }
       Else
        {
         $num = 10 ;
         $table [1][0] = "" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
         $table [1][1] = "" ;     // Fond des cellules : G grisee, N normal
         $table [1][2] = "" ;     // Position : M milieu, G gauche, D droite
         $table [1][3] = "" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
         $table [1][4] = "" ;
        }
       $table [1][0] .= "N" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
       $table [1][1] .= "N" ;     // Fond des cellules : G grisee, N normal
       $table [1][2] .= "G" ;     // Position : M milieu, G gauche, D droite
       $table [1][3] .= "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
       $table [1][4] .= Chr (30+$taille_fonte_entete) ;	
       $table [1][$num+1] .= "" ;
       // Parcours les groupes
       For ($i = 1 ; $i <= $nbr_col_grp ; $i++)
        {
	 $table [1][0] .= "G" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
         $table [1][1] .= "G" ;     // Fond des cellules : G grisee, N normal
         $table [1][2] .= "M" ;     // Position : M milieu, G gauche, D droite
         $table [1][3] .= "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
         $table [1][4] .= Chr (30+$taille_fonte_entete) ;
         $table [1][$num+$i+1] = "Grp." ;
        }
       // Parcours les options
       For ($i = 1 ; $i <= $nbr_col_opt ; $i++)
        {
	 $table [1][0] .= "G" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
         $table [1][1] .= "G" ;     // Fond des cellules : G grisee, N normal
         $table [1][2] .= "M" ;     // Position : M milieu, G gauche, D droite
         $table [1][3] .= "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
         $table [1][4] .= Chr (30+$taille_fonte_entete) ;
         $table [1][$num+$i+$nbr_col_grp+1] = "Opt." ;
        }
       
       // ENTETES : LIGNE DE CELLULES 2
       If ($numerotation_lignes)
        {
	 If ($nbr_sous_discipline == 0)
	  {
	   $table [2][11] = "n" ;
	   $table [2][0] = "G" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
           $table [2][1] = "G" ;     // Fond des cellules : G grisee, N normal
	  }
	 Else
	  {
	   $table [2][11] = "" ;
	   $table [2][0] = "N" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
           $table [2][1] = "N" ;     // Fond des cellules : G grisee, N normal
	  }
         $num = 11 ;
         $table [2][2] = "M" ;     // Position : M milieu, G gauche, D droite
         $table [2][3] = "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
         $table [2][4] = Chr (30+$taille_fonte_entete) ;
        }
       If ($nbr_sous_discipline == 0)
        {
         $table [2][0] .= "G" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
         $table [2][1] .= "G" ;     // Fond des cellules : G grisee, N normal
         $table [2][2] .= "M" ;     // Position : M milieu, G gauche, D droite
	 $table [2][$num+1] = "Noms" ;
	}
       Else
        {
	 $table [2][0] .= "N" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
         $table [2][1] .= "N" ;     // Fond des cellules : G grisee, N normal
         $table [2][2] .= "G" ;     // Position : M milieu, G gauche, D droite
	 $table [2][$num+1] = "" ;
	}
       $table [2][3] .= "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
       $table [2][4] .= Chr (30+$taille_fonte_entete) ;	
       // Parcours les groupes
       For ($i = 1 ; $i <= $nbr_col_grp ; $i++)
        {
	 $table [2][0] .= "G" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
         $table [2][1] .= "G" ;     // Fond des cellules : G grisee, N normal
         $table [2][2] .= "M" ;     // Position : M milieu, G gauche, D droite
         $table [2][3] .= "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
         $table [2][4] .= Chr (30+$taille_fonte_entete) ;
         $table [2][$num+$i+1] = $grp [$i][0] ;
        }
       // Parcours les options
       For ($i = 1 ; $i <= $nbr_col_opt ; $i++)
        {
	 $table [2][0] .= "G" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
         $table [2][1] .= "G" ;     // Fond des cellules : G grisee, N normal
         $table [2][2] .= "M" ;     // Position : M milieu, G gauche, D droite
         $table [2][3] .= "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
         $table [2][4] .= Chr (30+$taille_fonte_entete) ;
         $table [2][$num+$i+$nbr_col_grp+1] = $opt [$i][0] ;
        }

       // ENTETES : LIGNE DE CELLULES 3
       If ($nbr_sous_discipline > 0)
        {
         If ($numerotation_lignes)
          {
           $table [3][11] = "n" ;
           $num = 11 ;
           $table [3][0] = "G" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
           $table [3][1] = "G" ;     // Fond des cellules : G grisee, N normal
           $table [3][2] = "M" ;     // Position : M milieu, G gauche, D droite
           $table [3][3] = "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
           $table [3][4] = Chr (30+$taille_fonte_entete) ;
          }
         $table [3][0] .= "G" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
         $table [3][1] .= "G" ;     // Fond des cellules : G grisee, N normal
         $table [3][2] .= "M" ;     // Position : M milieu, G gauche, D droite
         $table [3][3] .= "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
         $table [3][4] .= Chr (30+$taille_fonte_entete) ;	
         $table [3][$num+1] = "Noms" ;
         // Parcours les groupes
         For ($i = 1 ; $i <= $nbr_col_grp ; $i++)
          {
  	   $table [3][0] .= "G" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
           $table [3][1] .= "G" ;     // Fond des cellules : G grisee, N normal
           $table [3][2] .= "M" ;     // Position : M milieu, G gauche, D droite
           $table [3][3] .= "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
           $table [3][4] .= Chr (30+$taille_fonte_entete) ;
           $table [3][$num+$i+1] = $opt [$i][1] ;
          }
         // Parcours les options
         For ($i = 1 ; $i <= $nbr_col_opt ; $i++)
          {
	   $table [3][0] .= "G" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
           $table [3][1] .= "G" ;     // Fond des cellules : G grisee, N normal
           $table [3][2] .= "M" ;     // Position : M milieu, G gauche, D droite
           $table [3][3] .= "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
           $table [3][4] .= Chr (30+$taille_fonte_entete) ;
           $table [3][$num+$i+$nbr_col_grp+1] = $opt [$i][1] ;
          }
         $compteur = 2 ;
	 $debut = 2 ;
	}
       Else { $compteur = 1 ; $debut = 1 ; }
       // Chercher les fiches eleves
       $resultat = SQL_commande ("SELECT * FROM eleves WHERE classe='".$id_classe."' AND exterieur='0' ORDER BY nom,prenoms", $id_sql) ;
       $nombre_eleves = SQL_nbr_lignes ($resultat) ;
       For ($i = 0 ; $i < $nombre_eleves ; $i++)
        {
         $ligne = SQL_tableau_associatif ($resultat, "") ;
	 $compteur++ ;
	 
	 // Ligne de cellules 1+$compteur
         If ($numerotation_lignes)
          {
           $table [1+$compteur][11] = $compteur-$debut ;
           $num = 11 ;
           $table [1+$compteur][0] = "G" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
	   If (($compteur-$debut)%2 == 0) { $table [1+$compteur][1] .= "G" ; } Else { $table [1+$compteur][1] .= "N" ; }
           $table [1+$compteur][2] = "M" ;     // Position : M milieu, G gauche, D droite
           $table [1+$compteur][3] = "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
           $table [1+$compteur][4] = Chr (30+$taille_fonte_cellules) ; // Taille : Chr (30+$taille)
          }
         Else
          {
           $num = 10 ;
           $table [1+$compteur][0] = "" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
           $table [1+$compteur][1] = "" ;     // Fond des cellules : G grisee, N normal
           $table [1+$compteur][2] = "" ;     // Position : M milieu, G gauche, D droite
           $table [1+$compteur][3] = "" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
           $table [1+$compteur][4] = "" ; // Taille : Chr (30+$taille)
          }
         
	 // Eleves
         If (StrPos ($ligne ["prenoms"], " ")) { $prenoms = SubStr ($ligne ["prenoms"], 0, StrPos ($ligne ["prenoms"], " ")) ; }
         Else { $prenoms = $ligne ["prenoms"] ; }
     
         // Nom + Prenoms
	 $table [1+$compteur][0] .= "N" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
	 If (($compteur-$debut)%2 == 0) { $table [1+$compteur][1] .= "G" ; } Else { $table [1+$compteur][1] .= "N" ; }
         $table [1+$compteur][2] .= "G" ;     // Position : M milieu, G gauche, D droite
         $table [1+$compteur][3] .= "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
         $table [1+$compteur][4] .= Chr (30+$taille_fonte_entete) ;
         $table [1+$compteur][$num+1] = $ligne ["nom"]." ".$prenoms ;
     
         // Groupes
         $groupes = groupes_classe ($id_classe) ;
	 $j = 0 ;
         If (Is_Array ($groupes))
          {
           While (list ($cle, $valeur) = Each ($groupes))
            {
	     $nom_groupe = "" ;
	     $k = 0 ;
             //For ($k = 0 ; $k < $groupes [$cle][2] ; $k++)
	     While (($k < $groupes [$cle][2]) And ($nom_groupe == ""))
              {
	       If (numero_groupe ($ligne ["id_eleve"], $cle) == $groupes [$cle][3+$k*2]) { $nom_groupe = $groupes [$cle][4+$k*2] ; }
	       $k++ ;
              }
	     $j++ ;
	     $table [1+$compteur][0] .= "N" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
	     If (($compteur-$debut)%2 == 0) { $table [1+$compteur][1] .= "G" ; } Else { $table [1+$compteur][1] .= "N" ; }
             $table [1+$compteur][2] .= "M" ;     // Position : M milieu, G gauche, D droite
             $table [1+$compteur][3] .= "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
             $table [1+$compteur][4] .= Chr (30+$taille_fonte_entete) ;
             $table [1+$compteur][$num+1+$j] = $nom_groupe ;
            }
          }
     
         // Options
         $resultats = SQL_commande ("SELECT s.id_service_classe,d.id_discipline,d.code FROM disciplines d,services_classe s
                                      WHERE d.id_discipline=s.discipline AND s.classe='".$id_classe."' AND s.optionnelle='1' ORDER BY d.nom_bref,s.id_service_classe", $id_sql) ;
         For ($j = 0 ; $j < SQL_nbr_lignes ($resultats) ; $j++)
          {
           $option = SQL_tableau_associatif ($resultats, "") ;
  	   $so = suit_loption ($ligne ["id_eleve"], $option ["id_discipline"], $option ["id_service_classe"]) ;
	   If ($so > 0)
	    {
	     $table [1+$compteur][0] .= "N" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
	     If (($compteur-$debut)%2 == 0) { $table [1+$compteur][1] .= "G" ; } Else { $table [1+$compteur][1] .= "N" ; }
             $table [1+$compteur][2] .= "M" ;     // Position : M milieu, G gauche, D droite
             $table [1+$compteur][3] .= "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
             $table [1+$compteur][4] .= Chr (30+$taille_fonte_entete) ;
             $table [1+$compteur][$num+$nbr_col_grp+2+$j] = "X" ;
	    }
	   Else
	    {
	     $table [1+$compteur][0] .= "N" ;     // Type de caracteres : G gras, N normal, I italique, M gras+italique
	     If (($compteur-$debut)%2 == 0) { $table [1+$compteur][1] .= "G" ; } Else { $table [1+$compteur][1] .= "N" ; }
             $table [1+$compteur][2] .= "M" ;     // Position : M milieu, G gauche, D droite
             $table [1+$compteur][3] .= "H" ;     // Fonte : H helvetica, C courrier, T times roman, S symbol, Z zapfdingbats
             $table [1+$compteur][4] .= Chr (30+$taille_fonte_entete) ;
             $table [1+$compteur][$num+$nbr_col_grp+2+$j] = "" ;
	    }
          }
        }

       $table [0][3] = $num-10+1+$nbr_col_grp+$nbr_col_opt ;   // Nombre de cellules
       $table [0][4] = 1+$compteur ; // Nombre de lignes
       If ($compteur > 0) { tableau_pdf ($table, "structure", 1) ; }
       Else
        {
         // Aucune donnees
         Echo "<html><body background=\"../images/fond.gif\" bgcolor=\"#ddffdd\" text=\"#000000\">" ;
         Echo "<br><br><br><center><b>Aucune donn&eacute;es !</b></center><br>" ;
         Echo "</body></html>" ;
        }
      }
     Else
      {
       // Aucune donnees
       Echo "<html><body background=\"../images/fond.gif\" bgcolor=\"#ddffdd\" text=\"#000000\">" ;
       Echo "<br><br><br><center>&nbsp;Aucun&nbsp;groupe&nbsp;ou&nbsp;option&nbsp;d&eacute;clar&eacute;&nbsp;!&nbsp;</center>" ;
       Echo "</body></html>" ;
      }
    }
   ElseIf ($id_classe < 0)
    {
     // Procedure d'appel du calcul du PDF
     Echo "<html><head><title>Garennes.</title>" ;
     Echo "<meta http-equiv=\"refresh\" content=\"1;url=./imp_grp_opt.php?fenetre=1&id_classe=".(-$id_classe)."&code=".$_SESSION ["code"]."\">" ;
     Echo "</head>" ;
     Echo "<body background=\"../images/fond.png\" onContextMenu=\"return false\">" ;
     Echo "<center><b>Cr&eacute;ation du PDF des groupes/options pour impression.<br>Calcul en cours... Veuillez patienter !</b><br>" ;
     Echo "<a href=\"./imp_grp_opt.php?fenetre=1&id_classe=".(-$id_classe)."&code=".$_SESSION ["code"]."\"><img src=\"../../images/attente.gif\" border=\"1\"></a></center>" ;
     Echo "</body></html>" ;
    }
  }
 Else { Echo "<html><head><script>window.close();</script></head></html>" ; }
?>