<?php
 /**
 * Creation d'un graphique
 * @return mixed Image au format PNG (par defaut)
 */
 // Variables par defaut
 $couleur_fond_defaut = "#faff6a";//EFEFDC" ; // Couleur fond globale
 $couleur_fond_graphe_defaut = "#ffffff";//EFEFDC" ; // Couleur fond du graphe uniquement
 $couleur_fond_degrade_defaut = 1 ; // 0=Pas de degrade;1=Degrade
 $couleur_fond_degrade_finale_defaut = "#ffffff" ; // Couleur fond finale lors d'un degrade (couleur du haut)
 $couleur_comparaison_classe_fond_defaut = "#DDDDDD" ; // Couleur fond du graphe comparaison classe
 $couleur_comparaison_classe_contour_defaut = "#000000" ; // Couleur contour du graphe comparaison classe
 $couleur_comparaison_classe_moyenne_defaut = "#8FBCF7" ; // Couleur trace du graphe comparaison classe moyen
 $couleur_comparaison_classe_moyenne_contour_defaut = "#000F0F" ; // Couleur contour du graphe comparaison classe moyen
 
 $couleur_fond_legende_defaut = "#FFFFFF" ; // Couleur fond legende
 $couleur_contour_legende_defaut = "#000000" ; // Couleur fond legende
 $legende_3d = 1 ; // 1=3D, 0=2D
 $couleur_contour_3d_legende_defaut = "#888888" ; // Couleur fond legende
 $espace_entre_legende_h_defaut = 10 ; // Espace entre les legendes a l'horizontale
 $espace_entre_legende_v_defaut = 5 ; // Espace entre les legendes a la verticale
 $marge_legende_droite_defaut = 5 ; // Marge droite interieur legende
 $marge_legende_gauche_defaut = 5 ; // Marge gauche interieur legende
 $marge_legende_haut_defaut = 2 ; // Marge haut interieur legende
 $marge_legende_bas_defaut = 2 ; // Marge bas interieur legende
 $marge_legende_matiere_defaut = 5 ; // Marge entre la legende et les matieres
 $taille_fonte_legende_defaut = 2 ; // Taille fonte legende
 $taille_car_periode_legende_defaut = 5 ; // Nombre de caracteres du nom de periode (0=tout)
 
 $espace_entre_barre_defaut = 3 ; // Espace entre les barres
 $decalage_barre_compare_defaut = 3 ; // Espace entre les barres
 $taille_avant_grille_h_defaut = 2 ;
 $taille_arriere_grille_h_defaut = 1 ;
 $couleur_trait_grille_h_defaut = "#000000" ;
 $taille_avant_grille_v_defaut = 2 ;
 $taille_arriere_grille_v_defaut = 1 ;
 $couleur_trait_grille_v_defaut = "#000000" ;
 
 $couleur_barre_defaut [1] = "#0000FF";//8FBCF7" ; // Couleur rectangle periode 1
 $couleur_barre_defaut [2] = "#FF7700" ; // Couleur rectangle periode 2
 $couleur_barre_defaut [3] = "#FF00B6" ; // Couleur rectangle periode 3
 $couleur_barre_defaut [4] = "#60BCF4" ; // Couleur rectangle periode 4
 $couleur_barre_defaut [5] = "#8C00FF" ; // Couleur rectangle periode 5
 $couleur_barre_defaut [6] = "#FFDD00" ; // Couleur rectangle periode 6
 
 $couleur_barre_degrade_defaut [1] = 0 ; // Activation du degrade pour le rectangle periode 1
 $couleur_barre_degrade_defaut [2] = 0 ; // Activation du degrade pour le rectangle periode 2
 $couleur_barre_degrade_defaut [3] = 0 ; // Activation du degrade pour le rectangle periode 3
 $couleur_barre_degrade_defaut [4] = 0 ; // Activation du degrade pour le rectangle periode 4
 $couleur_barre_degrade_defaut [5] = 0 ; // Activation du degrade pour le rectangle periode 5
 $couleur_barre_degrade_defaut [6] = 0 ; // Activation du degrade pour le rectangle periode 6
 
 $couleur_barre_degrade_finale_defaut [1] = "#ffffff" ; // Couleur finale du degrade pour le rectangle periode 1 (a gauche)
 $couleur_barre_degrade_finale_defaut [2] = "#ffffff" ; // Couleur finale du degrade pour le rectangle periode 2 (a gauche)
 $couleur_barre_degrade_finale_defaut [3] = "#ffffff" ; // Couleur finale du degrade pour le rectangle periode 3 (a gauche)
 $couleur_barre_degrade_finale_defaut [4] = "#ffffff" ; // Couleur finale du degrade pour le rectangle periode 4 (a gauche)
 $couleur_barre_degrade_finale_defaut [5] = "#ffffff" ; // Couleur finale du degrade pour le rectangle periode 5 (a gauche)
 $couleur_barre_degrade_finale_defaut [6] = "#ffffff" ; // Couleur finale du degrade pour le rectangle periode 6 (a gauche)
 
 $couleur_barre_compare_defaut [1] = "#8F9AF7" ; // Couleur rectangle comparaison periode 1
 $couleur_barre_compare_defaut [2] = "#FF7700" ; // Couleur rectangle comparaison periode 2
 $couleur_barre_compare_defaut [3] = "#FF00B6" ; // Couleur rectangle comparaison periode 3
 $couleur_barre_compare_defaut [4] = "#60BCF4" ; // Couleur rectangle comparaison periode 4
 $couleur_barre_compare_defaut [5] = "#8C00FF" ; // Couleur rectangle comparaison periode 5
 $couleur_barre_compare_defaut [6] = "#FFDD00" ; // Couleur rectangle comparaison periode 6
 
 $couleur_barre_compare_degrade_defaut [1] = 0 ; // Activation du degrade pour le rectangle comparaison periode 1
 $couleur_barre_compare_degrade_defaut [2] = 0 ; // Activation du degrade pour le rectangle comparaison periode 2
 $couleur_barre_compare_degrade_defaut [3] = 0 ; // Activation du degrade pour le rectangle comparaison periode 3
 $couleur_barre_compare_degrade_defaut [4] = 0 ; // Activation du degrade pour le rectangle comparaison periode 4
 $couleur_barre_compare_degrade_defaut [5] = 0 ; // Activation du degrade pour le rectangle comparaison periode 5
 $couleur_barre_compare_degrade_defaut [6] = 0 ; // Activation du degrade pour le rectangle comparaison periode 6
 
 $couleur_barre_compare_degrade_finale_defaut [1] = "#ffffff" ; // Couleur finale du degrade pour le rectangle comparaison periode 1 (a droite)
 $couleur_barre_compare_degrade_finale_defaut [2] = "#ffffff" ; // Couleur finale du degrade pour le rectangle comparaison periode 2 (a droite)
 $couleur_barre_compare_degrade_finale_defaut [3] = "#ffffff" ; // Couleur finale du degrade pour le rectangle comparaison periode 3 (a droite)
 $couleur_barre_compare_degrade_finale_defaut [4] = "#ffffff" ; // Couleur finale du degrade pour le rectangle comparaison periode 4 (a droite)
 $couleur_barre_compare_degrade_finale_defaut [5] = "#ffffff" ; // Couleur finale du degrade pour le rectangle comparaison periode 5 (a droite)
 $couleur_barre_compare_degrade_finale_defaut [6] = "#ffffff" ; // Couleur finale du degrade pour le rectangle comparaison periode 6 (a droite)
 
 $couleur_barre_compare_point_defaut [1] = "#000000" ; // Couleur des points dans le rectangle comparaison periode 1
 $couleur_barre_compare_point_defaut [2] = "#000000" ; // Couleur des points dans le rectangle comparaison periode 2
 $couleur_barre_compare_point_defaut [3] = "#000000" ; // Couleur des points dans le rectangle comparaison periode 3
 $couleur_barre_compare_point_defaut [4] = "#000000" ; // Couleur des points dans le rectangle comparaison periode 4
 $couleur_barre_compare_point_defaut [5] = "#000000" ; // Couleur des points dans le rectangle comparaison periode 5
 $couleur_barre_compare_point_defaut [6] = "#000000" ; // Couleur des points dans le rectangle comparaison periode 6
 
 $couleur_contour_barre_defaut [1] = "#000000" ; // Couleur contour rectangle periode 1
 $couleur_contour_barre_defaut [2] = "#000000" ; // Couleur contour rectangle periode 2
 $couleur_contour_barre_defaut [3] = "#000000" ; // Couleur contour rectangle periode 3
 $couleur_contour_barre_defaut [4] = "#000000" ; // Couleur contour rectangle periode 4
 $couleur_contour_barre_defaut [5] = "#000000" ; // Couleur contour rectangle periode 5
 $couleur_contour_barre_defaut [6] = "#000000" ; // Couleur contour rectangle periode 6
 
 $couleur_contour_barre_compare_defaut [1] = "#000000" ; // Couleur contour rectangle comparaison periode 1
 $couleur_contour_barre_compare_defaut [2] = "#000000" ; // Couleur contour rectangle comparaison periode 2
 $couleur_contour_barre_compare_defaut [3] = "#000000" ; // Couleur contour rectangle comparaison periode 3
 $couleur_contour_barre_compare_defaut [4] = "#000000" ; // Couleur contour rectangle comparaison periode 4
 $couleur_contour_barre_compare_defaut [5] = "#000000" ; // Couleur contour rectangle comparaison periode 5
 $couleur_contour_barre_compare_defaut [6] = "#000000" ; // Couleur contour rectangle comparaison periode 6
 
 $couleur_ligne_defaut [1] = "#0000FF" ; // Couleur ligne periode 1
 $couleur_ligne_defaut [2] = "#FF7700" ; // Couleur ligne periode 2
 $couleur_ligne_defaut [3] = "#FF00B6" ; // Couleur ligne periode 3
 $couleur_ligne_defaut [4] = "#60BCF4" ; // Couleur ligne periode 4
 $couleur_ligne_defaut [5] = "#8C00FF" ; // Couleur ligne periode 5
 $couleur_ligne_defaut [6] = "#FFDD00" ; // Couleur ligne periode 6
 
 $couleur_ligne_compare_defaut [1] = "#0000FF" ; // Couleur ligne comparaison periode 1
 $couleur_ligne_compare_defaut [2] = "#FF7700" ; // Couleur ligne comparaison periode 2
 $couleur_ligne_compare_defaut [3] = "#FF00B6" ; // Couleur ligne comparaison periode 3
 $couleur_ligne_compare_defaut [4] = "#60BCF4" ; // Couleur ligne comparaison periode 4
 $couleur_ligne_compare_defaut [5] = "#8C00FF" ; // Couleur ligne comparaison periode 5
 $couleur_ligne_compare_defaut [6] = "#FFDD00" ; // Couleur ligne comparaison periode 6
 
 $couleur_contour_point_defaut [1] = "#0000FF" ; // Couleur points periode 1
 $couleur_contour_point_defaut [2] = "#FF7700" ; // Couleur points periode 2
 $couleur_contour_point_defaut [3] = "#FF00B6" ; // Couleur points periode 3
 $couleur_contour_point_defaut [4] = "#60BCF4" ; // Couleur points periode 4
 $couleur_contour_point_defaut [5] = "#8C00FF" ; // Couleur points periode 5
 $couleur_contour_point_defaut [6] = "#FFDD00" ; // Couleur points periode 6
 
 $taille_point_defaut [1] = 7 ; // Taille des points
 $taille_point_defaut [2] = 7 ; // Taille des points
 $taille_point_defaut [3] = 7 ; // Taille des points
 $taille_point_defaut [4] = 7 ; // Taille des points
 $taille_point_defaut [5] = 7 ; // Taille des points
 $taille_point_defaut [6] = 7 ; // Taille des points
 
 $forme_point_defaut [1] = 1 ; // Forme des points
 $forme_point_defaut [2] = 3 ; // Forme des points
 $forme_point_defaut [3] = 2 ; // Forme des points
 $forme_point_defaut [4] = 1 ; // Forme des points
 $forme_point_defaut [5] = 3 ; // Forme des points
 $forme_point_defaut [6] = 2 ; // Forme des points
 
 $couleur_point_defaut [1] = "#0000FF" ; // Couleur ligne periode 1
 $couleur_point_defaut [2] = "#FF7700" ; // Couleur ligne periode 2
 $couleur_point_defaut [3] = "#FF00B6" ; // Couleur ligne periode 3
 $couleur_point_defaut [4] = "#60BCF4" ; // Couleur ligne periode 4
 $couleur_point_defaut [5] = "#8C00FF" ; // Couleur ligne periode 5
 $couleur_point_defaut [6] = "#FFDD00" ; // Couleur ligne periode 6
 
 $couleur_point_compare_defaut [1] = "#E6E7E6" ; // Couleur point comparaison periode 1
 $couleur_point_compare_defaut [2] = "#E6E7E6" ; // Couleur point comparaison periode 2
 $couleur_point_compare_defaut [3] = "#E6E7E6" ; // Couleur point comparaison periode 3
 $couleur_point_compare_defaut [4] = "#E6E7E6" ; // Couleur point comparaison periode 4
 $couleur_point_compare_defaut [5] = "#E6E7E6" ; // Couleur point comparaison periode 5
 $couleur_point_compare_defaut [6] = "#E6E7E6" ; // Couleur point comparaison periode 6
 
 $couleur_contour_point_compare_defaut [1] = "#0000FF" ; // Couleur contour point comparaison periode 1
 $couleur_contour_point_compare_defaut [2] = "#FF7700" ; // Couleur contour point comparaison periode 2
 $couleur_contour_point_compare_defaut [3] = "#FF00B6" ; // Couleur contour point comparaison periode 3
 $couleur_contour_point_compare_defaut [4] = "#60BCF4" ; // Couleur contour point comparaison periode 4
 $couleur_contour_point_compare_defaut [5] = "#8C00FF" ; // Couleur contour point comparaison periode 5
 $couleur_contour_point_compare_defaut [6] = "#FFDD00" ; // Couleur contour point comparaison periode 6
 
 $taille_point_compare_defaut [1] = 7 ; // Taille points comparaison periode 1
 $taille_point_compare_defaut [2] = 7 ; // Taille points comparaison periode 2
 $taille_point_compare_defaut [3] = 7 ; // Taille points comparaison periode 3
 $taille_point_compare_defaut [4] = 7 ; // Taille points comparaison periode 4
 $taille_point_compare_defaut [5] = 7 ; // Taille points comparaison periode 5
 $taille_point_compare_defaut [6] = 7 ; // Taille points comparaison periode 6
 
 $forme_point_compare_defaut [1] = 1 ; // Forme des points comparaison periode 1
 $forme_point_compare_defaut [2] = 3 ; // Forme des points comparaison periode 2
 $forme_point_compare_defaut [3] = 2 ; // Forme des points comparaison periode 3
 $forme_point_compare_defaut [4] = 1 ; // Forme des points comparaison periode 4
 $forme_point_compare_defaut [5] = 3 ; // Forme des points comparaison periode 5
 $forme_point_compare_defaut [6] = 2 ; // Forme des points comparaison periode 6
 
 $taille_point_seuls_defaut [1] = 10 ; // Taille des points seuls
 $taille_point_seuls_defaut [2] = 10 ; // Taille des points seuls
 $taille_point_seuls_defaut [3] = 10 ; // Taille des points seuls
 $taille_point_seuls_defaut [4] = 10 ; // Taille des points seuls
 $taille_point_seuls_defaut [5] = 10 ; // Taille des points seuls
 $taille_point_seuls_defaut [6] = 10 ; // Taille des points seuls
 $taille_point_seuls_compare_defaut = 10 ; // Taille des points seuls comparaison
 
 $forme_point_seuls_defaut [1] = 1 ; // Forme des points seuls 1=rond, 2=carre, 3=croix
 $forme_point_seuls_defaut [2] = 3 ; // Forme des points seuls 1=rond, 2=carre, 3=croix
 $forme_point_seuls_defaut [3] = 2 ; // Forme des points seuls 1=rond, 2=carre, 3=croix
 $forme_point_seuls_defaut [4] = 1 ; // Forme des points seuls 1=rond, 2=carre, 3=croix
 $forme_point_seuls_defaut [5] = 3 ; // Forme des points seuls 1=rond, 2=carre, 3=croix
 $forme_point_seuls_defaut [6] = 2 ; // Forme des points seuls 1=rond, 2=carre, 3=croix
 
 $forme_point_seuls_compare_defaut [1] = 1 ; // Forme des points seuls comparaison
 $forme_point_seuls_compare_defaut [2] = 3 ; // Forme des points seuls comparaison
 $forme_point_seuls_compare_defaut [3] = 2 ; // Forme des points seuls comparaison
 $forme_point_seuls_compare_defaut [4] = 1 ; // Forme des points seuls comparaison
 $forme_point_seuls_compare_defaut [5] = 3 ; // Forme des points seuls comparaison
 $forme_point_seuls_compare_defaut [6] = 2 ; // Forme des points seuls comparaison
  
 $couleur_axes_defaut = "#000000" ; // Couleur des axes V et H
 $couleur_traits_horizontaux_defaut = "#CCCCCC" ; // Couleur traits H
 $couleur_traits_verticaux_defaut = "#CCCCCC" ; // Couleur traits V
 $couleur_trait_horizontal_indic_40_defaut = "#FF0000" ; // Couleur traits 40%Maximum
 $couleur_trait_horizontal_moyenne_defaut = "#FF7700" ; // Couleur traits moyen
 $couleur_trait_horizontal_indic_60_defaut = "#2BA02B" ; // Couleur traits 60%maximum
 $couleur_fonte_defaut = "#FFFFFF" ; // Couleur fonte
 $couleur_titre_defaut = "#000000" ; // Couleur titre
 $couleur_titre_3d_defaut = "#AAAAAA" ; // Couleur titre
 $titre_3d = 1 ; // Couleur titre en 3D
 $taille_fonte_ordonnees_defaut = "3" ; // Taille fonte ordonnees
 $taille_fonte_matiere_defaut = "3" ; // Taille fonte matieres
 
 $taille_fonte_titre_defaut = "5" ; // Taille fonte titre
 $marge_gauche_defaut = 5 ; // Marge gauche
 $marge_droite_defaut = 10 ; // Marge droite
 $marge_bas_defaut = 5 ; // Marge bas
 $marge_haut_defaut = 5 ; // Marge haut
 $marge_titre_defaut = 10 ; // Marge titre
 
 $couleur_degrade_defaut = 0 ;
 
 // Insertion du fichier de configuration
 //If (!IsSet ($reentrance))
 // {
   Session_Start () ;
   Include ("../../include/garennes.cfg") ;
   Include_Once ("../../include/init.php") ;
 //  verif_droits ($droit_courant, $code) ;
 // }
 //Include ("../../include/var_temp.inc") ;
 $fichier = $_GET ["fichier"] ;
 Include ("../../tmp/".$fichier) ;
 
 If (($compare1 == 1) And (!IsSet ($cc))) { $compare1 = 0 ; }
 If (($compare2 == 1) And (!IsSet ($cp))) { $compare2 = 0 ; }

 /**
 * Extraction de la couleur en format RRVVBB en tableau RR,VV,BB
 * @param string $rgb Couleur format RRVVBB ou #RRVVBB
 * @return array Tableau des composantes de bases R,V et B
 */
 Function extraction_couleur ($rgb)
  {
   If (SubStr ($rgb, 0, 1) == "#") { $decalage = 1 ; } Else { $decalage = 0 ; }
   $couleur [0] = (integer)HexDec (SubStr ($rgb, $decalage+0, 2)) ; 
   $couleur [1] = (integer)HexDec (SubStr ($rgb, $decalage+2, 2)) ;
   $couleur [2] = (integer)HexDec (SubStr ($rgb, $decalage+4, 2)) ;
   Return $couleur ;
  }

 /**
 * Trace d'un point
 * @param int $forme Forme du point (1=Rond;2=Rectangle;3=Croix)
 * @param int $x Abscisse
 * @param int $y Ordonnee
 * @param int $taille Rayon
 * @param mixed $couleur Couleur du point
 * @param int $taille_trace Taille de la trace
 * @param int $remplissage Remplir avec la couleur (1) ou pas (0)
 */
 Function point ($forme, $x, $y, $taille, $couleur, $taille_trace, $remplissage)
  {
   Global $image ;
   @ImageSetThickNess ($image, $taille_trace) ;
   Switch ($forme)
    {
     Default:
     Case 1 : If ($remplissage == 1) { @ImageFilledEllipse ($image, $x, $y, $taille, $taille, $couleur) ; }
              Else { @ImageEllipse ($image, $x, $y, $taille, $taille, $couleur) ; }
	      Break ;
     Case 2 : If ($remplissage == 1) { @ImageFilledRectangle ($image, $x+$taille/2, $y+$taille/2, $x-$taille/2, $y-$taille/2, $couleur) ; }
              Else { @ImageRectangle ($image, $x+$taille/2, $y+$taille/2, $x-$taille/2, $y-$taille/2, $couleur) ; }
	      Break ;
     Case 3 : @ImageLine ($image, $x, $y+$taille/2, $x, $y-$taille/2, $couleur) ;
              @ImageLine ($image, $x+$taille/2, $y, $x-$taille/2, $y, $couleur) ;
	      Break ;
    }
  }
 
 // Variables
 If (IsSet ($largeur_graphe)) { $lg = $largeur_graphe ; } Else { $lg = $largeur_graphe_defaut ; }
 If (IsSet ($hauteur_graphe)) { $hg = $hauteur_graphe ; } Else { $hg = $hauteur_graphe_defaut ; }
 If (IsSet ($marge_gauche)) { $mg = $marge_gauche ; } Else { $mg = $marge_gauche_defaut ; }
 If (IsSet ($marge_droite)) { $md = $marge_droite ; } Else { $md = $marge_droite_defaut ; }
 If (IsSet ($marge_bas)) { $mb = $marge_bas ; } Else { $mb = $marge_bas_defaut ; }
 If (IsSet ($marge_haut)) { $mh = $marge_haut ; } Else { $mh = $marge_haut_defaut ; }
 If (IsSet ($marge_titre)) { $mt = $marge_titre ; } Else { $mt = $marge_titre_defaut ; }
 If (IsSet ($taille_arriere_grille_h)) { $targh = $taille_arriere_grille_h ; } Else { $targh = $taille_arriere_grille_h_defaut ; }
 If (IsSet ($taille_avant_grille_h)) { $tavgh = $taille_avant_grille_h ; } Else { $tavgh = $taille_avant_grille_h_defaut ; }
 If (IsSet ($taille_arriere_grille_v)) { $targv = $taille_arriere_grille_v ; } Else { $targv = $taille_avant_grille_v_defaut ; }
 If (IsSet ($taille_avant_grille_v)) { $tavgv = $taille_avant_grille_v ; } Else { $tavgv = $taille_avant_grille_v_defaut ; }
 If (IsSet ($marge_legende_droite)) { $mld = $marge_legende_droite ; } Else { $mld = $marge_legende_droite_defaut ; }
 If (IsSet ($marge_legende_gauche)) { $mlg = $marge_legende_gauche ; } Else { $mlg = $marge_legende_gauche_defaut ; }
 If (IsSet ($marge_legende_haut)) { $mlh = $marge_legende_haut ; } Else { $mlh = $marge_legende_haut_defaut ; }
 If (IsSet ($marge_legende_bas)) { $mlb = $marge_legende_bas ; } Else { $mlb = $marge_legende_bas_defaut ; }
 If (IsSet ($marge_legende_matiere)) { $mlm = $marge_legende_matiere ; } Else { $mlm = $marge_legende_matiere_defaut ; }
 If (IsSet ($espace_entre_legende_h)) { $eelh = $espace_entre_legende_h ; } Else { $eelh = $espace_entre_legende_h_defaut ; }
 If (IsSet ($espace_entre_legende_v)) { $eelv = $espace_entre_legende_v ; } Else { $eelv = $espace_entre_legende_v_defaut ; }
 
 // Echelles des fontes
 $exf = $largeur_graphe/$largeur_graphe_defaut ;
 $eyf = $hauteur_graphe/$hauteur_graphe_defaut ;
 If ($exf > $eyf) { $ech = $exf ; } Else { $ech = $eyf ; }
 
 // Taille max
 $tps = 0 ;
 For ($i = 1 ; $i <= $nbr_periodes ; $i++)
  {
   If (IsSet ($taille_point [$i])) { If ($taille_point [$i]*$ech > $tps) { $tps = $taille_point [$i]*$ech ; } }
   Else { If ($taille_point_defaut [$i]*$ech > $tps) { $tps = $taille_point_defaut [$i]*$ech ; } }
   If (IsSet ($compare2) And ($compare2 == 1))
    {
     If (IsSet ($taille_point_compare [$i])) { If ($taille_point_compare [$i]*$ech > $tps) { $tps = $taille_point_compare [$i]*$ech ; } }
     Else { If ($taille_point_compare_defaut [$i]*$ech > $tps) { $tps = $taille_point_compare_defaut [$i]*$ech ; } }
    }
  }
 
 // Creation de l'image
 $image = @ImageCreateTrueColor ($lg, $hg) Or Die ("Je ne peux pas initialiser la bibliotheque GD >= 2.0.1 : Voir l'administrateur reseau") ;
 
 // Initialisation des couleurs
 // Couleur de fond du tracee
 If (IsSet ($couleur_fond)) { $c = extraction_couleur ($couleur_fond) ; } Else { $c = extraction_couleur ($couleur_fond_defaut) ; }
 $fond = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
 
 // Couleur de fond du graphe
 If (IsSet ($couleur_fond_graphe)) { $c = extraction_couleur ($couleur_fond_graphe) ; } Else { $c = extraction_couleur ($couleur_fond_graphe_defaut) ; }
 $fond_graphe = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
 
 // Couleur des axes
 If (IsSet ($couleur_axes)) { $c = extraction_couleur ($couleur_axes) ; } Else { $c = extraction_couleur ($couleur_axes_defaut) ; }
 $axes = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
 
 // Couleur traits horizontaux
 If (IsSet ($couleur_traits_horizontaux)) { $c = extraction_couleur ($couleur_traits_horizontaux) ; } Else { $c = extraction_couleur ($couleur_traits_horizontaux_defaut) ; }
 $traits_h = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
 
 // Couleur traits verticaux
 If (IsSet ($couleur_traits_verticaux)) { $c = extraction_couleur ($couleur_traits_verticaux) ; } Else { $c = extraction_couleur ($couleur_traits_verticaux_defaut) ; }
 $traits_v = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
 
 // Couleur trait moyenne
 If (IsSet ($couleur_trait_horizontal_moyenne)) { $c = extraction_couleur ($couleur_trait_horizontal_moyenne) ; } Else { $c = extraction_couleur ($couleur_trait_horizontal_moyenne_defaut) ; }
 $trait_moyenne = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
 
 // Couleur indic 40%
 If (IsSet ($couleur_trait_horizontal_indic_40)) { $c = extraction_couleur ($couleur_trait_horizontal_indic_40) ; } Else { $c = extraction_couleur ($couleur_trait_horizontal_indic_40_defaut) ; }
 $trait_indic_40 = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
 
 // Couleur indic 60%
 If (IsSet ($couleur_trait_horizontal_indic_60)) { $c = extraction_couleur ($couleur_trait_horizontal_indic_60) ; } Else { $c = extraction_couleur ($couleur_trait_horizontal_indic_60_defaut) ; }
 $trait_indic_60 = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
 
 // Couleur fonte
 If (IsSet ($couleur_fonte)) { $c = extraction_couleur ($couleur_fonte) ; } Else { $c = extraction_couleur ($couleur_fonte_defaut) ; }
 $fonte = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
 
 // Couleur titre
 If (IsSet ($couleur_titre)) { $c = extraction_couleur ($couleur_titre) ; } Else { $c = extraction_couleur ($couleur_titre_defaut) ; }
 $couleur_tt = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
 
 // Couleur transparente
 $couleur_transparente = @ImageColorTransparent ($image) ;
 
 // Taille des caracteres
 If (IsSet ($taille_fonte_titre))
  {
   $h_fonte_titre = @ImageFontHeight ($taille_fonte_titre*$ech) ;
   $l_fonte_titre = @ImageFontWidth ($taille_fonte_titre*$ech) ;
   $tftt = $taille_fonte_titre*$ech ;
  }
 Else
  {
   $h_fonte_titre = @ImageFontHeight ($taille_fonte_titre_defaut*$ech) ;
   $l_fonte_titre = @ImageFontWidth ($taille_fonte_titre_defaut*$ech) ;
   $tftt = $taille_fonte_titre_defaut*$ech ;
  }
 If ($type_graphique == 5)
  {
   If (IsSet ($taille_fonte_ordonnees_cercle))
    {
     $h_fonte_ordonnees = @ImageFontHeight ($taille_fonte_ordonnees_cercle*$ech) ;
     $l_fonte_ordonnees = @ImageFontWidth ($taille_fonte_ordonnees_cercle*$ech) ;
     $tfo = $taille_fonte_ordonnees_cercle*$ech ;
    }
   Else
    {
     $h_fonte_ordonnees = @ImageFontHeight ($taille_fonte_ordonnees_cercle_defaut*$ech) ;
     $l_fonte_ordonnees = @ImageFontWidth ($taille_fonte_ordonnees_cercle_defaut*$ech) ;
     $tfo = $taille_fonte_ordonnees_cercle_defaut*$ech ;
    }
   If (IsSet ($taille_fonte_matiere_cercle))
    {
     $h_fonte_matiere = @ImageFontHeight ($taille_fonte_matiere_cercle*$ech) ;
     $l_fonte_matiere = @ImageFontWidth ($taille_fonte_matiere_cercle*$ech) ;
     $tft = $taille_fonte_matiere_cercle*$ech ;
    }
   Else
    {
     $h_fonte_matiere = @ImageFontHeight ($taille_fonte_matiere_cercle_defaut*$ech) ;
     $l_fonte_matiere = @ImageFontWidth ($taille_fonte_matiere_cercle_defaut*$ech) ;
     $tft = $taille_fonte_matiere_cercle_defaut*$ech ;
    }
  }
 Else
  {
   If (IsSet ($taille_fonte_ordonnees))
    {
     $h_fonte_ordonnees = @ImageFontHeight ($taille_fonte_ordonnees*$ech) ;
     $l_fonte_ordonnees = @ImageFontWidth ($taille_fonte_ordonnees*$ech) ;
     $tfo = $taille_fonte_ordonnees*$ech ;
    }
   Else
    {
     $h_fonte_ordonnees = @ImageFontHeight ($taille_fonte_ordonnees_defaut*$ech) ;
     $l_fonte_ordonnees = @ImageFontWidth ($taille_fonte_ordonnees_defaut*$ech) ;
     $tfo = $taille_fonte_ordonnees_defaut*$ech ;
    }
   If (IsSet ($taille_fonte_matiere))
    {
     $h_fonte_matiere = @ImageFontHeight ($taille_fonte_matiere*$ech) ;
     $l_fonte_matiere = @ImageFontWidth ($taille_fonte_matiere*$ech) ;
     $tft = $taille_fonte_matiere*$ech ;
    }
   Else
    {
     $h_fonte_matiere = @ImageFontHeight ($taille_fonte_matiere_defaut*$ech) ;
     $l_fonte_matiere = @ImageFontWidth ($taille_fonte_matiere_defaut*$ech) ;
     $tft = $taille_fonte_matiere_defaut*$ech ;
    }
  }
 If (IsSet ($taille_fonte_legende))
  {
   $h_fonte_legende = @ImageFontHeight ($taille_fonte_legende*$ech) ;
   $l_fonte_legende = @ImageFontWidth ($taille_fonte_legende*$ech) ;
   $tfl = $taille_fonte_legende*$ech ;
  }
 ELse
  {
   $h_fonte_legende = @ImageFontHeight ($taille_fonte_legende_defaut*$ech) ;
   $l_fonte_legende = @ImageFontWidth ($taille_fonte_legende_defaut*$ech) ;
   $tfl = $taille_fonte_legende_defaut*$ech ;
  }
 
 If ($type_graphique == 5)
  {
   // Determine le nombre max de caracteres a afficher pour les matieres
   $max_f_h = 0 ;
   For ($i = 0 ; $i <= $nbr_donnees ; $i++)
    { If (StrLen ($d [$i][0]) > $max_f_h) { $max_f_h = StrLen ($d [$i][0]) ; } }
   
   // Determine la position du centre
   $larg = $lg-$mg-$md-2*$max_f_h*$l_fonte_matiere ;
   $x_0 = $mg+$max_f_h*$l_fonte_matiere+Round ($larg/2) ;
   $largeur_possible = $lg-$x_0-$md ;
   // Determine le max Horizontal
   $max_h = $nbr_donnees+1 ;
  }
 Else
  {
   // Determine la position du "0" en X
   $x_0 = StrLen ((string)$y_maximum)*$l_fonte_ordonnees+$mg+$targh+1+$tps/2 ;
   $largeur_possible = $lg-$x_0-$md ;
 
   // Determine le max Horizontal
   $max_h = $nbr_donnees+1 ;
   
   // Determine le nombre max de caracteres a afficher pour les matieres
   $max_f_h = 0 ;
   For ($i = 0 ; $i <= $nbr_donnees ; $i++)
    { If (StrLen ($d [$i][0]) > $max_f_h) { $max_f_h = StrLen ($d [$i][0]) ; } }
   //If ($largeur_possible-$max_f_h*$nbr_donnees*$l_fonte_matiere < $nbr_donnees*$l_fonte_matiere) { $nbr_lignes = 2 ; } Else { $nbr_lignes = 1 ; }
  }

 // Si aucune donnees alors image vierge 
 If ($nbr_donnees == -1)
  {
   // Remplissage du graphisme total par la couleur
   @ImageFilledRectangle ($image, 0, 0, $lg, $hg, $fond) ;
   $texte = "Aucune donne a tracer !" ;
   @ImageString ($image, $tftt, ($lg-StrLen ($texte)*$l_fonte_titre)/2, ($hg-$h_fonte_titre)/2, $texte, $couleur_tt) ;
   If ($generation == 1)
    {
     Header ("Content-type: image/png") ;
     @ImagePng ($image) ;
    }
   ElseIf ($generation == 2)
    {
     @ImagePng ($image, $nom_fichier) ;
    }
   @ImageDestroy ($image) ;
   Exit () ;
  }
 
 If ($tps/2 > $max_f_h*$l_fonte_matiere/2) { $largeur_possible -= $tps/2 ; } Else { $largeur_possible -= $max_f_h*$l_fonte_matiere/2 ; }
 If ($type_graphique == 1) { $echelle_x = $largeur_possible/($max_h*$nbr_periodes) ; }
 Else { $echelle_x = $largeur_possible/($max_h-1) ; }
 // Si la taille maximal+2 caracteres d'un nom de matiere est superieure a la largeur admissible alors 2 lignes
 If (($max_f_h+2)*$l_fonte_matiere > $nbr_periodes*$echelle_x) { $nbr_lignes = 2 ; } Else { $nbr_lignes = 1 ; }

 // Calcul la taille de la legende
 $nbr_lignes_legende = 1 ;
 $taille_int_lh [$nbr_lignes_legende] = -$eelh ;
 $nbr_titre_legende [$nbr_lignes_legende] = 0 ;
 $pr = 1 ;
 If (IsSet ($taille_car_periode_legende)) { $tclp = $taille_car_periode_legende ; } Else { $tclp = $taille_car_periode_legende_defaut ; }
 If ($compare2 == 1) { $pr = 2 ; }
 If ($compare1 == 1)
  {
   If ($type_graphique != 5)
    {
     $nl = Chr (201)."cart mini-maxi classe" ;
     $taille_int_lh [$nbr_lignes_legende] += $eelh+$echelle_x+StrLen ($nl)*$l_fonte_legende ;
     $nbr_titre_legende [$nbr_lignes_legende]++ ;
     $titres [$nbr_lignes_legende][$nbr_titre_legende [$nbr_lignes_legende]] = $nl ;
     $status_titres [$nbr_lignes_legende][$nbr_titre_legende [$nbr_lignes_legende]][0] = -1 ;
     $status_titres [$nbr_lignes_legende][$nbr_titre_legende [$nbr_lignes_legende]][1] = -1 ;
    }
   $nl = "Moyenne classe" ;
   If ($taille_int_lh [$nbr_lignes_legende]+$eelh+$echelle_x+StrLen ($nl)*$l_fonte_legende <= $largeur_graphe-$mld-$mlg)
    {
     $taille_int_lh [$nbr_lignes_legende] += $eelh+$echelle_x+StrLen ($nl)*$l_fonte_legende ;
     $nbr_titre_legende [$nbr_lignes_legende]++ ;
     $titres [$nbr_lignes_legende][$nbr_titre_legende [$nbr_lignes_legende]] = $nl ;
     $status_titres [$nbr_lignes_legende][$nbr_titre_legende [$nbr_lignes_legende]][0] = -2 ;
     $status_titres [$nbr_lignes_legende][$nbr_titre_legende [$nbr_lignes_legende]][1] = -2 ;
     }
    Else
     {
      $nbr_lignes_legende++ ;
      $taille_int_lh [$nbr_lignes_legende] = -$eelh ;
      $taille_int_lh [$nbr_lignes_legende] = $echelle_x+StrLen ($nl)*$l_fonte_legende ;
      $nbr_titre_legende [$nbr_lignes_legende] = 1 ;
      $titres [$nbr_lignes_legende][$nbr_titre_legende [$nbr_lignes_legende]] = $nl ;
      $status_titres [$nbr_lignes_legende][$nbr_titre_legende [$nbr_lignes_legende]][0] = -2 ;
      $status_titres [$nbr_lignes_legende][$nbr_titre_legende [$nbr_lignes_legende]][1] = -2 ;
     }
  }
 For ($j = 1 ; $j <= $pr ; $j++)
  {
   For ($i = 1 ; $i <= $nbr_periodes ; $i++)
    {
     If ($tclp == 0) { $t = StrLen ($nom_periode [$i]) ; } Else { $t = $tclp-1 ; }
     If ($j == 1)
      {
       If ($pr == 2)
        {
	 $nl = HTML_Entity_Decode ($nom)." ".SubStr (HTML_Entity_Decode ($prenoms), 0, 1).". ".StrToUpper (SubStr (HTML_Entity_Decode ($nom_periode [$i]), 0, 1)).SubStr (HTML_Entity_Decode ($nom_periode [$i]), 1, $t)." ".$num_periode [$i] ;
	}
       Else
        {
         $nl = StrToUpper (SubStr (HTML_Entity_Decode ($nom_periode [$i]), 0, 1)).SubStr (HTML_Entity_Decode ($nom_periode [$i]), 1, StrLen (HTML_Entity_Decode ($nom_periode [$i]))-1)." ".$num_periode [$i] ;
        }
      }
     ElseIf ($j == 2)
      {
       $nl = HTML_Entity_Decode ($comp_nom)." ".SubStr (HTML_Entity_Decode ($comp_prenoms), 0, 1).". ".StrToUpper (SubStr (HTML_Entity_Decode ($nom_periode [$i]), 0, 1)).SubStr (HTML_Entity_Decode ($nom_periode [$i]), 1, $t)." ".$num_periode [$i] ;
      }
     If ($nl != "")
      {
       If ($taille_int_lh [$nbr_lignes_legende]+$eelh+$echelle_x+StrLen ($nl)*$l_fonte_legende <= $largeur_graphe-$mld-$mlg)
        {
         $taille_int_lh [$nbr_lignes_legende] += $eelh+$echelle_x+StrLen ($nl)*$l_fonte_legende ;
         $nbr_titre_legende [$nbr_lignes_legende]++ ;
         $titres [$nbr_lignes_legende][$nbr_titre_legende [$nbr_lignes_legende]] = $nl ;
         $status_titres [$nbr_lignes_legende][$nbr_titre_legende [$nbr_lignes_legende]][0] = $j ;
         $status_titres [$nbr_lignes_legende][$nbr_titre_legende [$nbr_lignes_legende]][1] = $i ;
        }
       Else
        {
         $nbr_lignes_legende++ ;
         $taille_int_lh [$nbr_lignes_legende] = -$eelh ;
         $taille_int_lh [$nbr_lignes_legende] = $echelle_x+StrLen ($nl)*$l_fonte_legende ;
         $nbr_titre_legende [$nbr_lignes_legende] = 1 ;
         $titres [$nbr_lignes_legende][$nbr_titre_legende [$nbr_lignes_legende]] = $nl ;
         $status_titres [$nbr_lignes_legende][$nbr_titre_legende [$nbr_lignes_legende]][0] = $j ;
         $status_titres [$nbr_lignes_legende][$nbr_titre_legende [$nbr_lignes_legende]][1] = $i ;
        }
      }
    }
  }
 If ($compare1 == 1) { $pr++ ; }
 $taille_int_lh_max = $taille_int_lh [1] ;
 For ($i = 2 ; $i <= $nbr_lignes_legende ; $i++)
  {
   If ($taille_int_lh [$i] > $taille_int_lh_max) { $taille_int_lh_max = $taille_int_lh [$i] ; }
  }
 $hauteur_legende = $mlh+$nbr_lignes_legende*$h_fonte_legende+($nbr_lignes_legende-1)*$eelv+$mlb ;
 $largeur_legende = $taille_int_lh_max+$mld+$mlg ;
 
 If ($type_graphique == 5)
  {
   // Calcul de la position du "0" en Y
   If (IsSet ($marge_matiere_graphique_cercle)) { $mmg = $marge_matiere_graphique_cercle ; } Else { $mmg = $marge_matiere_graphique_cercle_defaut ; }
   $hautg = $hg-2*$mh-$mt-$mb-$hauteur_legende-($legende_3d==1)-$mlm-2.5*$h_fonte_matiere-$tps/2-2*$mmg ;
   $y_0 = $mh+$mt+$mh+1.5*$h_fonte_matiere+$mmg+$tps/2+Round ($hautg/2) ;
   If ($larg > $hautg) { $long_trait = Round ($hautg/2) ; } Else { $long_trait = Round ($larg/2) ; }
   // Calcul du dephasage
   If ($nbr_donnees > 0) { $theta = 2*M_PI/($nbr_donnees+1) ; } Else { $theta = 0 ; }
   // Echelles
   If ($y_maximum > 0) { $echelle_x = $echelle_y = $long_trait/$y_maximum ; } Else { $echelle_x = $echelle_y = 1 ; }
  }
 Else
  {
   // Calcul de la position du "0" en Y
   $y_0 = $hg-$mb-$hauteur_legende-($legende_3d==1)-$mlm-$nbr_lignes*$h_fonte_matiere-$tps/2 ;
   $hauteur_possible = $y_0-$mh-$h_fonte_titre-$mt-$tps/2 ;
   If ($y_maximum > 0) { $echelle_y = $hauteur_possible/$y_maximum ; } Else { $echelle_y = $hauteur_possible ; $y_maximum = 1 ; }
  }
 
 // Remplissage du graphisme total par la couleur
 If (IsSet ($couleur_fond_degrade)) { $fond_degrade = $couleur_fond_degrade ; } Else { $fond_degrade = $couleur_fond_degrade_defaut ; }
 If ($fond_degrade == 1)
  {
   If (IsSet ($couleur_fond)) { $fond = $couleur_fond ; } Else { $fond = $couleur_fond_defaut ; }
   If (IsSet ($couleur_fond_degrade_finale)) { $fond_final = $couleur_fond_degrade_finale ; } Else { $fond_final = $couleur_fond_degrade_finale_defaut ; }
   $coul_deb = extraction_couleur ($fond) ;
   $coul_fin = extraction_couleur ($fond_final) ;
   $ppas = 5 ;
   $compteur = 0 ;
   $delta0 = ($coul_deb [0]-$coul_fin [0])/($hg/$ppas) ;
   $delta1 = ($coul_deb [1]-$coul_fin [1])/($hg/$ppas) ;
   $delta2 = ($coul_deb [2]-$coul_fin [2])/($hg/$ppas) ;
   For ($i = 0 ; $i < $hg ; $i+=$ppas)
    {
     $cfdg [$i] = @ImageColorAllocate ($image, Round ($coul_fin [0]+$delta0*$compteur), Round ($coul_fin [1]+$delta1*$compteur), Round ($coul_fin [2]+$delta2*$compteur)) ;
     @ImageFilledRectangle ($image, 0, $i, $lg, $i+$ppas-1, $cfdg [$i]) ;
     $compteur++ ;
    }
  }
 Else { @ImageFilledRectangle ($image, 0, 0, $lg, $hg, $fond) ; }
 
 // Remplissage du graphe par la couleur
 @ImageFilledRectangle ($image, $x_0, $y_0-$hauteur_possible, $x_0+$largeur_possible, $y_0, $fond_graphe) ;
 
 // Calcul du pas
 If (!IsSet ($pas) Or ($pas == 0))
  {
   If ($echelle_y > $h_fonte_ordonnees/2) { $pas = 1 ; }
   Else
    {
     For ($i = 5 ; $i <= $y_maximum ; $i += 5)
      {
       If ($echelle_y*$i > $h_fonte_ordonnees/2) { $pas = $i ; Break ; }
      }
    }
  }
 
 // Calcul du modulo d'affichage des ordonnees et tracee
 If ($echelle_y > 3*$h_fonte_ordonnees/2) { $modulo_ordonnee = 1 ; $modulo = 5 ; }
 Else
  {
   For ($i = $pas ; $i <= $y_maximum ; $i += $pas)
    {
     If ($echelle_y*$i > 3*$h_fonte_ordonnees/2) { $modulo = $i*2 ; $modulo_ordonnee = $i ; Break ; }
    }
  }
 
 If ($type_graphique == 5)
  {
   // Remplissage avec la couleur de fond
   If (IsSet ($couleur_degrade)) { $degrade = $couleur_degrade ; } Else { $degrade = $couleur_degrade_defaut ; }
   If (IsSet ($couleur_fond_vert)) { $cv = extraction_couleur ($couleur_fond_vert) ; } Else { $cv = extraction_couleur ($couleur_fond_vert_defaut) ; }
   If (IsSet ($couleur_fond_orange)) { $co = extraction_couleur ($couleur_fond_orange) ; } Else { $co = extraction_couleur ($couleur_fond_orange_defaut) ; }
   If (IsSet ($couleur_fond_rouge)) { $cr = extraction_couleur ($couleur_fond_rouge) ; } Else { $cr = extraction_couleur ($couleur_fond_rouge_defaut) ; }
   If (IsSet ($couleur_fond_rouge_final)) { $crf = extraction_couleur ($couleur_fond_rouge_final) ; } Else { $crf = extraction_couleur ($couleur_fond_rouge_final_defaut) ; }
   If ($degrade == 1)
    {
     // Vert
     $compteur1 = 0 ;
     $compteur2 = 0 ;
     $ppas = 2 ;
     $delta0 = ($cv [0]-$co [0])/(0.4*$y_maximum*$ppas) ;
     $delta1 = ($cv [1]-$co [1])/(0.4*$y_maximum*$ppas) ;
     $delta2 = ($cv [2]-$co [2])/(0.4*$y_maximum*$ppas) ;
     For ($i = $y_maximum ; $i > 0.6*$y_maximum ; $i-=1/$ppas)
      {
       $fd [$compteur1] = @ImageColorAllocate ($image, Round ($cv [0]-$delta0*$compteur2), Round ($cv [1]-$delta1*$compteur2), Round ($cv [2]-$delta2*$compteur2)) ;
       @ImageFilledEllipse ($image, $x_0, $y_0, 2*$i*$echelle_x, 2*$i*$echelle_y, $fd [$compteur1]) ;
       $compteur1++ ;
       $compteur2++ ;
      }
     // Orange
     $compteur2 = 0 ;
     $delta0 = ($co [0]-$cr [0])/(0.2*$y_maximum*$ppas) ;
     $delta1 = ($co [1]-$cr [1])/(0.2*$y_maximum*$ppas) ;
     $delta2 = ($co [2]-$cr [2])/(0.2*$y_maximum*$ppas) ;
     For ($i = 0.6*$y_maximum ; $i > 0.4*$y_maximum ; $i-=1/$ppas)
      {
       $fd [$compteur1] = @ImageColorAllocate ($image, Round ($co [0]-$delta0*$compteur2), Round ($co [1]-$delta1*$compteur2), Round ($co [2]-$delta2*$compteur2)) ;
       @ImageFilledEllipse ($image, $x_0, $y_0, 2*$i*$echelle_x, 2*$i*$echelle_y, $fd [$compteur1]) ;
       $compteur1++ ;
       $compteur2++ ;
      }
     // Rouge
     $compteur2 = 0 ;
     $delta0 = ($cr [0]-$crf [0])/(0.4*$y_maximum*$ppas) ;
     $delta1 = ($cr [1]-$crf [1])/(0.4*$y_maximum*$ppas) ;
     $delta2 = ($cr [2]-$crf [2])/(0.4*$y_maximum*$ppas) ;
     For ($i = 0.4*$y_maximum ; $i > 0 ; $i-=1/$ppas)
      {
       $fd [$compteur1] = @ImageColorAllocate ($image, Round ($cr [0]-$delta0*$compteur2), Round ($cr [1]-$delta1*$compteur2), Round ($cr [2]-$delta2*$compteur2)) ;
       @ImageFilledEllipse ($image, $x_0, $y_0, 2*$i*$echelle_x, 2*$i*$echelle_y, $fd [$compteur1]) ;
       $compteur1++ ;
       $compteur2++ ;
      }
    }
   Else
    {
     $fd [0] = @ImageColorAllocate ($image, $cv [0], $cv [1], $cv [2]) ;
     @ImageFilledEllipse ($image, $x_0, $y_0, 2*$y_maximum*$echelle_x, 2*$y_maximum*$echelle_y, $fd [0]) ;
     $fd [1] = @ImageColorAllocate ($image, $co [0], $co [1], $co [2]) ;
     @ImageFilledEllipse ($image, $x_0, $y_0, 1.2*$y_maximum*$echelle_x, 1.2*$y_maximum*$echelle_y, $fd [1]) ;
     $fd [2] = @ImageColorAllocate ($image, $cr [0], $cr [1], $cr [2]) ;
     @ImageFilledEllipse ($image, $x_0, $y_0, 0.8*$y_maximum*$echelle_x, 0.8*$y_maximum*$echelle_y, $fd [2]) ;
    } 
   // Trace des axes et des matieres
   @ImageSetThickNess ($image, 1) ;
   For ($i = 0 ; $i <= $nbr_donnees ; $i++)
    {
     $angle = M_PI/2+$theta*$i ;
     @ImageLine ($image, $x_0, $y_0, Round ($x_0+$long_trait*cos ($angle)), Round ($y_0-$long_trait*sin ($angle)), $axes) ;
     If ($angle == M_PI/2) { $x_m = $x_0-StrLen ($d [$i][0])/2*$l_fonte_matiere ; $y_m = $y_0-$long_trait-$h_fonte_matiere-$mmg-$h_fonte_ordonnees/2 ; }
     ElseIf ($angle == M_PI) { $x_m = $x_0-$long_trait-StrLen ($d [$i][0])*$l_fonte_matiere-$mmg ; $y_m = $y_0-$h_fonte_matiere/2 ; }
     ElseIf ($angle == 3*M_PI/2) { $x_m = $x_0-StrLen ($d [$i][0])/2*$l_fonte_matiere ; $y_m = $y_0+$long_trait+$mmg ; }
     ElseIf ($angle == 2*M_PI) { $x_m = $x_0+$long_trait+$mmg ; $y_m = $y_0-$h_fonte_matiere/2 ; }
     ElseIf (($angle > M_PI/2) And ($angle < M_PI)) { $x_m = $x_0+$long_trait*cos ($angle)-$mmg-StrLen ($d [$i][0])*$l_fonte_matiere ; $y_m = $y_0-$long_trait*sin ($angle)-$h_fonte_matiere ; }
     ElseIf (($angle > M_PI) And ($angle < 3*M_PI/2)) { $x_m = $x_0+$long_trait*cos ($angle)-$mmg-StrLen ($d [$i][0])*$l_fonte_matiere ; $y_m = $y_0-$long_trait*sin ($angle) ; }
     ElseIf ($angle > 2*M_PI) { $x_m = $x_0+$long_trait*cos ($angle)+$mmg ; $y_m = $y_0-$long_trait*sin ($angle)-$h_fonte_matiere ; }
     Else { $x_m = $x_0+$long_trait*cos ($angle)+$mmg ; $y_m = $y_0-$long_trait*sin ($angle) ; }
     @ImageString ($image, $tft, $x_m, $y_m, $d [$i][0], $axes) ;
    }
   // Trace de la ligne moyenne
   @ImageSetStyle ($image, $axe_moyen) ;
   @ImageSetThickNess ($image, 1) ;
   @ImageEllipse ($image, $x_0, $y_0, $y_maximum*$echelle_x, $y_maximum*$echelle_x, $trait_moyenne) ;
   // Trace des indics
   If ($ind_40 == 1)
    {
     @ImageSetStyle ($image, $axe_indic_40) ;
     @ImageSetThickNess ($image, 1) ;
     @ImageEllipse ($image, $x_0, $y_0, 0.8*$y_maximum*$echelle_x, 0.8*$y_maximum*$echelle_x, $trait_indic_40) ;
    }
   If ($ind_60 == 1)
    {
     @ImageSetStyle ($image, $axe_indic_60) ;
     @ImageSetThickNess ($image, 1) ;
     @ImageEllipse ($image, $x_0, $y_0, 1.2*$y_maximum*$echelle_x, 1.2*$y_maximum*$echelle_x, $trait_indic_60) ;
    }
   // Trace des reperes verticaux + Affichage des reperes sur les ordonnees
   If (IsSet ($couleur_trait_repere_cercle)) { $c = extraction_couleur ($couleur_trait_repere_cercle) ; }
   Else { $c = extraction_couleur ($couleur_trait_repere_cercle_defaut) ; }
   $tgv = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
   @ImageSetThickNess ($image, 1) ;
   For ($i = 0 ; $i <= $y_maximum ; $i++)
    {
     If ($i%$modulo_ordonnee == 0)
      {
       @ImageLine ($image, $x_0-$mmg, $y_0-$i*$echelle_y, $x_0+$mmg, $y_0-$i*$echelle_y, $tgv) ;
       @ImageString ($image, $tfo, $x_0+$mmg+1, $y_0-$i*$echelle_y-$h_fonte_ordonnees/2, $i, $couleur_tt) ;
      }
    }
  }

 // Comparaison classe
 // Coefficient de decalage a partir de la droite pour distinguer les differentes courbes
 Switch ($nbr_periodes)
  {
    Case 1 : $coeff_eb = 1.2 ; Break ; // $coeff_eb = 10/(4*$nbr_periodes) ;
    Case 2 : $coeff_eb = 1 ; Break ;
    Case 3 : $coeff_eb = 1 ; Break ;
   Default : $coeff_eb = 1 ; Break ;
  }
 If ($compare1 == 1)
  {
   If (IsSet ($couleur_comparaison_classe_fond)) { $c = extraction_couleur ($couleur_comparaison_classe_fond) ; }
   Else { $c = extraction_couleur ($couleur_comparaison_classe_fond_defaut) ; }
   $c1 = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
   If (IsSet ($couleur_comparaison_classe_contour)) { $c = extraction_couleur ($couleur_comparaison_classe_contour) ; }
   Else { $c = extraction_couleur ($couleur_comparaison_classe_contour_defaut) ; }
   $c2 = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
   If (IsSet ($couleur_comparaison_classe_moyenne)) { $c = extraction_couleur ($couleur_comparaison_classe_moyenne) ; }
   Else { $c = extraction_couleur ($couleur_comparaison_classe_moyenne_defaut) ; }
   $c3 = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
   If (IsSet ($couleur_comparaison_classe_moyenne_contour)) { $c = extraction_couleur ($couleur_comparaison_classe_moyenne_contour) ; }
   Else { $c = extraction_couleur ($couleur_comparaison_classe_moyenne_contour_defaut) ; }
   $c4 = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
   $style_classe = Array ($c2,$c2,$c2,$c2,$c2,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente) ;
   If (IsSet ($decalage_barre_compare)) { $db = $decalage_barre_compare*$ech ; } Else { $db = $decalage_barre_compare_defaut*$ech ; }
   If (IsSet ($espace_entre_barre)) { $eb = $espace_entre_barre*$ech ; } Else { $eb = $espace_entre_barre_defaut*$ech ; }
   $nbr_points = 0 ;
   If ($type_graphique != 1) { $coeff = 1 ; } Else { $coeff = $nbr_periodes ; }
   For ($prc = 0 ; $prc <= $nbr_donnees ; $prc++)
    {
     $moy = 0 ; $nbr_moy = 0 ;
     If ($compare0 == 1)
      {
       $moy = 0 ;
       For ($periode = 1 ; $periode <= $nbr_periodes ; $periode++)
        {
         If (Is_Numeric ($cc [$prc][$periode][0])) { $moy += $cc [$prc][$periode][0] ; $nbr_moy++ ; }
         If ($periode == 1) { $min = $max = $cc [$prc][$periode][1] ; }
         Else
          {
           If (Is_Numeric ($cc [$prc][$periode][1]) And ($cc [$prc][$periode][1] < $min)) { $min = $cc [$prc][$periode][1] ; }
           If (Is_Numeric ($cc [$prc][$periode][2]) And ($cc [$prc][$periode][2] > $max)) { $max = $cc [$prc][$periode][2] ; }
          }
	}
       //$moyenne [$prc] = ($max+$min)/2 ;
       If ($nbr_moy > 0) { $moyenne [$prc] = $moy/$nbr_moy ; } Else { $moyenne [$prc] = 0 ; }
      }
     Else
      {
       $moyenne [$prc] = $cc [$prc][1][0] ;
       $min = $cc [$prc][1][1] ;
       $max = $cc [$prc][1][2] ;
      }
     If ($prc == 0) { $coord_points [$nbr_points] = $x_0+1+$prc*$echelle_x*$coeff ; }
     Else { $coord_points [$nbr_points] = $x_0+$prc*$echelle_x*$coeff ; }
     $coord_points [$nbr_points+1] = $y_0+1-$max*$echelle_y ;
     $nbr_points += 2 ;
     $coord_points [4*($nbr_donnees+1)-$nbr_points] = $x_0+($prc==0)+$prc*$echelle_x*$coeff ;
     $coord_points [4*($nbr_donnees+1)-$nbr_points+1] = $y_0+1-$min*$echelle_y ;
    }
   If ($type_graphique == 5)
    {
     $i = 0 ;
     While ((!Is_Numeric ($moyenne [$i])) And ($i <= $nbr_donnees))
      {
       $i++ ;
      }
     $pp = $i ;
     $x_old = $pp ;
     $y_old = $moyenne [$i] ;
     @ImageSetThickNess ($image, 2.5*$ech) ;
     For ($i = $pp+1 ; $i <= $nbr_donnees ; $i++)
      {
       If (Is_Numeric ($moyenne [$i]) And ($moyenne [$i] > 0))
        {
         @ImageLine ($image, $x_0+$y_old*$echelle_x*cos (M_PI/2+$theta*($i-1)), $y_0-$y_old*$echelle_y*sin (M_PI/2+$theta*($i-1)),
	                     $x_0+$moyenne [$i]*$echelle_x*cos (M_PI/2+$theta*$i), $y_0-$moyenne [$i]*$echelle_y*sin (M_PI/2+$theta*$i), $c3) ;
         $x_old = $i ;
         $y_old = $moyenne [$i] ;
        }
      }
     // Liaison premier point et dernier point
     @ImageLine ($image, $x_0+$y_old*$echelle_x*cos (M_PI/2+$theta*($i-1)), $y_0-$y_old*$echelle_y*sin (M_PI/2+$theta*($i-1)),
		         $x_0+$moyenne [$pp]*$echelle_x*cos (M_PI/2+$theta*$pp), $y_0-$moyenne [$pp]*$echelle_y*sin (M_PI/2+$theta*$pp), $c3) ;
    }
   ElseIf ($type_graphique != 1)
    {
     @ImageSetThickNess ($image, $ech) ;
     @ImageFilledPolygon ($image, $coord_points, $nbr_points, $c1) ;
     @ImageSetStyle ($image, $style_classe) ;
     @ImagePolygon ($image, $coord_points, $nbr_points, IMG_COLOR_STYLED) ;
     @ImageSetThickNess ($image, 2*$ech) ;
     For ($i = 1 ; $i <= $nbr_donnees ; $i++)
      {
       If (Is_Numeric ($moyenne [$i]) And Is_Numeric ($moyenne [$i-1]) And (($moyenne [$i-1] > 0) Or ($moyenne [$i] > 0)))
        {
         @ImageLine ($image, $x_0+($i-1)*$echelle_x, $y_0+1-$moyenne [$i-1]*$echelle_y, $x_0+$i*$echelle_x, $y_0+1-$moyenne [$i]*$echelle_y, $c3) ;
        }
      }
     @ImageSetThickNess ($image, $ech) ;
     @ImageLine ($image, $coord_points [0], $coord_points [1], $coord_points [4*($nbr_donnees+1)-2], $coord_points [4*($nbr_donnees+1)-1], $fond_graphe) ;
     @ImageLine ($image, $coord_points [2*$nbr_donnees], $coord_points [2*$nbr_donnees+1], $coord_points [2*$nbr_donnees+2], $coord_points [2*$nbr_donnees+3], $fond_graphe) ;
    }
   Else
    {
     For ($i = 0 ; $i < $nbr_points/2 ; $i++)
      {
       @ImageFilledRectangle ($image, $coord_points [2*$i]+$db, $coord_points [2*$i+1], $coord_points [2*$i]+$echelle_x*$nbr_periodes+$db-$eb, $coord_points [2*$nbr_points-2*$i-1], $c1) ;
       @ImageSetStyle ($image, $style_classe) ;
       @ImageRectangle ($image, $coord_points [2*$i]+$db, $coord_points [2*$i+1], $coord_points [2*$i]+$echelle_x*$nbr_periodes+$db-$eb, $coord_points [2*$nbr_points-2*$i-1], IMG_COLOR_STYLED) ;
      }
     /*
     For ($i = 0 ; $i <= $nbr_donnees ; $i++)
      {
       If (Is_Numeric ($moyenne [$i]) And ($moyenne [$i] > 0))
        {
         @ImageFilledRectangle ($image, $x_0+$i*$echelle_x*$nbr_periodes+$echelle_x*$nbr_periodes/4+$db, $y_0+1-($moyenne [$i]-0.25)*$echelle_y, $x_0+$i*$echelle_x*$nbr_periodes+3*$echelle_x*$nbr_periodes/4+$db, $y_0+1-($moyenne [$i]+0.25)*$echelle_y, $c3) ;
         @ImageRectangle ($image, $x_0+$i*$echelle_x*$nbr_periodes+$echelle_x*$nbr_periodes/4+$db, $y_0+1-($moyenne [$i]-0.25)*$echelle_y, $x_0+$i*$echelle_x*$nbr_periodes+3*$echelle_x*$nbr_periodes/4+$db, $y_0+1-($moyenne [$i]+0.25)*$echelle_y, $c4) ;
        }
      }
     */
    }
  }

 // Comparaison periode et eleve
 //If (($compare1 == 1) Or ($compare2 == 1))
 If ($compare2 == 1)
  {
   For ($periode = 1 ; $periode <= $nbr_periodes ; $periode++)
    {
     Switch ($type_graphique)
      {
       Case 1 : // Tracee de rectangles
                @ImageSetThickNess ($image, 1) ;
	        If (IsSet ($couleur_barre_compare [$periode])) { $c = extraction_couleur ($couleur_barre_compare [$periode]) ; }
	        Else { $c = extraction_couleur ($couleur_barre_compare_defaut [$periode]) ; }
                $barre_c [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
	        If (IsSet ($couleur_contour_barre_compare [$periode])) { $c = extraction_couleur ($couleur_contour_barre_compare [$periode]) ; }
		Else { $c = extraction_couleur ($couleur_contour_barre_compare_defaut [$periode]) ; }
                $contour_barre_c [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
		If (IsSet ($couleur_barre_compare_point [$periode])) { $c = extraction_couleur ($couleur_barre_compare_point [$periode]) ; }
		Else { $c = extraction_couleur ($couleur_barre_compare_point_defaut [$periode]) ; }
                $contour_barre_point_c [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
	        If (IsSet ($espace_entre_barre)) { $eb = $espace_entre_barre*$ech ; } Else { $eb = $espace_entre_barre_defaut*$ech ; }
		If (IsSet ($decalage_barre_compare)) { $db = $decalage_barre_compare*$ech ; } Else { $db = $decalage_barre_compare_defaut*$ech ; }
		If (IsSet ($couleur_barre_compare_degrade)) { $barre_compare_degrade = $couleur_barre_compare_degrade [$periode] ; } Else { $barre_compare_degrade = $couleur_barre_compare_degrade_defaut [$periode] ; }
	        If ($barre_compare_degrade == 1)
                 {
                  If (IsSet ($couleur_barre_compare)) { $cbr = $couleur_barre_compare [$periode] ; } Else { $cbr = $couleur_barre_compare_defaut [$periode] ; }
                  If (IsSet ($couleur_barre_compare_degrade_finale)) { $cbrf = $couleur_barre_compare_degrade_finale [$periode] ; } Else { $cbrf = $couleur_barre_compare_degrade_finale_defaut [$periode] ; }
                  $coul_deb = extraction_couleur ($cbr) ;
                  $coul_fin = extraction_couleur ($cbrf) ;
                  $ppas = 4-$nbr_periodes ;
                  $delta0 = ($coul_deb [0]-$coul_fin [0])/(($echelle_x+$eb*(-$coeff_eb-1))/$ppas) ;
                  $delta1 = ($coul_deb [1]-$coul_fin [1])/(($echelle_x+$eb*(-$coeff_eb-1))/$ppas) ;
                  $delta2 = ($coul_deb [2]-$coul_fin [2])/(($echelle_x+$eb*(-$coeff_eb-1))/$ppas) ;
	         }
                For ($i = 0 ; $i <= $nbr_donnees ; $i++)
                 {
	          If ($i == 0)
	           {
		    If (Is_Numeric ($cp [$i][$periode]) And ($cp [$i][$periode] > 0))
		     {
		      If ($barre_compare_degrade == 1)
                       {
		        $compteur = 0 ;
		        For ($j = $x_0+$db+($periode-1)*$echelle_x+1 ; $j < $x_0+$db-$eb*$coeff_eb+$periode*$echelle_x-1 ; $j+= $ppas)
		         {
		          $cbdgc [$periode][$j] = @ImageColorAllocate ($image, Round ($coul_deb [0]-$delta0*$compteur), Round ($coul_deb [1]-$delta1*$compteur), Round ($coul_deb [2]-$delta2*$compteur)) ;
		          @ImageFilledRectangle ($image, $j, $y_0-$cp [$i][$periode]*$echelle_y, $j+$ppas, $y_0, $cbdgc [$periode][$j]) ;
			  $compteur++ ;
		         }
		       }
		      Else { @ImageFilledRectangle ($image, $x_0+$db+($periode-1)*$echelle_x, $y_0-$cp [$i][$periode]*$echelle_y, $x_0+$db-$eb*$coeff_eb+$periode*$echelle_x, $y_0, $barre_c [$periode]) ; }
	              @ImageRectangle ($image, $x_0+$db+($periode-1)*$echelle_x, $y_0-$cp [$i][$periode]*$echelle_y, $x_0+$db-$eb*$coeff_eb+$periode*$echelle_x, $y_0, $contour_barre_c [$periode]) ;
		      For ($j = $y_0-$cp [$i][$periode]*$echelle_y+1 ; $j < $y_0-1 ; $j++)
		       {
		        For ($k = 0 ; $k < Rand (1, 3) ; $k++)
		        {
		         @ImageSetPixel ($image, $x_0+1+$db+$eb+($periode-1)*$echelle_x+Rand (0, $echelle_x-$eb*$coeff_eb-4), $j, $contour_barre_point_c [$periode]) ;
		        }
		       }
		     } 
	           }
	          ElseIf ($i <= $nbr_donnees)
	           {
		    If (Is_Numeric ($cp [$i][$periode]) And ($cp [$i][$periode] > 0))
		     {
		      If ($barre_compare_degrade == 1)
                       {
		        $compteur = 0 ;
		        For ($j = $x_0+$db+($i*$nbr_periodes+$periode-1)*$echelle_x+1 ; $j < $x_0+$db-$eb*$coeff_eb+($i*$nbr_periodes+$periode)*$echelle_x-1 ; $j+= $ppas)
		         {
		          $cbdgc [$periode][$j] = @ImageColorAllocate ($image, Round ($coul_deb [0]-$delta0*$compteur), Round ($coul_deb [1]-$delta1*$compteur), Round ($coul_deb [2]-$delta2*$compteur)) ;
		          @ImageFilledRectangle ($image, $j, $y_0-$cp [$i][$periode]*$echelle_y, $j+$ppas, $y_0, $cbdgc [$periode][$j]) ;
			  $compteur++ ;
		         }
		       }
		      Else { @ImageFilledRectangle ($image, $x_0+$db+($i*$nbr_periodes+$periode-1)*$echelle_x, $y_0-$cp [$i][$periode]*$echelle_y, $x_0+$db-$eb*$coeff_eb+($i*$nbr_periodes+$periode)*$echelle_x, $y_0, $barre_c [$periode]) ; }
	              @ImageRectangle ($image, $x_0+$db+($i*$nbr_periodes+$periode-1)*$echelle_x, $y_0-$cp [$i][$periode]*$echelle_y, $x_0+$db-$eb*$coeff_eb+($i*$nbr_periodes+$periode)*$echelle_x, $y_0, $contour_barre_c [$periode]) ;
		      For ($j = $y_0-$cp [$i][$periode]*$echelle_y+1 ; $j < $y_0-1 ; $j++)
		       {
		        For ($k = 0 ; $k < Rand (1, 3) ; $k++)
		         {
		          @ImageSetPixel ($image, $x_0+1+$db+$eb+($i*$nbr_periodes+$periode-1)*$echelle_x+Rand (0, $echelle_x-$eb*$coeff_eb-4), $j, $contour_barre_point_c [$periode]) ;
			 }
		       }
		     }
	           }
	          Else
	           {
		    If (Is_Numeric ($cp [$i][$periode]) And ($cp [$i][$periode] > 0))
		     {
		      If ($barre_compare_degrade == 1)
                       {
		        $compteur = 0 ;
		        For ($j = $x_0+$db+($i*$nbr_periodes+$periode-1)*$echelle_x+1 ; $j < $x_0+$db+($i*$nbr_periodes+$periode)*$echelle_x-1 ; $j+= $ppas)
		         {
		          $cbdgc [$periode][$j] = @ImageColorAllocate ($image, Round ($coul_deb [0]-$delta0*$compteur), Round ($coul_deb [1]-$delta1*$compteur), Round ($coul_deb [2]-$delta2*$compteur)) ;
		          @ImageFilledRectangle ($image, $j, $y_0-$cp [$i][$periode]*$echelle_y, $j+$ppas, $y_0, $cbdgc [$periode][$j]) ;
			  $compteur++ ;
		         }
		       }
		      Else { @ImageFilledRectangle ($image, $x_0+$db+($i*$nbr_periodes+$periode-1)*$echelle_x, $y_0-$cp [$i][$periode]*$echelle_y, $x_0+$db+($i*$nbr_periodes+$periode)*$echelle_x, $y_0, $barre_c [$periode]) ; }
	              @ImageRectangle ($image, $x_0+$db+($i*$nbr_periodes+$periode-1)*$echelle_x, $y_0-$cp [$i][$periode]*$echelle_y, $x_0+$db+($i*$nbr_periodes+$periode)*$echelle_x, $y_0, $contour_barre_c [$periode]) ;
		      For ($j = $y_0-$cp [$i][$periode]*$echelle_y+1 ; $j < $y_0-1 ; $j++)
		       {
		        For ($k = 0 ; $k < Rand (1, 3) ; $k++)
		         {
		          @ImageSetPixel ($image, $x_0+1+$db+$eb+($i*$nbr_periodes+$periode-1)*$echelle_x+Rand (0, $echelle_x-$eb*$coeff_eb-4), $j, $contour_barre_point_c [$periode]) ;
			 }
		       }
		     }
	           }
                 }
	        Break ;
       Case 2 : // Tracee des lignes avec points
	        If (IsSet ($couleur_ligne_compare [$periode])) { $c = extraction_couleur ($couleur_ligne_compare [$periode]) ; }
		Else { $c = extraction_couleur ($couleur_ligne_compare_defaut [$periode]) ; }
                $tc [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
		$style_comp [$periode] = Array ($tc [$periode], $tc [$periode], $tc [$periode], $tc [$periode], $tc [$periode], $tc [$periode], $tc [$periode], $tc [$periode],
		                                $couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente) ;
		@imageSetStyle ($image, $style_comp [$periode]) ;
                @ImageSetThickNess ($image, 3*$ech) ;
		$i = 0 ;
		While ((!Is_Numeric ($cp [$i][$periode])) And ($i <= $nbr_donnees))
		 {
		  $i++ ;
		 }
		$pp = $i ;
		$x_old = $pp ;
		$y_old = $cp [$pp][$periode] ;
                For ($i = $pp+1 ; $i <= $nbr_donnees ; $i++)
                 {
		  If (Is_Numeric ($cp [$i][$periode]) And ($cp [$i][$periode] > 0))
	  	   {
                    @ImageLine ($image, $x_0+$x_old*$echelle_x, $y_0+1-$y_old*$echelle_y, $x_0+$i*$echelle_x, $y_0+1-$cp [$i][$periode]*$echelle_y, IMG_COLOR_STYLED) ;
		    $x_old = $i ;
		    $y_old = $cp [$i][$periode] ;
		   }
                 }
                // Tracee des points
	        If (IsSet ($couleur_point_compare [$periode])) { $c = extraction_couleur ($couleur_point_compare [$periode]) ; }
		Else { $c = extraction_couleur ($couleur_point_compare_defaut [$periode]) ; }
                $point_int_compare [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
	        If (IsSet ($taille_point_compare [$periode])) { $tpc [$periode] = $taille_point_compare [$periode]*$ech ; } Else { $tpc [$periode] = $taille_point_compare_defaut [$periode]*$ech ; }
	        If (IsSet ($forme_point_compare [$periode])) { $fpc [$periode] = $forme_point_compare [$periode]*$ech ; } Else { $fpc [$periode] = $forme_point_compare_defaut [$periode]*$ech ; }
                // Tracee de l'exterieur des points
	        If (IsSet ($couleur_contour_point_compare [$periode])) { $c = extraction_couleur ($couleur_contour_point_compare [$periode]) ; }
		Else { $c = extraction_couleur ($couleur_contour_point_compare_defaut [$periode]) ; }
                $contour_point_compare [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
                For ($i = 0 ; $i <= $nbr_donnees ; $i++)
                 {
		  If (Is_Numeric ($cp [$i][$periode]))
		   {
	            point ($fpc [$periode], $x_0+$i*$echelle_x, $y_0+1-$cp [$i][$periode]*$echelle_y, $tpc [$periode], $contour_point_compare [$periode], 2*$ech, 0) ;
		   }
                 }
	        Break ;
       Case 3 : // Tracee des lignes
                If (IsSet ($couleur_ligne_compare [$periode])) { $c = extraction_couleur ($couleur_ligne_compare [$periode]) ; }
		Else { $c = extraction_couleur ($couleur_ligne_compare_defaut [$periode]) ; }
                $tc [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
		$style = Array ($tc [$periode], $tc [$periode], $tc [$periode], $tc [$periode], $tc [$periode], $tc [$periode], $tc [$periode], $tc [$periode],
		                $couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente) ;
		@imageSetStyle ($image, $style) ;
                @ImageSetThickNess ($image, 3*$ech) ;
		$i = 0 ;
		While ((!Is_Numeric ($cp [$i][$periode])) And ($i <= $nbr_donnees))
		 {
		  $i++ ;
		 }
		$pp = $i ;
		$x_old = $pp ;
		$y_old = $cp [$pp][$periode] ;
                For ($i = $pp+1 ; $i <= $nbr_donnees ; $i++)
                 {
		  If (Is_Numeric ($cp [$i][$periode]) And ($cp [$i][$periode] > 0))
	  	   {
                    @ImageLine ($image, $x_0+$x_old*$echelle_x, $y_0+1-$y_old*$echelle_y, $x_0+$i*$echelle_x, $y_0+1-$cp [$i][$periode]*$echelle_y, IMG_COLOR_STYLED) ;
		    $x_old = $i ;
		    $y_old = $cp [$i][$periode] ;
		   }
                 }
	        Break ;
       Case 4 : // Tracee des points
                If (IsSet ($couleur_point_compare [$periode])) { $c = extraction_couleur ($couleur_point_compare [$periode]) ; }
		Else { $c = extraction_couleur ($couleur_point_compare_defaut [$periode]) ; }
                $point_int_compare [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
	        If (IsSet ($taille_point_compare [$periode])) { $tpc [$periode] = $taille_point_compare [$periode]*$ech ; } Else { $tpc [$periode] = $taille_point_compare_defaut [$periode]*$ech ; }
	        If (IsSet ($forme_point_compare [$periode])) { $fpc [$periode] = $forme_point_compare [$periode]*$ech ; } Else { $fpc [$periode] = $forme_point_compare_defaut [$periode]*$ech ; }
                // Tracee de l'exterieur des points
	        If (IsSet ($couleur_contour_point_compare [$periode])) { $c = extraction_couleur ($couleur_contour_point_compare [$periode]) ; }
		Else { $c = extraction_couleur ($couleur_contour_point_compare_defaut [$periode]) ; }
                $contour_point_compare [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
                For ($i = 0 ; $i <= $nbr_donnees ; $i++)
                 {
		  If (Is_Numeric ($cp [$i][$periode]))
		   {
	            point ($fpc [$periode], $x_0+$i*$echelle_x, $y_0+1-$cp [$i][$periode]*$echelle_y, $tpc [$periode], $contour_point_compare [$periode], 2*$ech, 0) ;
		   }
                 }
	        Break ;
       Case 5 : // Trace d'un cercle
	        If (IsSet ($couleur_cercle_compare [$periode])) { $c = extraction_couleur ($couleur_cercle_compare [$periode]) ; }
		Else { $c = extraction_couleur ($couleur_cercle_compare_defaut [$periode]) ; }
                $tc [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
		$style_comp [$periode] = Array ($tc [$periode], $tc [$periode], $tc [$periode], $tc [$periode], $tc [$periode], $tc [$periode], $tc [$periode], $tc [$periode],
		                                $couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente) ;
		@imageSetStyle ($image, $style_comp [$periode]) ;
                @ImageSetThickNess ($image, 2.5*$ech) ;
		$i = 0 ;
		While ((!Is_Numeric ($cp [$i][$periode])) And ($i <= $nbr_donnees))
		 {
		  $i++ ;
		 }
		$pp = $i ;
		$x_old = $pp ;
		$y_old = $cp [$pp][$periode] ;
                For ($i = $pp+1 ; $i <= $nbr_donnees ; $i++)
                 {
		  If (Is_Numeric ($cp [$i][$periode]) And ($cp [$i][$periode] > 0))
	  	   {
		    @ImageLine ($image, $x_0+$y_old*$echelle_x*cos (M_PI/2+$theta*($i-1)), $y_0-$y_old*$echelle_y*sin (M_PI/2+$theta*($i-1)),
		                      $x_0+$cp [$i][$periode]*$echelle_x*cos (M_PI/2+$theta*$i), $y_0-$cp [$i][$periode]*$echelle_y*sin (M_PI/2+$theta*$i), IMG_COLOR_STYLED) ;
		    $x_old = $i ;
		    $y_old = $cp [$i][$periode] ;
		   }
                 }
		// Liaison premier point et dernier point
	        @ImageLine ($image, $x_0+$y_old*$echelle_x*cos (M_PI/2+$theta*($i-1)), $y_0-$y_old*$echelle_y*sin (M_PI/2+$theta*($i-1)),
		                    $x_0+$cp [$pp][$periode]*$echelle_x*cos (M_PI/2+$theta*$pp), $y_0-$cp [$pp][$periode]*$echelle_y*sin (M_PI/2+$theta*$pp), IMG_COLOR_STYLED) ;
                // Tracee des points
	        If (IsSet ($couleur_point_compare_cercle [$periode])) { $c = extraction_couleur ($couleur_point_compare_cercle [$periode]) ; }
		Else { $c = extraction_couleur ($couleur_point_compare_cercle_defaut [$periode]) ; }
                $point_int_compare [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
	        If (IsSet ($taille_point_compare_cercle [$periode])) { $tpc [$periode] = $taille_point_compare_cercle [$periode]*$ech ; }
		Else { $tpc [$periode] = $taille_point_compare_cercle_defaut [$periode]*$ech ; }
	        If (IsSet ($forme_point_compare_cercle [$periode])) { $fpc [$periode] = $forme_point_compare_cercle [$periode]*$ech ; }
		Else { $fpc [$periode] = $forme_point_compare_cercle_defaut [$periode]*$ech ; }
                // Tracee de l'exterieur des points
	        If (IsSet ($couleur_contour_point_compare_cercle [$periode])) { $c = extraction_couleur ($couleur_contour_point_cercle_compare [$periode]) ; }
		Else { $c = extraction_couleur ($couleur_contour_point_compare_cercle_defaut [$periode]) ; }
                $contour_point_compare [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
                For ($i = 0 ; $i <= $nbr_donnees ; $i++)
                 {
		  If (Is_Numeric ($cp [$i][$periode]))
		   {
		    point ($fpc [$periode], $x_0+$cp [$i][$periode]*$echelle_x*cos (M_PI/2+$theta*$i), $y_0-$cp [$i][$periode]*$echelle_y*sin (M_PI/2+$theta*$i), $tpc [$periode], $contour_point_compare [$periode], 2*$ech, 0) ;
		   }
                 }
	        Break ;
       Case 6 : $t = "pie" ; Break ;
      }
    }
   $coeff_eb = $coeff_eb*$coeff_eb ;
  }
 
 If ($type_graphique == 5)
  {
   // Trace des axes
  }
 Else
  {
   // Position des textes de la legende
   $pos_y = $hg-$mb-$hauteur_legende-$mlm-$h_fonte_matiere*$nbr_lignes ;
   // Trace des axes
   @ImageSetThickNess ($image, 1) ;
   @ImageLine ($image, $x_0, $y_0, $x_0+$largeur_possible, $y_0, $axes) ;
   @ImageLine ($image, $x_0, $y_0, $x_0, $y_0-$hauteur_possible, $axes) ; 
  
   // Trace des axes verticaux
   If (IsSet ($couleur_trait_grille_v)) { $c = extraction_couleur ($couleur_trait_grille_v) ; } Else { $c = extraction_couleur ($couleur_trait_grille_v_defaut) ; }
   $tgv = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
   @ImageSetThickNess ($image, 1) ;
   For ($i = 1 ; $i < $max_h ; $i++)
    {
     If (($quad_v == 1) And ($type_graphique != 1)) { @ImageLine ($image, $x_0+$i*$echelle_x, $y_0-$hauteur_possible, $x_0+$i*$echelle_x, $y_0, $traits_v) ; }
     Else
      {
       If ($type_graphique != 1) { @ImageLine ($image, $x_0+$i*$echelle_x, $y_0-$tavgv, $x_0+$i*$echelle_x, $y_0+$targv, $tgv) ; }
       Else { @ImageLine ($image, $x_0+$i*$nbr_periodes*$echelle_x, $y_0-$tavgv, $x_0+$i*$nbr_periodes*$echelle_x, $pos_y+($h_fonte_matiere-1)*2, $tgv) ; } // $y_0+$targv*2
      }
    }
   
   // Trace des axes horizontaux
   If (IsSet ($couleur_trait_grille_h)) { $c = extraction_couleur ($couleur_trait_grille_h) ; } Else { $c = extraction_couleur ($couleur_trait_grille_h_defaut) ; }
   $tgh = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
   $axes_h_1 = Array ($traits_h,$traits_h,$traits_h,$traits_h,$traits_h,$traits_h,$traits_h,$traits_h,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente) ;
   $axes_h_2 = Array ($traits_h,$traits_h,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente) ;
   For ($i = 0 ; $i <= $y_maximum ; $i += $pas)
    {
     If ($i > 0)
      {
       If ($i%$modulo == 0) { @ImageSetThickNess ($image, 2*$ech) ; @ImageSetStyle ($image, $axes_h_1) ; } Else { @ImageSetThickNess ($image, 1*$ech) ; @ImageSetStyle ($image, $axes_h_2) ; }
       // Ne trace pas la valeur moyenne ni les indics si presents maintenant
       If (!(($i == $y_maximum/2) Or (($ind_40 == 1) And ($i == 40*$y_maximum/100)) Or (($ind_60 == 1) And ($i == 60*$y_maximum/100))))
        {
         If ($quad_h == 1) { @ImageLine ($image, $x_0+1, $y_0-$i*$echelle_y, $x_0+$largeur_possible, $y_0-$i*$echelle_y, IMG_COLOR_STYLED) ; }
         Else { @ImageLine ($image, $x_0-$targh, $y_0-$i*$echelle_y, $x_0+$tavgh, $y_0-$i*$echelle_y, $tgh) ; }
        }
      }
    }
  
   // Affichage des matieres sur l'axe des abscisses
   For ($i = 0 ; $i <= $nbr_donnees ; $i++)
    {
     $nom_disc = HTML_Entity_Decode ($d [$i][0]) ;
     If ($type_graphique == 1)
      {
       $pos_x = $x_0+$i*$nbr_periodes*$echelle_x+Round (($nbr_periodes*$echelle_x-StrLen ($nom_disc)*$l_fonte_matiere)/2) ;
      }
     Else { $pos_x = $x_0-StrLen ($nom_disc)/2*$l_fonte_matiere+$i*$echelle_x ; }
     @ImageString ($image, $tft, $pos_x, $pos_y+($h_fonte_matiere-1)*($i%2)*($nbr_lignes==2), $nom_disc, $couleur_tt) ;
    }
   
   // Affichage des reperes sur les ordonnees
   $pos_x = $mg+StrLen ((string)$y_maximum)*$l_fonte_ordonnees ;
   For ($i = 0 ; $i <= $y_maximum ; $i += $pas)
    {
     If ($i%$modulo_ordonnee == 0) { @ImageString ($image, $tfo, $pos_x-StrLen ((string)$i)*$l_fonte_ordonnees, $y_0-$i*$echelle_y-$h_fonte_ordonnees/2, $i, $couleur_tt) ; }
    }
  }
 
 // Affichage du titre
 $titre = "Bilan de ".$nom." ".$prenoms ;
 While ((StrLen ($titre)*$l_fonte_titre > $lg-$mg-$md) And ($tftt > 1))
  {
   $tftt-- ;
   $h_fonte_titre = @ImageFontHeight ($tftt) ;
   $l_fonte_titre = @ImageFontWidth ($tftt) ;
  }
 $pos_x = ($lg-$mg-$md-StrLen ($titre)*$l_fonte_titre)/2 ;
 $pos_y = $mh ;
 If (IsSet ($titre_3d)) { $t3d = $titre_3d ; } Else { $t3d = $titre_3d_defaut ; }
 If (IsSet ($couleur_titre_3d)) { $c = extraction_couleur ($couleur_titre_3d) ; } Else { $c = extraction_couleur ($couleur_titre_3d_defaut) ; }
 $ct3d = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
 If ($t3d == 1) { @ImageString ($image, $tftt, $pos_x+1, $pos_y+1, $titre, $ct3d) ; }
 @ImageString ($image, $tftt, $pos_x, $pos_y, $titre, $couleur_tt) ;
 
 // Tracee des resultats
 For ($periode = 1 ; $periode <= $nbr_periodes ; $periode++)
  {
   Switch ($type_graphique)
    {
     Case 1 : // Tracee de rectangles
              @ImageSetThickNess ($image, 1) ;
	      If (IsSet ($couleur_barre [$periode])) { $c = extraction_couleur ($couleur_barre [$periode]) ; } Else { $c = extraction_couleur ($couleur_barre_defaut [$periode]) ; }
              $barre [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
	      If (IsSet ($couleur_contour_barre [$periode])) { $c = extraction_couleur ($couleur_contour_barre [$periode]) ; } Else { $c = extraction_couleur ($couleur_contour_barre_defaut [$periode]) ; }
              $contour_barre [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
	      If (IsSet ($espace_entre_barre)) { $eb = $espace_entre_barre*$ech ; } Else { $eb = $espace_entre_barre_defaut*$ech ; }
	      If (IsSet ($couleur_barre_degrade)) { $barre_degrade = $couleur_barre_degrade [$periode] ; } Else { $barre_degrade = $couleur_barre_degrade_defaut [$periode] ; }
	      If ($barre_degrade == 1)
               {
                If (IsSet ($couleur_barre)) { $cbr = $couleur_barre [$periode] ; } Else { $cbr = $couleur_barre_defaut [$periode] ; }
                If (IsSet ($couleur_barre_degrade_finale)) { $cbrf = $couleur_barre_degrade_finale [$periode] ; } Else { $cbrf = $couleur_barre_degrade_finale_defaut [$periode] ; }
                $coul_deb = extraction_couleur ($cbr) ;
                $coul_fin = extraction_couleur ($cbrf) ;
                $ppas = 4-$nbr_periodes ;
                $delta0 = ($coul_deb [0]-$coul_fin [0])/(($echelle_x+$eb*(-$coeff_eb-1))/$ppas) ;
                $delta1 = ($coul_deb [1]-$coul_fin [1])/(($echelle_x+$eb*(-$coeff_eb-1))/$ppas) ;
                $delta2 = ($coul_deb [2]-$coul_fin [2])/(($echelle_x+$eb*(-$coeff_eb-1))/$ppas) ;
	       }
              For ($i = 0 ; $i <= $nbr_donnees ; $i++)
               {
	        If ($i == 0)
	         {
	          If (Is_Numeric ($d [$i][$periode]) And ($d [$i][$periode] > 0))
	 	   {
		    If ($barre_degrade == 1)
                     {
		      $compteur = 0 ;
		      For ($j = $x_0+$eb+($periode-1)*$echelle_x+1 ; $j < $x_0-$eb*$coeff_eb+$periode*$echelle_x-1 ; $j+= $ppas)
		       {
		        $cbdg [$periode][$j] = @ImageColorAllocate ($image, Round ($coul_fin [0]+$delta0*$compteur), Round ($coul_fin [1]+$delta1*$compteur), Round ($coul_fin [2]+$delta2*$compteur)) ;
		        @ImageFilledRectangle ($image, $j, $y_0-$d [$i][$periode]*$echelle_y, $j+$ppas, $y_0, $cbdg [$periode][$j]) ;
			$compteur++ ;
		       }
		     }
		    Else { @ImageFilledRectangle ($image, $x_0+$eb+($periode-1)*$echelle_x, $y_0-$d [$i][$periode]*$echelle_y, $x_0-$eb*$coeff_eb+$periode*$echelle_x, $y_0, $barre [$periode]) ; }
	            @ImageRectangle ($image, $x_0+$eb+($periode-1)*$echelle_x, $y_0-$d [$i][$periode]*$echelle_y, $x_0-$eb*$coeff_eb+$periode*$echelle_x, $y_0, $contour_barre [$periode]) ;
		   }
	         }
	        ElseIf ($i <= $nbr_donnees)
	         {
	          If (Is_Numeric ($d [$i][$periode]) And ($d [$i][$periode] > 0))
	           {
		    If ($barre_degrade == 1)
                     {
		      $compteur = 0 ;
		      For ($j = $x_0+$eb+($i*$nbr_periodes+$periode-1)*$echelle_x+1 ; $j < $x_0-$eb*$coeff_eb+($i*$nbr_periodes+$periode)*$echelle_x-1 ; $j+= $ppas)
		       {
		        $cbdg [$periode][$j] = @ImageColorAllocate ($image, Round ($coul_fin [0]+$delta0*$compteur), Round ($coul_fin [1]+$delta1*$compteur), Round ($coul_fin [2]+$delta2*$compteur)) ;
		        @ImageFilledRectangle ($image, $j, $y_0-$d [$i][$periode]*$echelle_y, $j+$ppas, $y_0, $cbdg [$periode][$j]) ;
			$compteur++ ;
		       }
		     }
		    Else { @ImageFilledRectangle ($image, $x_0+$eb+($i*$nbr_periodes+$periode-1)*$echelle_x, $y_0-$d [$i][$periode]*$echelle_y, $x_0-$eb*$coeff_eb+($i*$nbr_periodes+$periode)*$echelle_x, $y_0, $barre [$periode]) ; }
	            @ImageRectangle ($image, $x_0+$eb+($i*$nbr_periodes+$periode-1)*$echelle_x, $y_0-$d [$i][$periode]*$echelle_y, $x_0-$eb*$coeff_eb+($i*$nbr_periodes+$periode)*$echelle_x, $y_0, $contour_barre [$periode]) ;
	           }
	         }
	        Else
	         {
	          If (Is_Numeric ($d [$i][$periode]) And ($d [$i][$periode] > 0))
	           {
		    If ($barre_degrade == 1)
                     {
		      $compteur = 0 ;
		      For ($j = $x_0+$eb+($i*$nbr_periodes+$periode-1)*$echelle_x+1 ; $j < $x_0+($i*$nbr_periodes+$periode)*$echelle_x-1 ; $j+= $ppas)
		       {
		        $cbdg [$periode][$j] = @ImageColorAllocate ($image, Round ($coul_fin [0]+$delta0*$compteur), Round ($coul_fin [1]+$delta1*$compteur), Round ($coul_fin [2]+$delta2*$compteur)) ;
		        @ImageFilledRectangle ($image, $j, $y_0-$d [$i][$periode]*$echelle_y, $j+$ppas, $y_0, $cbdg [$periode][$j]) ;
			$compteur++ ;
		       }
		     }
		    Else { @ImageFilledRectangle ($image, $x_0+$eb+($i*$nbr_periodes+$periode-1)*$echelle_x, $y_0-$d [$i][$periode]*$echelle_y, $x_0+($i*$nbr_periodes+$periode)*$echelle_x, $y_0, $barre [$periode]) ; }
	            @ImageRectangle ($image, $x_0+$eb+($i*$nbr_periodes+$periode-1)*$echelle_x, $y_0-$d [$i][$periode]*$echelle_y, $x_0+($i*$nbr_periodes+$periode)*$echelle_x, $y_0, $contour_barre [$periode]) ;
		   }
	         }
               }
	      Break ;
     Case 2 : // Tracee des lignes avec points
              If (IsSet ($couleur_ligne [$periode])) { $c = extraction_couleur ($couleur_ligne [$periode]) ; }
	      Else { $c = extraction_couleur ($couleur_ligne_defaut [$periode]) ; }
              $trace [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
              @ImageSetThickNess ($image, 3*$ech) ;
	      $i = 0 ;
	      While ((!Is_Numeric ($d [$i][$periode])) And ($i <= $nbr_donnees))
	       {
	        $i++ ;
	       }
	      $pp = $i ;
	      $x_old = $i ;
	      $y_old = $d [$i][$periode] ;
              For ($i = $pp+1 ; $i <= $nbr_donnees ; $i++)
               {
	        If (Is_Numeric ($d [$i][$periode]) And ($d [$i][$periode] > 0))
	         {
                  @ImageLine ($image, $x_0+$x_old*$echelle_x, $y_0+1-$y_old*$echelle_y, $x_0+$i*$echelle_x, $y_0+1-$d [$i][$periode]*$echelle_y, $trace [$periode]) ;
		  $x_old = $i ;
		  $y_old = $d [$i][$periode] ;
	         }
               }
              // Tracee des points
	      If (IsSet ($taille_point [$periode])) { $tp [$periode] = $taille_point [$periode]*$ech ; } Else { $tp [$periode] = $taille_point_defaut [$periode]*$ech ; }
	      If (IsSet ($forme_point [$periode])) { $fp [$periode] = $forme_point [$periode]*$ech ; } Else { $fp [$periode] = $forme_point_defaut [$periode]*$ech ; }
	      If (IsSet ($couleur_contour_point [$periode])) { $c = extraction_couleur ($couleur_contour_point [$periode]) ; }
	      Else { $c = extraction_couleur ($couleur_contour_point_defaut [$periode]) ; }
              $contour_point [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
              For ($i = 0 ; $i <= $nbr_donnees ; $i++)
               {
	        If (Is_Numeric ($d [$i][$periode]))
		 {
	          point ($fp [$periode], $x_0+$i*$echelle_x, $y_0+1-$d [$i][$periode]*$echelle_y, $tp [$periode], $contour_point [$periode], 2*$ech, 0) ;
		 }
               }
	      Break ;
     Case 3 : // Tracee des lignes
              If (IsSet ($couleur_ligne [$periode])) { $c = extraction_couleur ($couleur_ligne [$periode]) ; } Else { $c = extraction_couleur ($couleur_ligne_defaut [$periode]) ; }
              $trace [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
              @ImageSetThickNess ($image, 3*$ech) ;
	      $i = 0 ;
	      While ((!Is_Numeric ($d [$i][$periode])) And ($i <= $nbr_donnees))
	       {
	        $i++ ;
	       }
	      $pp = $i ;
	      $x_old = $i ;
	      $y_old = $d [$i][$periode] ;
              For ($i = $pp+1 ; $i <= $nbr_donnees ; $i++)
               {
	        If (Is_Numeric ($d [$i][$periode]) And ($d [$i][$periode] > 0))
	         {
                  @ImageLine ($image, $x_0+$x_old*$echelle_x, $y_0+1-$y_old*$echelle_y, $x_0+$i*$echelle_x, $y_0+1-$d [$i][$periode]*$echelle_y, $trace [$periode]) ;
		  $x_old = $i ;
		  $y_old = $d [$i][$periode] ;
	         }
               }
	      Break ;
     Case 4 : // Tracee des points
	      If (IsSet ($couleur_point [$periode])) { $c = extraction_couleur ($couleur_point [$periode]) ; } Else { $c = extraction_couleur ($couleur_point_defaut [$periode]) ; }
              $point_int [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
	      If (IsSet ($taille_point [$periode])) { $tp [$periode] = $taille_point [$periode]*$ech ; } Else { $tp [$periode] = $taille_point_defaut [$periode]*$ech ; }
	      If (IsSet ($forme_point [$periode])) { $fp [$periode] = $forme_point [$periode]*$ech ; } Else { $fp [$periode] = $forme_point_defaut [$periode]*$ech ; }
              // Tracee de l'exterieur des points
	      If (IsSet ($couleur_contour_point [$periode])) { $c = extraction_couleur ($couleur_contour_point [$periode]) ; } Else { $c = extraction_couleur ($couleur_contour_point_defaut [$periode]) ; }
              $contour_point [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
              For ($i = 0 ; $i <= $nbr_donnees ; $i++)
               {
	        If (Is_Numeric ($d [$i][$periode]))
		 {
                  point ($fp [$periode], $x_0+$i*$echelle_x, $y_0+1-$d [$i][$periode]*$echelle_y, $tp [$periode], $contour_point [$periode], 2*$ech, 0) ;
		 }
               }
	      Break ;
     Case 5 : // Tracee d'un cercle
              If (IsSet ($couleur_cercle [$periode])) { $c = extraction_couleur ($couleur_cercle [$periode]) ; }
	      Else { $c = extraction_couleur ($couleur_cercle_defaut [$periode]) ; }
              $trace [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
              @ImageSetThickNess ($image, 2.5*$ech) ;
	      $i = 0 ;
	      While ((!Is_Numeric ($d [$i][$periode])) And ($i <= $nbr_donnees))
	       {
	        $i++ ;
	       }
	      $pp = $i ;
	      $x_old = $i ;
	      $y_old = $d [$i][$periode] ;
              For ($i = $pp+1 ; $i <= $nbr_donnees ; $i++)
               {
	        If (Is_Numeric ($d [$i][$periode]) And ($d [$i][$periode] > 0))
	         {
        	  @ImageLine ($image, $x_0+$y_old*$echelle_x*cos (M_PI/2+$theta*$x_old), $y_0-$y_old*$echelle_y*sin (M_PI/2+$theta*$x_old),
		                      $x_0+$d [$i][$periode]*$echelle_x*cos (M_PI/2+$theta*$i), $y_0-$d [$i][$periode]*$echelle_y*sin (M_PI/2+$theta*$i), $trace [$periode]) ;
		  $x_old = $i ;
		  $y_old = $d [$i][$periode] ;
	         }
               }
	      // Liaison premier point et dernier point
	      @ImageLine ($image, $x_0+$y_old*$echelle_x*cos (M_PI/2+$theta*$x_old), $y_0-$y_old*$echelle_y*sin (M_PI/2+$theta*$x_old),
		                  $x_0+$d [$pp][$periode]*$echelle_x*cos (M_PI/2+$theta*$pp), $y_0-$d [$pp][$periode]*$echelle_y*sin (M_PI/2+$theta*$pp), $trace [$periode]) ;
              // Tracee des points
	      If (IsSet ($taille_point_cercle [$periode])) { $tp [$periode] = $taille_point_cercle [$periode]*$ech ; }
	      Else { $tp [$periode] = $taille_point_cercle_defaut [$periode]*$ech ; }
	      If (IsSet ($forme_point_cercle [$periode])) { $fp [$periode] = $forme_point_cercle [$periode]*$ech ; }
	      Else { $fp [$periode] = $forme_point_cercle_defaut [$periode]*$ech ; }
	      If (IsSet ($couleur_contour_point_cercle [$periode])) { $c = extraction_couleur ($couleur_contour_point_cercle [$periode]) ; }
	      Else { $c = extraction_couleur ($couleur_contour_point_cercle_defaut [$periode]) ; }
              $contour_point [$periode] = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
              For ($i = 0 ; $i <= $nbr_donnees ; $i++)
               {
	        If (Is_Numeric ($d [$i][$periode]))
		 {
		  point ($fp [$periode], $x_0+$d [$i][$periode]*$echelle_x*cos (M_PI/2+$theta*$i), $y_0-$d [$i][$periode]*$echelle_y*sin (M_PI/2+$theta*$i), $tp [$periode], $contour_point [$periode], 2*$ech, 0) ;
		 }
               }
	      Break ;
     Case 6 : $t = "pie" ; Break ;
    }
  }

 // Affichage de la legende
 If ($type_graphique == 5) { $echelle_x = $largeur_possible/($max_h-1) ; }
 $pos_x = Round (($lg-$largeur_legende-($legende_3d==1))/2) ;
 $pos_y = $hg-$mb-$hauteur_legende-($legende_3d==1) ;
 // Verification
 If ($pos_x < 0) { $pos_x = $mg ; }
 If ($pos_x+$largeur_legende > $lg) { $echelle_x = ($lg-$mg-$md-$mlg-$mld)*$echelle_x/$largeur_legende ; $largeur_legende = $lg-$mg-$md ; }
 //If ($mlh > $hauteur_legende/2) { $mlh = Round ($hauteur_legende/3) ; }
 
 If (IsSet ($couleur_fond_legende)) { $c = extraction_couleur ($couleur_fond_legende) ; } Else { $c = extraction_couleur ($couleur_fond_legende_defaut) ; }
 $cfl = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
 If (IsSet ($couleur_contour_legende)) { $c = extraction_couleur ($couleur_contour_legende) ; } Else { $c = extraction_couleur ($couleur_contour_legende_defaut) ; }
 $ccl = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
 @ImageSetThickNess ($image, 1) ;
 If ($legende_3d == 1)
  {
   If (IsSet ($couleur_contour_3d_legende)) { $c = extraction_couleur ($couleur_contour_3d_legende) ; } Else { $c = extraction_couleur ($couleur_contour_3d_legende_defaut) ; }
   $ccl_3d = @ImageColorAllocate ($image, $c [0], $c [1], $c [2]) ;
   @ImageRectangle ($image, $pos_x+1, $pos_y+1, $pos_x+$largeur_legende+1, $pos_y+$hauteur_legende+1, $ccl_3d) ;
  }
 @ImageFilledRectangle ($image, $pos_x, $pos_y, $pos_x+$largeur_legende, $pos_y+$hauteur_legende, $cfl) ;
 @ImageRectangle ($image, $pos_x, $pos_y, $pos_x+$largeur_legende, $pos_y+$hauteur_legende, $ccl) ;
 For ($i = 1 ; $i <= $nbr_lignes_legende ; $i++)
  {
   $x = $pos_x+$mlg ;
   $y = $pos_y+$mlh+($h_fonte_legende+$eelv)*($i-1) ;
   For ($j = 1 ; $j <= $nbr_titre_legende [$i] ; $j++)
    {
     If ($status_titres [$i][$j][0] == -1)
      {
       If (IsSet ($espace_entre_barre)) { $eb = $espace_entre_barre*$ech ; } Else { $eb = $espace_entre_barre_defaut*$ech ; }
       @ImageFilledRectangle ($image, $x+$eb, $y+1, $x+$echelle_x-$eb, $y+$h_fonte_legende-1, $c1) ;
       @ImageSetStyle ($image, $style_classe) ;
       @ImageRectangle ($image, $x+$eb, $y+1, $x+$echelle_x-$eb, $y+$h_fonte_legende-1, IMG_COLOR_STYLED) ;
       @ImageString ($image, $tfl, $x+$echelle_x, $y, $titres [$i][$j], $couleur_tt) ;
       $x += $echelle_x+StrLen ($titres [$i][$j])*$l_fonte_legende+$eelh ;
      }
     ElseIf ($status_titres [$i][$j][0] == -2)
      {
       @ImageSetThickNess ($image, 2*$ech) ;
       @ImageLine ($image, $x, $y+Round ($h_fonte_legende/2), $x+$echelle_x, $y+Round ($h_fonte_legende/2), $c3) ;
       @ImageString ($image, $tfl, $x+$echelle_x, $y, $titres [$i][$j], $couleur_tt) ;
       $x += $echelle_x+StrLen ($titres [$i][$j])*$l_fonte_legende+$eelh ;
      }
     Else
      {
       Switch ($type_graphique)
        {
         Case 1 : @ImageSetThickNess ($image, 1) ;
                  If ($status_titres [$i][$j][0] == 1)
                   {
		    If (IsSet ($couleur_barre_degrade)) { $barre_degrade = $couleur_barre_degrade [$status_titres [$i][$j][1]] ; }
		    Else { $barre_degrade = $couleur_barre_degrade_defaut [$status_titres [$i][$j][1]] ; }
	            If ($barre_degrade == 1)
                     {
                      If (IsSet ($couleur_barre)) { $cbr = $couleur_barre [$status_titres [$i][$j][1]] ; } Else { $cbr = $couleur_barre_defaut [$status_titres [$i][$j][1]] ; }
                      If (IsSet ($couleur_barre_degrade_finale)) { $cbrf = $couleur_barre_degrade_finale [$status_titres [$i][$j][1]] ; } Else { $cbrf = $couleur_barre_degrade_finale_defaut [$status_titres [$i][$j][1]] ; }
                      $coul_deb = extraction_couleur ($cbr) ;
                      $coul_fin = extraction_couleur ($cbrf) ;
                      $ppas = 4-$nbr_periodes ;
                      $delta0 = ($coul_deb [0]-$coul_fin [0])/(($echelle_x-2)/$ppas) ;
                      $delta1 = ($coul_deb [1]-$coul_fin [1])/(($echelle_x-2)/$ppas) ;
                      $delta2 = ($coul_deb [2]-$coul_fin [2])/(($echelle_x-2)/$ppas) ;
	             }
		    If ($barre_degrade == 1)
                     {
		      $compteur = 0 ;
		      For ($k = $x+$eb+1 ; $k < $x+$echelle_x-$eb-1 ; $k+= $ppas)
		       {
		        $cbdgl [$i][$k] = @ImageColorAllocate ($image, Round ($coul_fin [0]+$delta0*$compteur), Round ($coul_fin [1]+$delta1*$compteur), Round ($coul_fin [2]+$delta2*$compteur)) ;
		        @ImageFilledRectangle ($image, $k, $y+1, $k+$ppas, $y+$h_fonte_legende-1, $cbdgl [$i][$k]) ;
			$compteur++ ;
		       }
		     }
		    Else { @ImageFilledRectangle ($image, $x+$eb, $y+1, $x+$echelle_x-$eb, $y+$h_fonte_legende-1, $barre [$status_titres [$i][$j][1]]) ; }
                    @ImageRectangle ($image, $x+$eb, $y+1, $x+$echelle_x-$eb, $y+$h_fonte_legende-1, $contour_barre [$status_titres [$i][$j][1]]) ;
     	           }
	          ElseIf ($status_titres [$i][$j][0] == 2)
	           {
		    If (IsSet ($couleur_barre_compare_degrade)) { $barre_compare_degrade = $couleur_barre_compare_degrade [$status_titres [$i][$j][1]] ; } Else { $barre_compare_degrade = $couleur_barre_compare_degrade_defaut [$status_titres [$i][$j][1]] ; }
	            If ($barre_compare_degrade == 1)
                     {
                      If (IsSet ($couleur_barre_compare)) { $cbr = $couleur_barre_compare [$status_titres [$i][$j][1]] ; } Else { $cbr = $couleur_barre_compare_defaut [$status_titres [$i][$j][1]] ; }
                      If (IsSet ($couleur_barre_compare_degrade_finale)) { $cbrf = $couleur_barre_compare_degrade_finale [$status_titres [$i][$j][1]] ; } Else { $cbrf = $couleur_barre_compare_degrade_finale_defaut [$status_titres [$i][$j][1]] ; }
                      $coul_deb = extraction_couleur ($cbr) ;
                      $coul_fin = extraction_couleur ($cbrf) ;
                      $ppas = 4-$nbr_periodes ;
                      $delta0 = ($coul_deb [0]-$coul_fin [0])/(($echelle_x-2)/$ppas) ;
                      $delta1 = ($coul_deb [1]-$coul_fin [1])/(($echelle_x-2)/$ppas) ;
                      $delta2 = ($coul_deb [2]-$coul_fin [2])/(($echelle_x-2)/$ppas) ;
	             }
		    If ($barre_compare_degrade == 1)
                     {
		      $compteur = 0 ;
		      For ($k = $x+$eb+1 ; $k < $x+$echelle_x-$eb-1 ; $k+= $ppas)
		       {
		        $cbdgcl [$i][$k] = @ImageColorAllocate ($image, Round ($coul_deb [0]-$delta0*$compteur), Round ($coul_deb [1]-$delta1*$compteur), Round ($coul_deb [2]-$delta2*$compteur)) ;
		        @ImageFilledRectangle ($image, $k, $y+1, $k+$ppas, $y+$h_fonte_legende-1, $cbdgcl [$i][$k]) ;
		        $compteur++ ;
		       }
		     }
		    Else { @ImageFilledRectangle ($image, $x+$eb, $y+1, $x+$echelle_x-$eb, $y+$h_fonte_legende-1, $barre_c [$status_titres [$i][$j][1]]) ; }
	            @ImageRectangle ($image, $x+$eb, $y+1, $x+$echelle_x-$eb, $y+$h_fonte_legende-1, $contour_barre_c [$status_titres [$i][$j][1]]) ;
	            For ($yy = $y+2 ; $yy < $y+$h_fonte_legende-2 ; $yy++)
	             {
	              For ($xx = 0 ; $xx < Rand (1, 3) ; $xx++)
	     	       {
		        @ImageSetPixel ($image, $x+$eb+Rand (1, $echelle_x-2*$eb-1), $yy, $contour_barre_point_c [$status_titres [$i][$j][1]]) ;
		       }
		     }
		   }
	          Break ;
         Case 2 : If ($status_titres [$i][$j][0] == 1)
                   {
		    @ImageSetThickNess ($image, 3*$ech) ;
		    @ImageLine ($image, $x, $y+Round ($h_fonte_legende/2), $x+$echelle_x, $y+Round ($h_fonte_legende/2), $trace [$status_titres [$i][$j][1]]) ;
		    point ($fp [$status_titres [$i][$j][1]], $x+Round ($echelle_x/2), $y+Round ($h_fonte_legende/2), $tp [$status_titres [$i][$j][1]], $contour_point [$status_titres [$i][$j][1]], 2*$ech, 0) ;
		   }
	          ElseIf ($status_titres [$i][$j][0] == 2)
	           {
		    @imageSetStyle ($image, $style_comp [$status_titres [$i][$j][1]]) ;
                    @ImageSetThickNess ($image, 3*$ech) ;
		    @ImageLine ($image, $x, $y+Round ($h_fonte_legende/2), $x+$echelle_x, $y+Round ($h_fonte_legende/2), IMG_COLOR_STYLED) ;
		    point ($fpc [$status_titres [$i][$j][1]], $x+Round ($echelle_x/2), $y+Round ($h_fonte_legende/2), $tpc [$status_titres [$i][$j][1]], $contour_point_compare [$status_titres [$i][$j][1]], 2*$ech, 0) ;
		   }
	          Break ;
         Case 3 : If ($status_titres [$i][$j][0] == 1)
                   {
		    @ImageSetThickNess ($image, 3*$ech) ;
		    @ImageLine ($image, $x, $y+Round ($h_fonte_legende/2), $x+$echelle_x, $y+Round ($h_fonte_legende/2), $trace [$status_titres [$i][$j][1]]) ;
		   }
	          ElseIf ($status_titres [$i][$j][0] == 2)
	           {
		    @ImageSetThickNess ($image, 3*$ech) ;
		    @imageSetStyle ($image, $style_comp [$status_titres [$i][$j][1]]) ;
		    @ImageLine ($image, $x, $y+Round ($h_fonte_legende/2), $x+$echelle_x, $y+Round ($h_fonte_legende/2), IMG_COLOR_STYLED) ;
		   }
                  Break ;
         Case 4 : If ($status_titres [$i][$j][0] == 1)
                   {
		    point ($fp [$status_titres [$i][$j][1]], $x+Round ($echelle_x/2), $y+Round ($h_fonte_legende/2), $tp [$status_titres [$i][$j][1]], $contour_point [$status_titres [$i][$j][1]], 2*$ech, 0) ;
		   }
	          ElseIf ($status_titres [$i][$j][0] == 2)
	           {
		    point ($fpc [$status_titres [$i][$j][1]], $x+Round ($echelle_x/2), $y+Round ($h_fonte_legende/2), $tpc [$status_titres [$i][$j][1]], $contour_point_compare [$status_titres [$i][$j][1]], 2*$ech, 0) ;
		   }
                  Break ;
         Case 5 : If ($status_titres [$i][$j][0] == 1)
                   {
		    @ImageSetThickNess ($image, 2*$ech) ;
		    @ImageLine ($image, $x, $y+Round ($h_fonte_legende/2), $x+$echelle_x, $y+Round ($h_fonte_legende/2), $trace [$status_titres [$i][$j][1]]) ;
		    point ($fp [$status_titres [$i][$j][1]], $x+Round ($echelle_x/2), $y+Round ($h_fonte_legende/2), $tp [$status_titres [$i][$j][1]], $contour_point [$status_titres [$i][$j][1]], 2*$ech, 0) ;
		   }
	          ElseIf ($status_titres [$i][$j][0] == 2)
	           {
		    @imageSetStyle ($image, $style_comp [$status_titres [$i][$j][1]]) ;
                    @ImageSetThickNess ($image, 2*$ech) ;
		    @ImageLine ($image, $x, $y+Round ($h_fonte_legende/2), $x+$echelle_x, $y+Round ($h_fonte_legende/2), IMG_COLOR_STYLED) ;
		    point ($fpc [$status_titres [$i][$j][1]], $x+Round ($echelle_x/2), $y+Round ($h_fonte_legende/2), $tpc [$status_titres [$i][$j][1]], $contour_point_compare [$status_titres [$i][$j][1]], 2*$ech, 0) ;
		   }
	          Break ;
        }
       @ImageString ($image, $tfl, $x+$echelle_x, $y, $titres [$i][$j], $couleur_tt) ;
       $x += $echelle_x+StrLen ($titres [$i][$j])*$l_fonte_legende+$eelh ;
      }
    }
  }

 If ($type_graphique != 5)
  {
   // Trace de la ligne moyenne
   $axe_moyen = Array ($trait_moyenne,$trait_moyenne,$trait_moyenne,$trait_moyenne,$trait_moyenne,$trait_moyenne,$trait_moyenne,$trait_moyenne,
                       $couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente) ;
   @ImageSetStyle ($image, $axe_moyen) ;
   @ImageSetThickNess ($image, 2*$ech) ;
   @ImageLine ($image, $x_0+1, $y_0-($y_maximum/2)*$echelle_y, $x_0+$largeur_possible, $y_0-($y_maximum/2)*$echelle_y, IMG_COLOR_STYLED) ;
   
   // Trace des indics
   If ($ind_40 == 1)
    {
     $axe_indic_40 = Array ($trait_indic_40,$trait_indic_40,$trait_indic_40,$trait_indic_40,$trait_indic_40,$trait_indic_40,$trait_indic_40,$trait_indic_40,
                            $couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente) ;
     @ImageSetStyle ($image, $axe_indic_40) ;
     @ImageSetThickNess ($image, 2*$ech) ;
     @ImageLine ($image, $x_0+1, $y_0-(40*$y_maximum/100)*$echelle_y, $x_0+$largeur_possible, $y_0-(40*$y_maximum/100)*$echelle_y, IMG_COLOR_STYLED) ;
    }
   If ($ind_60 == 1)
    {
     $axe_indic_60 = Array ($trait_indic_60,$trait_indic_60,$trait_indic_60,$trait_indic_60,$trait_indic_60,$trait_indic_60,$trait_indic_60,$trait_indic_60,
                            $couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente,$couleur_transparente) ;
     @ImageSetStyle ($image, $axe_indic_60) ;
     @ImageSetThickNess ($image, 2*$ech) ;
     @ImageLine ($image, $x_0+1, $y_0-(60*$y_maximum/100)*$echelle_y, $x_0+$largeur_possible, $y_0-(60*$y_maximum/100)*$echelle_y, IMG_COLOR_STYLED) ;
    }
  }
 
 @UnLink ("../../tmp/".$fichier) ;
 If ($generation == 1)
  {
   Header ("Content-type: image/png") ;
   @ImagePng ($image) ;
  }
 ElseIf ($generation == 2)
  {
   @ImagePng ($image, $nom_fichier) ;
  }
 @ImageDestroy ($image) ;
?>