<?php
 /** @package Garennes - Verification des notes */
 Session_Start () ;
 If (!$_SESSION ["repertoire_config"]) { Header ("Location: ../../sortie.php?sortie=3") ; }
 Include ("../../include/garennes.cfg") ;
 Include ("../../include/init.php") ;
 Include ("../../include/verifications.php") ;
 Include ("../include/config.inc") ;
 verif_droits ($droit_courant, $_SESSION ["code"]) ;
 
 $verif = var_courante ("verif", 0, null) ;
 $prof = var_courante ("prof", 0, 0) ;
 $id_classe = var_courante ("id_classe", 0, 0) ;
 $purge = var_courante ("purge", 0, 0) ;
 $millesime = millesime (0) ;
 
 $debug = 1 ;
 
 // Destruction des groupes alias en trop par rapport aux services profs
 $al = SQL_commande ("SELECT professeur,id_service_prof FROM services_prof WHERE professeur<0", $id_sql) ;
 $nbr_al = SQL_nbr_lignes ($al) ;
 $requet1 = $requete2 = "" ;
 For ($ii = 0 ; $ii < $nbr_al ; $ii++)
  {
   $als = SQL_ligne_suivante ($al) ;
   If ($ii > 0) { $requete1 .= " AND " ; $requete2 .= " AND " ; }
   $requete1 .= "id_alias!='".(-$als [0])."'" ;
   $requete2 .= "id_service_prof!='".$als [1]."'" ;
  }
 $okk = SQL_commande ("DELETE FROM alias WHERE ".$requete1, $id_sql) ;
 $okk = SQL_commande ("DELETE FROM groupes_alias WHERE ".$requete2, $id_sql) ;
 // Destruction des alias en double
 $al = SQL_commande ("SELECT DISTINCT a.id_groupe_alias,b.id_groupe_alias FROM groupes_alias a,groupes_alias b WHERE a.id_alias=b.id_alias AND a.code=b.code
                         AND a.numero=b.numero AND a.id_utilisateur=b.id_utilisateur AND a.id_service_classe=b.id_service_classe
                         AND a.id_service_prof=b.id_service_prof AND a.millesime=b.millesime AND a.id_groupe_alias!=b.id_groupe_alias
		    ORDER BY a.id_groupe_alias", $id_sql) ;
 $nbr_al = SQL_nbr_lignes ($al) ;
 $table [0] = 0 ;
 For ($ii = 0 ; $ii < $nbr_al ; $ii++)
  {
   $als = SQL_ligne_suivante ($al) ;
   $ok = 0 ;
   For ($jj = 1 ; $jj <= $table [0] ; $jj++)
    {
     If (($table [$jj] == $als [0]) Or ($table [$jj] == $als [1])) { $ok = 1 ; }
    }
   If ($ok == 0)
    {
     $okk = SQL_commande ("DELETE FROM groupes_alias WHERE id_groupe_alias='".$als [0]."' LIMIT 1", $id_sql) ;
     $table [0] = $table [0] + 1 ;
     $table [$table [0]] = $als [0] ;
    }
  }
 $okk = SQL_commande ("DELETE FROM groupes_alias WHERE id_utilisateur='0'", $id_sql) ;
 // Destruction des groupes alias en trop
 $al = SQL_commande ("SELECT a.id_alias FROM alias a,groupes_alias b WHERE a.id_alias=b.id_alias", $id_sql) ;
 $nbr_al = SQL_nbr_lignes ($al) ;
 $requete = "SELECT id_groupe_alias FROM groupes_alias WHERE " ;
 For ($ii = 0 ; $ii < $nbr_al ; $ii++)
  {
   $als = SQL_ligne_suivante ($al) ;
   If ($ii > 0) { $requete .= " AND " ; }
   $requete .= "id_alias!='".$als [0]."'" ;
  }
 $al = SQL_commande ($requete, $id_sql) ;
 $nbr_al = SQL_nbr_lignes ($al) ;
 For ($ii = 0 ; $ii < $nbr_al ; $ii++)
  {
   $als = SQL_ligne_suivante ($al) ;
   $okk = SQL_commande ("DELETE FROM groupes_alias WHERE id_groupe_alias='".$als [0]."'", $id_sql) ;
  }
 
 $resultats = SQL_commande ("SELECT * FROM menus WHERE numero='".$droit_courant."' AND ordre='0'", $id_sql) ;
 $l = SQL_tableau_associatif ($resultats, "") ;
 
 Function verification_enseignant ($professeurs, $millesime)
  {
   Global $id_sql, $ctl, $code_absent, $code_non_rendu, $code_dispense, $debug ;
   $l [0] = 0 ;
   $l [1] = "" ;
   For ($i = 0 ; $i < SQL_nbr_lignes ($professeurs) ; $i++)
    {
     $prof = SQL_tableau_associatif ($professeurs, "") ;
     $l [0]++ ;
     $l [1] .= "- V&eacute;rification des notes de ".$prof ["nom"]." ".$prof ["prenom"]." -" ;
     $classes = SQL_commande ("SELECT classe FROM services_prof WHERE professeur='".$prof ["id_utilisateur"]."' AND millesime='".$millesime."'", $id_sql) ;
     $ok_ligne = 0 ;
     For ($j = 0 ; $j < SQL_nbr_lignes ($classes) ; $j++)
      {
       $classe = SQL_ligne_suivante ($classes, "") ;
       $r = verification_notes_enseignant ($prof ["id_utilisateur"], $classe [0], $debug) ;
       If ($r [0] > 1)
        {
         If ($ok_ligne == 0) { $l [0]++ ; $l [1] .= "\n" ; }
         $l [0] += $r [0] ;
         $l [1] .= $r [1] ;
         $ok_ligne = 1 ;
        }
      }
     If ($r [0] == 1) { $l [1] .= "> Correct !\n" ; $l [0]++ ; } Else { $l [0]++ ; $l [1] .= "\n" ; }
    }
   Return $l ;
  }
 
 If (IsSet ($verif))
  {
   If ($verif > 0)
    {
     // Purge initiale
     $ok = SQL_commande ("DELETE FROM appreciations WHERE eleve='0'", $id_sql) ;
     $ok = SQL_commande ("UPDATE appreciations SET millesime='".$millesime."' WHERE millesime='0'", $id_sql) ;
     $ok = SQL_commande ("UPDATE calcul_moyenne SET millesime='".$millesime."' WHERE millesime='0'", $id_sql) ;
     $ok = SQL_commande ("UPDATE classes SET millesime='".$millesime."' WHERE millesime='0'", $id_sql) ;
     $ok = SQL_commande ("UPDATE controles SET millesime='".$millesime."' WHERE millesime='0'", $id_sql) ;
     $ok = SQL_commande ("UPDATE eleves SET millesime='".$millesime."' WHERE millesime='0'", $id_sql) ;
     $ok = SQL_commande ("UPDATE etablissements SET millesime='".$millesime."' WHERE millesime='0'", $id_sql) ;
     $ok = SQL_commande ("UPDATE groupes_classe SET millesime='".$millesime."' WHERE millesime='0'", $id_sql) ;
     $ok = SQL_commande ("DELETE FROM groupes_eleve WHERE eleve='0'", $id_sql) ;
     $ok = SQL_commande ("UPDATE groupes_eleve SET millesime='".$millesime."' WHERE millesime='0'", $id_sql) ;
     $ok = SQL_commande ("DELETE FROM moyennes WHERE eleve='0'", $id_sql) ;
     $ok = SQL_commande ("UPDATE moyennes SET millesime='".$millesime."' WHERE millesime='0'", $id_sql) ;
     $ok = SQL_commande ("DELETE FROM notes WHERE eleve='0'", $id_sql) ;
     $ok = SQL_commande ("UPDATE notes SET millesime='".$millesime."' WHERE millesime='0'", $id_sql) ;
     $ok = SQL_commande ("DELETE FROM notes WHERE controle='0'", $id_sql) ;
     $ok = SQL_commande ("DELETE FROM options_eleve WHERE eleve='0'", $id_sql) ;
     $ok = SQL_commande ("UPDATE options_eleve SET millesime='".$millesime."' WHERE millesime='0'", $id_sql) ;
     $ok = SQL_commande ("DELETE FROM groupes_classe WHERE service_classe='0'", $id_sql) ;
     $ok = SQL_commande ("DELETE FROM groupes_eleve WHERE groupe='0'", $id_sql) ;
     $ok = SQL_commande ("DELETE FROM options_eleve WHERE service_classe='0'", $id_sql) ;
     // Purge des options
     $options = SQL_commande ("SELECT id_option_eleve,eleve FROM options_eleve WHERE millesime='".$millesime."'", $id_sql) ;
     For ($i = 0 ; $i < SQL_nbr_lignes ($options) ; $i++)
      {
       $opt = SQL_ligne_suivante ($options) ;
       $ok = SQL_commande ("SELECT id_eleve FROM eleves WHERE id_eleve='".$opt [1]."' LIMIT 1", $id_sql) ;
       If (SQL_nbr_lignes ($ok)  == 0)
        {
         $ok = SQL_commande ("DELETE FROM options_eleve WHERE id_option_eleve='".$opt [0]."'", $id_sql) ;
        }
      }
     // Purge des groupes
     // Groupe d'eleve sans les eleves
     $groupes = SQL_commande ("SELECT id_groupe_eleve,eleve FROM groupes_eleve WHERE millesime='".$millesime."'", $id_sql) ;
     For ($i = 0 ; $i < SQL_nbr_lignes ($groupes) ; $i++)
      {
       $grp = SQL_ligne_suivante ($groupes) ;
       $ok = SQL_commande ("SELECT id_eleve FROM eleves WHERE id_eleve='".$grp [1]."' LIMIT 1", $id_sql) ;
       If (SQL_nbr_lignes ($ok)  == 0)
        {
         $ok = SQL_commande ("DELETE FROM groupes_eleve WHERE id_groupe_eleve='".$grp [0]."'", $id_sql) ;
        }
      }
     // Groupes identiques
     $groupes = SQL_commande ("SELECT g.id_groupe_eleve,g.eleve,g.groupe FROM groupes_eleve g,groupes_eleve e
                                WHERE g.eleve=e.eleve AND g.repere1=e.repere1 AND g.repere2=e.repere2 AND g.discipline=e.discipline
				  AND g.code_disc=e.code_disc AND g.groupe=e.groupe AND g.id_groupe_eleve!=e.id_groupe_eleve
                                  AND g.millesime='".$millesime."' AND e.millesime='".$millesime."' ORDER BY eleve,groupe", $id_sql) ;
     If (SQL_nbr_lignes ($groupes) > 0)
      {
       $grp = SQL_ligne_suivante ($groupes) ;
       $id_eleve = $grp [1] ;
       $id_groupe = $grp [2] ;
       For ($i = 1 ; $i < SQL_nbr_lignes ($groupes) ; $i++)
        {
         $grp = SQL_ligne_suivante ($groupes) ;
	 If ($grp [1] == $id_eleve)
	  {
	   If ($grp [2] == $id_groupe) { $ok = SQL_commande ("DELETE FROM groupes_eleve WHERE id_groupe_eleve='".$grp [0]."' LIMIT 1", $id_sql) ; }
	   Else { $id_groupe = $grp [2] ; }
	  }
	 Else
	  {
	   $id_eleve = $grp [1] ;
           $id_groupe = $grp [2] ;
	  }
	}
      }
     // Purge des notes
     $notes = SQL_commande ("SELECT id_note,eleve FROM notes WHERE millesime='".$millesime."'", $id_sql) ;
     For ($i = 0 ; $i < SQL_nbr_lignes ($notes) ; $i++)
      {
       $nts = SQL_ligne_suivante ($notes) ;
       $ok = SQL_commande ("SELECT id_eleve FROM eleves WHERE id_eleve='".$nts [1]."' LIMIT 1", $id_sql) ;
       If (SQL_nbr_lignes ($ok)  == 0) { $ok = SQL_commande ("DELETE FROM notes WHERE id_note='".$nts [0]."'", $id_sql) ; }
      }
     Switch ($verif)
      {
       Case 1 : // Verification des colonnes sans notes d'un professeur
                $ligne [0] = 0 ;
	        $ligne [1] = "" ;
		If ($purge == 1)
		 {
  	          $r = purger_colonnes_sans_notes ($prof, 1) ;
                  If ($r [0] > 0)
                   {
		    $ligne [0] += $r [0] ;
	            $ligne [1] .= $r [1]."\n" ; ;
                   }
                 }
                // Verification des notes d'un professeur
  	        $ctl = 0 ;
		$professeurs = SQL_commande ("SELECT * FROM utilisateurs WHERE id_utilisateur='".$prof."' LIMIT 1", $id_sql) ;
  	        $r = verification_enseignant ($professeurs, $millesime) ;
		$ligne [0] += $r [0] ;
	        $ligne [1] .= $r [1] ;
	        Break ;
       Case 2 : // Verification des colonnes sans notes de tous les professeurs
                $compteur = 0 ;
	        $ctl = 0 ;
		$ligne [0] = 1 ;
		$ligne [1] = "---- V&eacute;rification des notes de tous les enseignants ----\n" ;
		If ($purge == 1)
		 {
		  $professeurs = SQL_commande ("SELECT id_utilisateur FROM utilisateurs WHERE droits='".$droit_prof."'AND millesime='".$millesime."' ORDER BY nom,prenom", $id_sql) ;
		  For ($i = 0 ; $i < SQL_nbr_lignes ($professeurs) ; $i++)
		   {
		    $p = SQL_ligne_suivante ($professeurs) ;
  	            $r = purger_colonnes_sans_notes ($p [0], 1) ;
                    If ($r [0] > 0)
                     {
                      $ligne [0] += $r [0] ;
	              $ligne [1] .= $r [1]."\n" ;
                     }
                   }
                 }
                // Verification de toutes les notes
		$professeurs = SQL_commande ("SELECT id_utilisateur,nom,prenom FROM utilisateurs WHERE droits='".$droit_prof."' AND millesime='".$millesime."' ORDER BY nom,prenom", $id_sql) ;
		$r = verification_enseignant ($professeurs, $millesime) ;
		$ligne [0] += $r [0] ;
	        $ligne [1] .= $r [1] ;
	        Break ;
       Case 3 : // Verification de tous les eleves
                $compteur = 0 ;
	        $table [0] = 0 ;
	        $ctl = 0 ;
	        $nbr_lignes = 1 ;
                $notes = SQL_commande ("SELECT id_note,eleve,repere1,repere2 FROM notes WHERE millesime='".$millesime."'", $id_sql) ;
		$ligne [0] = 0 ;
		$ligne [1] = "---- V&eacute;rification de la base &eacute;l&egrave;ves ----\n" ;
	        For ($i = 0 ; $i < SQL_nbr_lignes ($notes) ; $i++)
	         {
	          $nt = SQL_tableau_associatif ($notes, "") ;
                  $eleves = SQL_commande ("SELECT id_eleve FROM eleves WHERE id_eleve='".$nt ["eleve"]."' LIMIT 1", $id_sql) ;
                  If (SQL_nbr_lignes ($eleves) == 0)
               	   {
	  	    $compteur++ ;
		    $ligne [0]++ ;
		    $ligne [1] .= $compteur."- L'&eacute;l&egrave;ve ".$nt ["eleve"]." (".$nt ["repere1"]."-".$nt ["repere2"].") n'existe plus dans la base.\n" ;
		    $ctl = 1 ;
		    $table [0]++ ;
		    $table [$table [0]] = $nt ["id_note"] ;  
		   }
	         }
	        For ($i = 1 ; $i <= $table [0] ; $i++)
	         {
	          $ok = SQL_commande ("DELETE FROM notes WHERE id_note='".$table [$i]."' LIMIT 1", $id_sql) ;
	         }
	        If ($ctl == 0) { $ligne [1] .= "Rien &agrave; signaler !\n" ; $ligne [0]++ ; }
	        Break ;
       Case 4 : // Verification de toutes les classes
                If ($id_classe == 0)
                 {
                  $compteur = 0 ;
	          $table [0] = 0 ;
	          $ctl = 0 ;
	          $nbr_lignes = 1 ;
                  $classes = SQL_commande ("SELECT id_classe,nom,nom_bref FROM classes WHERE millesime='".$millesime."' ORDER BY nom_bref,nom", $id_sql) ;
                  $nbr_classes = SQL_nbr_lignes ($classes) ;
                  $ligne [0] = 0 ;
                  $ligne [1] = "" ;
                  If ($purge == 1)
		   {
		    $professeurs = SQL_commande ("SELECT id_utilisateurs FROM utilisateurs WHERE droits='".$droit_prof."' AND millesime='".$millesime."' ORDER BY nom,prenom", $id_sql) ;
		    For ($i = 0 ; $i < SQL_nbr_lignes ($professeurs) ; $i++)
		     {
		      $p = SQL_ligne_suivante ($professeurs) ;
  	              $r = purger_colonnes_sans_notes ($p [0], 1) ;
                      If ($r [0] > 0)
                       {
                        $ligne [0] += $r [0] ;
	                $ligne [1] .= $r [1]."\n" ;
                       }
                     }
                   }
                  For ($i = 0 ; $i < $nbr_classes ; $i++)
                   {
                    $classe = SQL_ligne_suivante ($classes) ;
                    $eleves = SQL_commande ("SELECT id_eleve FROM eleves WHERE classe='".$classe [0]."' AND millesime='".$millesime."' ORDER BY nom,prenoms,date_naissance", $id_sql) ;
                    $nombre_eleves = SQL_nbr_lignes ($eleves) ;
		    $ligne [1] .= "- V&eacute;rification de la classe de ".$classe [1]." (".$classe [2].") -" ;
                    $ok_ligne = 0 ;
	            For ($j = 0 ; $j < $nombre_eleves ; $j++)
	             {
	              $eleve = SQL_ligne_suivante ($eleves, "") ;
                      $r = verification_notes_eleve ($eleve [0], $debug) ;
                      If ($r [0] > 1)
                       {
                        If ($ok_ligne == 0) { $ligne [0]++ ; $ligne [1] .= "\n" ; }
                        $ligne [0] += $r [0] ;
                        $ligne [1] .= $r [1] ;
                        $ok_ligne = 1 ;
                       }
		     }
                    If ($ok_ligne == 0) { $ligne [0]++ ; $ligne [1] .= "> Correct." ; }
                    $ligne [0]++ ;
                    $ligne [1] .= "\n" ;
	           }
                 }
	        Break ;
       Case 5 : // Verification d'une seule classe
                If ($id_classe > 0)
                 {
                  $compteur = 0 ;
	          $table [0] = 0 ;
	          $ctl = 0 ;
	          $nbr_lignes = 1 ;
                  $ligne [0] = 0 ;
                  $ligne [1] = "" ;
                  If ($purge == 1)
		   {
                    $ligne [1] .= "- V&eacute;rification de l'&eacute;quipe p&eacute;dagogique -\n" ;
		    $professeurs = SQL_commande ("SELECT s.professeur FROM services_prof s,utilisateurs u WHERE s.classe='".$id_classe."'AND s.millesime='".$millesime."' AND u.id_utilisateur=s.professeur ORDER BY u.nom,u.prenom", $id_sql) ;
                    $id_prof_old = 0 ;
		    For ($i = 0 ; $i < SQL_nbr_lignes ($professeurs) ; $i++)
		     {
		      $p = SQL_ligne_suivante ($professeurs) ;
                      If ($p [0] != $id_prof_old)
                       {
                        $r = purger_colonnes_sans_notes ($p [0], 1) ;
                        If ($r [0] > 0)
                         {
                          $ligne [0] += $r [0] ;
	                  $ligne [1] .= $r [1]."\n" ;
                         }
                        $id_prof_old = $p [0] ;
                       }
                     }
                   }
                  $classe = SQL_commande ("SELECT nom,nom_bref FROM classes WHERE id_classe='".$id_classe."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
                  $cl = SQL_ligne_suivante ($classe) ;
                  $eleves = SQL_commande ("SELECT id_eleve FROM eleves WHERE classe='".$id_classe."' AND millesime='".$millesime."' ORDER BY nom,prenoms,date_naissance", $id_sql) ;
                  $nombre_eleves = SQL_nbr_lignes ($eleves) ;
		  $ligne [1] .= "- V&eacute;rification de la classe de ".$cl [0]." (".$cl [1].") -" ;
                  $ok_ligne = 0 ;
	          For ($j = 0 ; $j < $nombre_eleves ; $j++)
	           {
	            $eleve = SQL_ligne_suivante ($eleves, "") ;
                    $r = verification_notes_eleve ($eleve [0], $debug) ;
                    If ($r [0] > 1)
                     {
                      If ($ok_ligne == 0) { $ligne [0]++ ; $ligne [1] .= "\n" ; }
                      $ligne [0] += $r [0] ;
                      $ligne [1] .= $r [1] ;
                      $ok_ligne = 1 ;
                     }
		   }
                  If ($ok_ligne == 0) { $ligne [0]++ ; $ligne [1] .= "> Correct." ; }
                  $ligne [0]++ ;
                  $ligne [1] .= "\n" ;
                 }
	        Break ;
      }
     $mess = 3 ;
    }
   Else
    {
     // Procedure d'appel pour faire patienter
     Echo "<HTML>" ;
     Echo "<HEAD><TITLE>Garennes.</TITLE>" ;
     Echo "<META HTTP-EQUIV=\"REFRESH\" CONTENT=\"1;url='./verif_notes.php?verif=".(-$verif)."&prof=".$prof."&id_classe=".$id_classe."&purge=".$purge."'\">" ;
     Echo "</HEAD>" ;
     Echo "<BODY BACKGROUND=\"../images/fond.png\" onContextMenu=\"return false\">" ;
     Echo "<CENTER><B>V&eacute;rification des notes/contr&ocirc;les en cours...<BR>Veuillez patienter S.V.P.</B><BR>MERCI&nbsp;!<BR>" ;
     Echo "<a href=\"./verif_notes.php?verif=".(-$verif)."&prof=".$prof."&id_classe=".$id_classe."&purge=".$purge."\">" ;
     Echo "<IMG SRC=\"../../images/attente.gif\" BORDER=\"1\" STYLE=\"border:1px solid #000000\"></a></CENTER>" ;
     Echo "</BODY></HTML>" ;
     Exit ;
    }
  }
 
 Echo "<HTML><HEAD>" ;
 entete_html ("Garennes - Menu", "", 1) ;
 Echo styles ("none", "none", "none", $l ["lien"], "none") ;
 Echo "</HEAD>" ;
 
 Echo "<BODY BACKGROUND=\"../images/fond.png\" TEXT=\"".$ligne ["couleur_texte"]."\" onContextMenu=\"return false\">" ;
 Echo "<CENTER>V&eacute;rification de la base</CENTER>" ;
 
 If ((IsSet ($mess)) Or (IsSet ($ligne))) { affiche_message ($mess, $ligne) ; }

 Echo "<TABLE BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"1\" ALIGN=\"CENTER\">" ;
 Echo "<TR><TD><TABLE BORDER=\"1\" CELLPADDING=\"0\" CELLSPACING=\"0\" BGCOLOR=\"".$l ["couleur_fond"]."\" WIDTH=\"100%\" STYLE=\"border:1px solid #000000;border-collapse:collapse\">" ;
 Echo "<TR><TD><TABLE BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\" WIDTH=\"100%\">" ;
 Echo "<TR BGCOLOR=\"".$l ["lien"]."\"><TD ALIGN=\"CENTER\"><FONT SIZE=\"".$l ["titre"]."\"><B>&nbsp;V&eacute;rification&nbsp;de&nbsp;la&nbsp;base&nbsp;&eacute;l&egrave;ves&nbsp;</B></FONT></TD></TR>" ;
 Echo "<TR><TD><FONT SIZE=\"".$l ["titre"]."\">&nbsp;</FONT></TD></TR>" ;
 Echo "<TR>" ;
 Echo "<FORM ACTION=\"./verif_notes.php\" METHOD=\"POST\">" ;
 Echo "<INPUT TYPE=\"HIDDEN\" NAME=\"verif\" VALUE=\"-3\">" ;
 Echo "<INPUT TYPE=\"HIDDEN\" NAME=\"prof\" VALUE=\"0\">" ;
 Echo "<TD ALIGN=\"CENTER\"><INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"  Lancer la v&eacute;rification  \"></TD>" ;
 Echo "</FORM>" ;
 Echo "</TR>" ;
 Echo "<TR><TD><FONT SIZE=\"".$l ["titre"]."\">&nbsp;</FONT></TD></TR>" ;
 Echo "</TABLE>" ;
 Echo "</TD></TR></TABLE>" ;
 Echo "</TD></TR>" ;
 $professeurs = SQL_commande ("SELECT * FROM utilisateurs WHERE droits='".$droit_prof."' AND millesime='".$millesime."' ORDER BY nom,prenom", $id_sql) ;
 If (SQL_nbr_lignes ($professeurs) > 0)
  {
   Echo "<TR><TD>&nbsp;</TD></TR>" ;
   Echo "<TR><TD>" ;
   Echo "<TABLE BORDER=\"1\" CELLPADDING=\"0\" CELLSPACING=\"0\" BGCOLOR=\"".$l ["couleur_fond"]."\" WIDTH=\"100%\" STYLE=\"border:1px solid #000000;border-collapse:collapse\">" ;
   Echo "<TR><TD>" ;
   Echo "<TABLE BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\" WIDTH=\"100%\">" ;
   Echo "<TR BGCOLOR=\"".$l ["lien"]."\"><TD ALIGN=\"CENTER\"><FONT SIZE=\"".$l ["titre"]."\"><B>&nbsp;V&eacute;rification&nbsp;de&nbsp;la&nbsp;base&nbsp;des&nbsp;notes&nbsp;d'un&nbsp;ou&nbsp;plusieurs&nbsp;enseignants&nbsp;</B></FONT></TD></TR>" ;
   Echo "<TR><TD><FONT SIZE=\"".$l ["titre"]."\">&nbsp;</FONT></TD></TR>" ;
   Echo "<TR>" ;
   Echo "<FORM ACTION=\"./verif_notes.php\" METHOD=\"POST\">" ;
   Echo "<INPUT TYPE=\"HIDDEN\" NAME=\"verif\" VALUE=\"-2\">" ;
   Echo "<INPUT TYPE=\"HIDDEN\" NAME=\"prof\" VALUE=\"0\">" ;
   Echo "<TD ALIGN=\"CENTER\"><INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\" Tous les enseignants \"></TD>" ;
   Echo "</TR>" ;
   Echo "<TR><TD ALIGN=\"CENTER\">&nbsp;<INPUT TYPE=\"CHECKBOX\" NAME=\"purge\" VALUE=\"1\" CHECKED>" ;
   Echo "&nbsp;Purge&nbsp;les&nbsp;colonnes&nbsp;de&nbsp;notes&nbsp;sans&nbsp;notes&nbsp;</TD></TR>" ;
   Echo "</FORM>" ;
   Echo "<TR><TD><FONT SIZE=\"".$l ["titre"]."\">&nbsp;</FONT></TD></TR>" ;
   Echo "<TR BGCOLOR=\"".$l ["lien"]."\"><TD ALIGN=\"CENTER\"><FONT SIZE=\"".$l ["titre"]."\">&nbsp;<B>ou&nbsp;un&nbsp;enseignant&nbsp;parmi</B>&nbsp;</FONT></TD></TR>" ;
   Echo "<TR><TD>&nbsp;</TD></TR>" ;
   Echo "<TR>" ;
   Echo "<FORM ACTION=\"./verif_notes.php\" METHOD=\"POST\">" ;
   Echo "<INPUT TYPE=\"HIDDEN\" NAME=\"verif\" VALUE=\"-1\">" ;
   Echo "<TD ALIGN=\"CENTER\">&nbsp;<SELECT NAME=\"prof\">" ;
   For ($i = 0 ; $i < SQL_nbr_lignes ($professeurs) ; $i++)
    {
     $p = SQL_tableau_associatif ($professeurs, "") ;
     Echo "<OPTION VALUE=\"".$p ["id_utilisateur"]."\"" ; If ($prof == $p ["id_utilisateur"]) { Echo " SELECTED" ; }
     Echo ">".$p ["nom"]." ".$p ["prenom"]."</OPTION>" ;
    }
   Echo "</SELECT>&nbsp;</TD>" ;
   Echo "</TR>" ;
   Echo "<TR><TD ALIGN=\"CENTER\">&nbsp;<INPUT TYPE=\"CHECKBOX\" NAME=\"purge\" VALUE=\"1\" CHECKED>" ;
   Echo "&nbsp;Purge&nbsp;les&nbsp;colonnes&nbsp;de&nbsp;notes&nbsp;sans&nbsp;notes&nbsp;</TD></TR>" ;
   Echo "<TR>" ;
   Echo "<TD ALIGN=\"CENTER\">&nbsp;<INPUT TYPE=\"IMAGE\" SRC=\"../images/valider.png\" NAME=\"submit\">&nbsp;</TD>" ;
   Echo "</FORM>" ;
   Echo "</TR>" ;
   Echo "<TR><TD>&nbsp;</TD></TR>" ;
   Echo "</TABLE>" ;
   Echo "</TD></TR></TABLE>" ;
  }
 Echo "</TD></TR>" ;
 $classes = SQL_commande ("SELECT id_classe,nom,nom_bref FROM classes WHERE millesime='".$millesime."' ORDER BY nom_bref,nom", $id_sql) ;
 If (SQL_nbr_lignes ($classes) > 0)
  {
   Echo "<TR><TD>&nbsp;</TD></TR>" ;
   Echo "<TR><TD>" ;
   Echo "<TABLE BORDER=\"1\" CELLPADDING=\"0\" CELLSPACING=\"0\" BGCOLOR=\"".$l ["couleur_fond"]."\" WIDTH=\"100%\" STYLE=\"border:1px solid #000000;border-collapse:collapse\">" ;
   Echo "<TR><TD>" ;
   Echo "<TABLE BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\" WIDTH=\"100%\">" ;
   Echo "<TR BGCOLOR=\"".$l ["lien"]."\"><TD ALIGN=\"CENTER\"><FONT SIZE=\"".$l ["titre"]."\"><B>&nbsp;V&eacute;rification&nbsp;de&nbsp;la&nbsp;base&nbsp;des&nbsp;notes&nbsp;d'une&nbsp;ou&nbsp;plusieurs&nbsp;classes&nbsp;</B></FONT></TD></TR>" ;
   Echo "<TR><TD><FONT SIZE=\"".$l ["titre"]."\">&nbsp;</FONT></TD></TR>" ;
   Echo "<TR>" ;
   Echo "<FORM ACTION=\"./verif_notes.php\" METHOD=\"POST\">" ;
   Echo "<INPUT TYPE=\"HIDDEN\" NAME=\"verif\" VALUE=\"-4\">" ;
   Echo "<INPUT TYPE=\"HIDDEN\" NAME=\"id_classe\" VALUE=\"0\">" ;
   Echo "<TD ALIGN=\"CENTER\"><INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\" Toutes les classes \">&nbsp;(<b>Peut&nbsp;&ecirc;tre&nbsp;tr&egrave;s&nbsp;long</b>)</TD>" ;
   Echo "</TR>" ;
   Echo "<TR><TD ALIGN=\"CENTER\">&nbsp;<INPUT TYPE=\"CHECKBOX\" NAME=\"purge\" VALUE=\"1\" CHECKED>" ;
   Echo "&nbsp;Purge&nbsp;les&nbsp;colonnes&nbsp;de&nbsp;notes&nbsp;sans&nbsp;notes&nbsp;</TD></TR>" ;
   Echo "</FORM>" ;
   Echo "<TR><TD><FONT SIZE=\"".$l ["titre"]."\">&nbsp;</FONT></TD></TR>" ;
   Echo "<TR BGCOLOR=\"".$l ["lien"]."\"><TD ALIGN=\"CENTER\"><FONT SIZE=\"".$l ["titre"]."\">&nbsp;<B>ou&nbsp;d'une&nbsp;classe&nbsp;parmi</B>&nbsp;</FONT></TD></TR>" ;
   Echo "<TR><TD>&nbsp;</TD></TR>" ;
   Echo "<TR>" ;
   Echo "<FORM ACTION=\"./verif_notes.php\" METHOD=\"POST\">" ;
   Echo "<INPUT TYPE=\"HIDDEN\" NAME=\"verif\" VALUE=\"-5\">" ;
   Echo "<TD ALIGN=\"CENTER\">&nbsp;<SELECT NAME=\"id_classe\">" ;
   For ($i = 0 ; $i < SQL_nbr_lignes ($classes) ; $i++)
    {
     $c = SQL_ligne_suivante ($classes) ;
     Echo "<OPTION VALUE=\"".$c [0]."\"" ; If ($id_classe == $c [0]) { Echo " SELECTED" ; }
     Echo ">".$c [2]." - ".$c [1]."</OPTION>" ;
    }
   Echo "</SELECT>&nbsp;</TD>" ;
   Echo "</TR>" ;
   Echo "<TR><TD ALIGN=\"CENTER\">&nbsp;<INPUT TYPE=\"CHECKBOX\" NAME=\"purge\" VALUE=\"1\" CHECKED>" ;
   Echo "&nbsp;Purge&nbsp;les&nbsp;colonnes&nbsp;de&nbsp;notes&nbsp;sans&nbsp;notes&nbsp;</TD></TR>" ;
   Echo "<TR>" ;
   Echo "<TD ALIGN=\"CENTER\">&nbsp;<INPUT TYPE=\"IMAGE\" SRC=\"../images/valider.png\" NAME=\"submit\">&nbsp;</TD>" ;
   Echo "</FORM>" ;
   Echo "</TR>" ;
   Echo "</TABLE>" ;
   Echo "</TD></TR></TABLE>" ;
   Echo "<TR><TD>&nbsp;</TD></TR>" ;
  }
 Echo "</TD></TR></TABLE>" ;
 Echo "</BODY></HTML>" ;
?>