<?php
 If (!IsSet ($reentrance))
  {
   Session_Start () ;
   $_SESSION ["repertoire_config"] = "../../include" ;
   Include ("../../include/garennes.cfg") ;
   Include ("../../include/init.php") ;
   Include ("../include/config.inc") ;
   verif_droits ($droit_courant, $_SESSION ["code"]) ;
  }
 Include ("../../include/cahier_textes.php") ;
 
 $hauteur_editeur = "200" ;
 $largeur_editeur = "650" ;
 
 /**
 * Insertion de la liste des seances saisies
 * @param int $cahier_type Identifiant du type de cahier de texte
 * @param int $id_service_prof Identifiant du service prof
 * @param int $onglet Numero de l'onglet courant
 * @param int $tri Tri de la progression (0=Descendant,1=Ascendant)
 * @param array $theme Couleurs pour affichage
 * @return string HTML du formulaire de la liste des seances
 */
 Function insertion_seance ($cahier_type, $id_service_prof, $onglet, $tri, $theme)
  {
   Global $id_sql, $nom_mois_maj ;
   $millesime = millesime (0) ;
   If ($cahier_type == 0) { $nom_action = "seance" ; $operateur = "=" ; $id = "id_cahier_texte" ; $num_fonction = $cahier_type ; }
   ElseIf ($cahier_type > 0) { $nom_action = "travail" ; $operateur = ">=" ; $id = "id_cahier_texte" ; $num_fonction = $cahier_type ;  }
   ElseIf ($cahier_type < 0) { $nom_action = "devoir" ; $operateur = "" ; $id = "id_cahier_devoir" ; $num_fonction = "devoir_".(-$cahier_type) ;  }
   $affiche = restaure_configuration_defaut ("CAHIER_TEXTES","AFFICHAGE",$nom_action."_".$id_service_prof,Date ("m")) ;
   $periode = carac_periode_par_service_prof ($id_service_prof) ;
   If ($affiche == 0) { $plus = "" ; }
   Else
    {
     If ((integer)$affiche > 0)
      {
       // Par mois
       If (($affiche > 8) And ($affiche <= 12)) { $annee = $millesime ; } Else { $annee = $millesime+1 ; }
       If (($affiche > 0) And ($affiche < 10)) { $mois = "0".(integer)$affiche ; } Else { $mois = $affiche ; }
       $plus = " AND date>='".$annee."-".$mois."-01' AND date <='".$annee."-".$mois."-31'" ;
      }
     Else
      {
       // Par periode
       $plus = " AND date>='".deb_periode ($periode [0], -$affiche)."' AND date <='" ;
       If (-$affiche < $periode [1]) { $plus .= deb_periode ($periode [0], -$affiche+1)."'" ; } Else { $plus .= ($millesime+1)."-08-31'" ; }
      }
    }
   If ($tri == 0) { $plus_tri = " DESC" ; } Else { $plus_tri = " ASC" ; }
   If ($cahier_type >= 0)
    {
     $requete = "SELECT id_cahier_texte,date,heure_debut,duree,date_entree,date_maj,texte,publication FROM cahier_textes
                  WHERE id_service_prof='".$id_service_prof."' AND cahier_type".$operateur."'".$cahier_type."'".$plus." ORDER BY date".$plus_tri ;
     If ($cahier_type == 0) { $requete .= ",heure_debut ASC" ; }
    }
   Else
    {
     $requete = "SELECT id_cahier_devoir,date,heure_debut,duree,date_entree,date_maj,texte,publication FROM cahier_devoirs
                  WHERE id_service_prof='".$id_service_prof."' ".$plus." ORDER BY date".$plus_tri.",heure_debut ASC" ;
    }
   $resultats = SQL_commande ($requete, $id_sql) ;
   $nbr_resultats = SQL_nbr_lignes ($resultats) ;
   $lgn = "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">" ;
   
   $lgn .= "<form action=\"./cahier_textes.php\" method=\"post\" name=\"selection_mois_".$num_fonction."\">" ;
   $lgn .= "<tr bgcolor=\"".$theme [10][2]."\"><td colspan=\"2\" style=\"border-bottom:1px solid #000000;\"><b>Afficher&nbsp;:&nbsp;" ;
   $lgn .= "<select name=\"mois\" onchange=\"javascript:document.selection_mois_".$num_fonction.".submit();\" style=\"background:".$theme [10][2]."\">" ;
   $lgn .= "<option value=\"0\">Toutes les notices</option>" ;
   If ($periode [1] > 1)
    {
     $periode [2] = StrToUpper (SubStr ($periode [2], 0, 1)).SubStr ($periode [2], 1, StrLen ($periode [2])-1) ;
     $lgn .= "<optgroup label='Notices P&eacute;riodiques' title='Notices p&eacute;riodiques'>" ;
     For ($i = 1 ; $i <= $periode [3] ; $i++)
      {
       $lgn .= "<option value=\"-".$i."\"" ; If ($affiche == -$i) { $lgn .= " selected" ; }
       $lgn .= " title=\"Toutes les notices du ".$periode [2]." ".$i."\">".$periode [2]."&nbsp;".$i."</option>" ;
      }
     $lgn .= "</optgroup>" ;
     $lgn .= "<optgroup label='Notices Mensuels' title='Notices mensuelles'>" ;
    }
   For ($i = 9 ; $i <= 12 ; $i++)
    {
     $lgn .= "<option value=\"".$i."\"" ; If ($affiche == $i) { $lgn .= " selected" ; }
     $lgn .= " title=\"Toutes les notices de ".$nom_mois_maj [(integer)$i]."\">".$nom_mois_maj [(integer)$i]."&nbsp;".$millesime."</option>" ;
    }
   For ($i = 1 ; $i <= 8 ; $i++)
    {
     $lgn .= "<option value=\"".$i."\"" ; If ($affiche == $i) { $lgn .= " selected" ; }
     $lgn .= " title=\"Toutes les notices de ".$nom_mois_maj [(integer)$i]."\">".$nom_mois_maj [(integer)$i]."&nbsp;".($millesime+1)."</option>" ;
    }
   If ($periode [1] > 1) { $lgn .= "</optgroup>" ; }
   $lgn .= "</select></b></td><td style=\"border-bottom:1px solid #000000;\"><input type=\"image\" src=\"../images/ajouter.png\" name=\"submit\" value=\"Valider\"></tr>" ;
   $lgn .= "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$onglet."\">" ;
   $lgn .= "<input type=\"hidden\" name=\"action_".$nom_action."\" value=\"".(15+($cahier_type < 0)*9)."\">" ;
   $lgn .= "<input type=\"hidden\" name=\"".$id."\" value=\"0\">" ;
   $lgn .= "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
   $lgn .= "</form>" ;
   
   $lgn .= "<tr><td align=\"center\" colspan=\"2\" style=\"border-bottom:1px dotted #000000;\">" ;
   $lgn .= "&nbsp;<b>.&nbsp;-&nbsp;=&nbsp;Liste&nbsp;des&nbsp;notices&nbsp;=&nbsp;-&nbsp;.</b>&nbsp;</td>" ;
   $lgn .= "<td style=\"border-bottom:1px dotted #000000;\"><a href=\"./cahier_textes.php?onglet_defaut=".$onglet."&action_".$nom_action."=".(16+($cahier_type < 0)*7)."&".$id."=0&id_service_prof=".$id_service_prof."\">" ;
   $lgn .= "<img src=\"../../images/tri_" ; If ($tri == 0) { $lgn .= "asc" ; } Else { $lgn .= "desc" ; }
   $lgn .= ".png\" title=\"Ordre de tri des notices...\" alt=\"Tri\" border=\"0\"></a></td></tr>" ;
   
   
   If ($nbr_resultats > 0)
    {
     $lgn .= "<form action=\"./cahier_textes.php\" method=\"post\" name=\"suppression_".$num_fonction."\">" ;
     $lgn .= "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$onglet."\">" ;
     $lgn .= "<input type=\"hidden\" name=\"action_".$nom_action."\" value=\"".(2+($cahier_type < 0)*18)."\">" ;
     $lgn .= "<input type=\"hidden\" name=\"".$id."\" value=\"0\">" ;
     $lgn .= "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
     $lgn .= "</form>" ;
     $lgn .= "<form action=\"./cahier_textes.php\" method=\"post\" name=\"public_".$num_fonction."\">" ;
     $lgn .= "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$onglet."\">" ;
     $lgn .= "<input type=\"hidden\" name=\"action_".$nom_action."\" value=\"".(7+($cahier_type < 0)*18)."\">" ;
     $lgn .= "<input type=\"hidden\" name=\"".$id."\" value=\"0\">" ;
     $lgn .= "<input type=\"hidden\" name=\"publication\" value=\"0\">" ;
     $lgn .= "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
     $lgn .= "</form>" ;
     $lgn .= "<script type=\"text/javascript\">" ;
     $lgn .= "function valider_effacement_".$num_fonction."(date,dd,df,id){";
     $lgn .= "if(confirm(\"Voulez-vous effacer la notice du\\n\"+date+\" de \"+dd+\" a \"+df+\" ?\")){" ;
     $lgn .= "document.suppression_".$num_fonction.".".$id.".value=id;" ;
     $lgn .= "document.suppression_".$num_fonction.".submit();}}" ;
     $lgn .= "function publication_".$num_fonction."(id,p){" ;
     $lgn .= "document.public_".$num_fonction.".".$id.".value=id;" ;
     $lgn .= "document.public_".$num_fonction.".publication.value=p;" ;
     $lgn .= "document.public_".$num_fonction.".submit();}" ;
     $lgn .= "</script>" ;
     For ($i = 0 ; $i < $nbr_resultats ; $i++)
      {
       $ligne = SQL_ligne_suivante ($resultats) ;
       $dd = Explode (":", $ligne [2]) ;
       $hd = $dd [0] ; $md = $dd [1] ; $sd = $dd [2] ;
       $lgn .= "<tr" ; If ($i%$theme [10][0] == 1) { $lgn .= " bgcolor=\"".$theme [10][2]."\"" ; }
       // Icones Edition/Suppression/Publication
       $lgn .= "><td valign=\"middle\"><a href=\"./cahier_textes.php?action_".$nom_action."=".(3+($cahier_type < 0)*18)."&onglet_defaut=".$onglet."&".$id."=".$ligne [0]."&id_service_prof=".$id_service_prof."\">" ;
       $lgn .= "<img src=\"../images/edition.png\" border=\"0\" title=\"Modifier...\" alt=\"Modifier\"></a>" ;
       $lgn .= "<a href=\"javascript:valider_effacement_".$num_fonction."('".jour_html ($ligne [1]." ".$ligne [2], 1)." ".decode_date_4 ($ligne [1])."','".Str_Replace (":", "H", SubStr ($ligne [2], 0, 5))."','" ;
       $lgn .= Str_Replace (":", "H", Date ("H:i", MkTime ((integer)$hd,(integer)$md,(integer)($sd+$ligne [3]),1,1,2006)))."','".$ligne [0]."',".$cahier_type.");\">" ;
       $lgn .= "<img src=\"../images/effacer.png\" border=\"0\" title=\"Supprimer...\" alt=\"Supprimer\"></a>" ;
       $lgn .= "<a href=\"javascript:publication_".$num_fonction."(".$ligne [0].",".$ligne [7].",".$cahier_type.");\"><img src=\"../../images/photo_" ;
       If ($ligne [7] == 1) { $lgn .= "ok" ; $titre = "Ne plus rendre publique cette notice..." ; } Else { $lgn .= "non_ok" ; $titre = "Rendre publique cette notice..." ; }
       $lgn .= ".png\" border=\"0\" title=\"".$titre."\" alt=\"Publique\"></a>&nbsp;</td>" ;
       // Date
       $lgn .= "<td><font size=\"-2\">&nbsp;" ;
       If ($cahier_type == 1) { $lgn .= "&Agrave;&nbsp;faire&nbsp;pour&nbsp;le&nbsp;<br>&nbsp;" ; }
       $lgn .= jour_html ($ligne [1]." ".$ligne [2], 1)."&nbsp;".decode_date_4 ($ligne [1])."&nbsp;" ;
       If ($cahier_type == 0)
        {
         $lgn .= "<br>&nbsp;" ;
         $lgn .= Str_Replace (":", "H", SubStr ($ligne [2], 0, 5))."&nbsp;&agrave;&nbsp;".Str_Replace (":", "H", Date ("H:i", MkTime ((integer)$hd,(integer)$md,(integer)($sd+$ligne [3]),1,1,2006)))."&nbsp;" ;
	}
       $lgn .= "</font></td>" ;
       // Icone fichier attache
       $fichiers_attaches = SQL_commande ("SELECT titre FROM cahier_documents WHERE id_cahier_texte='".$ligne [0]."' ORDER BY titre", $id_sql) ;
       $nbr_fa = SQL_nbr_lignes ($fichiers_attaches) ;
       $lgn .= "<td>" ;
       If ($nbr_fa > 0)
        {
	 If ($nbr_fa > 1) { $plus = "s" ; } Else { $plus = "" ; }
	 $lgn .= "<img src=\"../../images/attache.png\" title=\"Fichier".$plus." attach&eacute;".$plus." : " ;
	 For ($j = 0 ; $j < $nbr_fa ; $j++)
	  {
	   $fa = SQL_ligne_suivante ($fichiers_attaches) ;
	   If ($j > 0) { $lgn .= ", " ; }
	   $lgn .= $fa [0] ;
	  }
	 $lgn .= "\" alt=\"Fichiers\">" ;
	}
       $lgn .= "</td></tr>" ;
      }
     $lgn .= "</table>" ;
    }
   Else { $lgn .= "<tr><td align=\"center\"><b>Aucune&nbsp;notice.</b></td></tr></table>" ; }
   Return $lgn ;
  }
 
 /**
 * Insertion du formulaire d'insertion de documents
 * @param string $titre Titre du formulaire
 * @return string HTML du formulaire
 */
 Function insertion_document ($titre)
  {
   Global $id_sql, $id_classe, $id_service_prof, $fontes ;
   $tf = cahier_textes_tailles ($id_classe) ;
   $teu = cahier_textes_taille_espace_utilise ($id_service_prof) ;
   If ($tf [1] != 0) { $pourcent = Round ($teu/$tf [1]*100,2) ; }
   $aff_teu = cahier_textes_arrondi_taille ($teu, 2) ;
   $aff_tfic = cahier_textes_arrondi_taille ($tf [0], 2) ;
   $aff_tesp = cahier_textes_arrondi_taille ($tf [1], 2) ;
   $aff_tfic2 = cahier_textes_arrondi_taille ($tf [1]-$teu, 2) ;
   $lgn .= "<tr><td colspan=\"3\" valign=\"top\">".$fontes."<b>".$titre."&nbsp;:&nbsp;(Taille&nbsp;maximale&nbsp;:&nbsp;</font><font color=\"#ff0000\">" ;
   If ($tf [0] < $tf [1]-$teu) { $lgn .= $aff_tfic [0]."</font>".$aff_tfic [1] ; } Else { $lgn .= $aff_tfic2 [0]."</font>".$aff_tfic2 [1] ; }
   $lgn .= "o)&nbsp;</b></font></td></tr>" ;
   $lgn .= "<tr><td align=\"right\" valign=\"top\">".$fontes."<b>Titre&nbsp;(facultatif)&nbsp;:&nbsp;</b></font></td>" ;
   $lgn .= "<td colspan=\"2\"><input type=\"text\" name=\"fichier_titre\" size=\"30\"></td></tr>" ;
   $lgn .= "<tr><td align=\"right\" valign=\"top\">".$fontes."<b>Fichier&nbsp;attach&eacute;&nbsp;:&nbsp;</b></font></td>" ;
   $lgn .= "<td colspan=\"2\"><input type=\"file\" name=\"fichier\" size=\"30\"></td></tr>" ;
   $lgn .= "<tr><td></td><td colspan=\"2\">".$fontes."<i>Tous les documents ne sont pas accept&eacute;s, voir les " ;
   $lgn .= "<a onclick=\"javascript:document.getElementById('limites').style.display='';document.getElementById('id_page').className='gar102';\">limites et restrictions</a>.</i></font></td></tr>" ;
   Return $lgn ;
  }
 
 $action = var_courante ("action", 0, null) ;
 If (!IsSet ($action))
  {
   $action_seance = $action = var_courante ("action_seance", 0, null) ;
   If (!IsSet ($action))
    {
     $action_travail = $action = var_courante ("action_travail", 0, null) ;
     If (!IsSet ($action))
      {
       $action_devoir = $action = var_courante ("action_devoir", 0, null) ;
      }
    }
  }
 $id_service_prof = var_courante ("id_service_prof", 0, null) ;
 $date_consultation = var_courante ("date_consultation", 0, null) ;
 $onglet_defaut = var_courante ("onglet_defaut", 0, null) ;
 $millesime = millesime (0) ;
 $id_utilisateur = utilparcode ($_SESSION ["code"]) ;
 $nom_utilisateur = utilparid ($id_utilisateur) ;
 $param_theme = parametres_theme (themeparsession ($_SESSION ["code"])) ;
 $rep_themes = "../../images/themes/" ;
 
 // Verification des droits
 $id_classe = classe_service_prof ($id_service_prof) ;
 If (cahier_textes_actif ($id_classe) != 1)
  {
   $param_theme = parametres_theme (themeparsession ($_SESSION ["code"])) ;
   $rep_themes = "../../images/themes/" ;
   Include ($rep_themes.$param_theme ["nom_repertoire"]."/".$param_theme ["fichier_config"]) ;
 
   // Fin reelle de session !
   verif_droits ($droit_courant, $_SESSION ["code"]) ;
 
   Echo "<html><head>" ;
   entete_html ("Garennes", "", 1) ;
   Echo styles ("none", "none", "none", $theme [0][32], "none") ;
   Echo "</head>" ;
   Echo "<body background=\"".$rep_themes.$param_theme ["nom_repertoire"]."/".$theme [9][10]."\" onContextMenu=\"return false\">" ;
   Echo "<br><center>Le cahier de texte de cette classe n'a pas &eacute;t&eacute; activ&eacute; par la direction ou le secr&eacute;tariat !<br>" ;
   Echo "Vous ne pouvez donc pas y acc&eacute;der !</center></body></html>" ;
   Exit ;
  }
 
 $serv_prof = SQL_commande ("SELECT * FROM services_prof WHERE id_service_prof='".$id_service_prof."' LIMIT 1", $id_sql) ;
 $sp = SQL_tableau_associatif ($serv_prof, "") ;
 If (IsSet ($action) And ($action > 0))
  {
   $test = var_courante ("texte_seance", 0, null) ;
   If (!IsSet ($test))
    {
     $test = var_courante ("texte_travail", 0, null) ;
     If (!IsSet ($test))
      {
       $test = var_courante ("texte_devoir", 0, null) ; 
       If (!IsSet ($test))
        {
         $test = var_courante ("texte", 0, null) ;
         If (!IsSet ($test)) { $test = "" ; }
	}
      }
    }
   $tempo = "" ;
   While ($f = StrPos ($test, "/images/themes/fckeditor/"))
    {
     $d = StrPos ($test, "src=") ;
     $t = SubStr ($test, $d, $f-$d+25) ;
     $tempo .= SubStr ($test, 0, $d+6)."../..".SubStr ($test, $f, 25) ;
     $test = SubStr ($test, $f+25, StrLen ($test)-$f-25) ;
    }
   $tempo .= SubStr ($test, 0, StrLen ($test)) ;
   $texte = $tempo ;
   // Sauvegarde l'onglet par defaut
   If (($id_utilisateur > 0) And (IsSet ($onglet_defaut))) { sauvegarde_configuration ("PROF_".$id_utilisateur,"ONGLET","CAHIER_TEXTES",$onglet_defaut) ; }
   Switch ($action)
    {
     // Etape 1 : Nouvelle composition
     Case 1 : $date_entree = $date_maj = Date ("Y-m-d H:i:s") ;
              $annee = var_courante ("annee", 0, Date ("Y")) ;
	      $mois = var_courante ("mois", 0, Date ("m")) ;
	      $jour = var_courante ("jour", 0, Date ("d")) ;
	      $cahier_type = var_courante ("cahier_type", 0, 0) ;
	      $id_service_prof = var_courante ("id_service_prof", 0, 0) ;
	      $groupe = filtrage (var_courante ("groupe", 0, 0)) ;
	      $publication = var_courante ("publication", 0, 0) ;
	      If ($cahier_type == 0)
	       {
	        $heure_debut =  var_courante ("heure_debut", 0, Date ("H:i:s")) ;
	        $duree = var_courante ("duree", 0, "30") ;
	       }
	      Else
	       {
	        $heure_debut =  var_courante ("heure_debut", 0, "00:00:00") ;
	        $duree = var_courante ("duree", 0, 0) ;
	       }
	      $date = $annee."-".$mois."-".$jour ;
              $ok = SQL_commande ("INSERT INTO cahier_textes (id_cahier_texte,cahier_type,date,heure_debut,duree,id_service_prof,date_entree,date_maj,groupe,texte,publication)
                                   VALUES ('','".$cahier_type."','".$date."','".$heure_debut."','".$duree."','".$id_service_prof."','".$date_entree."','".$date_maj."','".$groupe."','".filtrage ($texte)."','".$publication."')",$id_sql) ;
              $res = SQL_commande ("SELECT * FROM cahier_textes WHERE cahier_type='".$cahier_type."' AND date='".$date."' AND heure_debut='".$heure_debut."' AND duree='".$duree."' AND id_service_prof='".$id_service_prof."'
	                                      AND date_entree='".$date_entree."' AND date_maj='".$date_maj."' AND publication='".$publication."' LIMIT 1", $id_sql) ;
              If (SQL_nbr_lignes ($res) == 1)
	       {
	        $modif = SQL_tableau_associatif ($res, "") ;
	        If (Is_UpLoaded_File ($_FILES ["fichier"]["tmp_name"]))
                 {
	          $id_cahier_texte = $modif ["id_cahier_texte"] ;
		  $fichier_titre = var_courante ("fichier_titre", 0, $_FILES ["fichier"]["name"]) ;
		  $date = var_courante ("date", 0, Date ("Y_m_d")) ;
	          $message = cahier_textes_gestion_fichier ($id_classe, $id_service_prof, $id_cahier_texte, $_FILES ["fichier"], $fichier_titre, $date, $action) ;
	         }
	        If (IsSet ($action_seance)) { $action_seance = $action = 5 ; $modif_seance = $modif ; } Else { $action_travail = $action = 5 ; $modif_travail = $modif ; }
	        $message = 4 ;
	       } Else { $message = 5 ; $action_seance = $action_travail = $action = 1 ; }
	      Break ;
     // Suppression du cours + documents associes
     Case 2 : $resultats = SQL_commande ("SELECT document FROM cahier_documents WHERE id_cahier_texte='".$_POST ["id_cahier_texte"]."'", $id_sql) ;
              $message = 6 ;
              If (SQL_nbr_lignes ($resultats) > 0)
	       {
	        $rep = cahier_textes_repertoire_stockage ($id_classe) ;
		$ok = 0 ;
	        For ($i = 0 ; $i < SQL_nbr_lignes ($resultats) ; $i++)
		 {
	          $ligne = SQL_ligne_suivante ($resultats) ;
		  If (@UnLink ($repertoire_racine.$rep.$ligne [0])) { $ok++ ; }
		 }
		If ($ok != SQL_nbr_lignes ($resultats)) { $message = 7 ; }
	       }
	      If ($message == 6)
	       {
                $ok = SQL_commande ("DELETE FROM cahier_documents WHERE id_cahier_texte='".$_POST ["id_cahier_texte"]."'", $id_sql) ;
                $ok = SQL_commande ("DELETE FROM cahier_textes WHERE id_cahier_texte='".$_POST ["id_cahier_texte"]."' LIMIT 1", $id_sql) ;
		$action_seance = $action_travail = $action = 1 ;
	       }
	      Else
	       {
	        $res = SQL_commande ("SELECT * FROM cahier_textes WHERE id_cahier_texte='".$_POST ["id_cahier_texte"]."' LIMIT 1", $id_sql) ;
                $modif = SQL_tableau_associatif ($res, "") ;
		If (IsSet ($action_seance)) { $action_seance = $action = 3 ; } Else { $action_travail = $action = 3 ; }
	       }
              Break ;
     // Debut modification
     Case 3 : $id_cahier_texte = var_courante ("id_cahier_texte", 0, 0) ;
              If ($id_cahier_texte > 0)
	       {
                $res = SQL_commande ("SELECT * FROM cahier_textes WHERE id_cahier_texte='".$id_cahier_texte."' LIMIT 1", $id_sql) ;
		If (SQL_nbr_lignes ($res) == 1)
		 {
                  $mdf = SQL_tableau_associatif ($res, "") ;
	          $racine = "cahier_textes.php" ;
	          $racine = Str_Replace ("/professeurs/pages/cahier_textes.php", "", $racine) ;
	          $mdf ["texte"] = Str_Replace ("../..", $racine, $mdf ["texte"]) ;
	          If (IsSet ($action_seance)) { $modif_seance = $mdf ; $action_seance = $action = 3 ; UnSet ($action_travail) ; }
		  Else { $modif_travail = $mdf ; $action_travail = $action = 3 ; UnSet ($action_seance) ; }
		 }
	        Else { $action_seance = $action_travail = $action = 1 ; }
	       }
	      Else { $action_seance = $action_travail = $action = 1 ; }
              Break ;
     // Fin modification
     Case 4 : $date_maj = Date ("Y-m-d H:i:s") ;
	      $annee = var_courante ("annee", 0, Date ("Y")) ;
	      $mois = var_courante ("mois", 0, Date ("m")) ;
	      $jour = var_courante ("jour", 0, Date ("d")) ;
	      $cahier_type = var_courante ("cahier_type", 0, 0) ;
	      If ($cahier_type == 0)
	       {
	        $heure_debut = var_courante ("heure_debut", 0, Date ("H:i:s")) ;
	        $duree = var_courante ("duree", 0, "30") ;
	       }
	      Else { $heure_debut = "00:00:00" ; $duree = 0 ; }
	      $date = $annee."-".$mois."-".$jour ;
	      
	      $id_cahier_texte = var_courante ("id_cahier_texte", 0, 0) ;
	      $groupe = filtrage (var_courante ("groupe", 0, 0)) ;
	      $publication = var_courante ("publication", 0, 0) ;
              $ok = SQL_commande ("UPDATE cahier_textes SET texte='".filtrage ($texte)."',date='".$date."',heure_debut='".$heure_debut."',duree='".$duree."',
	                                  date_maj='".$date_maj."',publication='".$publication."',groupe='".$groupe."',cahier_type='".$cahier_type."'
				    WHERE id_cahier_texte='".$id_cahier_texte."' LIMIT 1", $id_sql) ;
              $message = 1 ;
     // Etape 2 : Joindre des documents
     Case 5 : If (Is_UpLoaded_File ($_FILES ["fichier"]["tmp_name"]))
               {
	        $id_cahier_texte = var_courante ("id_cahier_texte", 0, 0) ;
		$fichier_titre = var_courante ("fichier_titre", 0, $_FILES ["fichier"]["name"]) ;
		$date = var_courante ("date", 0, Date ("Y_m_d")) ;
	        $message = cahier_textes_gestion_fichier ($id_classe, $id_service_prof, $id_cahier_texte, $_FILES ["fichier"], $fichier_titre, $date, $action) ;
	       }
	      // Renommer
	      If (($_POST ["id_cahier_document"] > 0) And ($_POST ["nouveau_nom"] != ""))
	       {
	        $ok = SQL_commande ("UPDATE cahier_documents SET titre='".filtrage ($_POST ["nouveau_nom"])."' WHERE id_cahier_document='".$_POST ["id_cahier_document"]."' LIMIT 1", $id_sql) ;
	       }
	      $res = SQL_commande ("SELECT * FROM cahier_textes WHERE id_cahier_texte='".$id_cahier_texte."' LIMIT 1", $id_sql) ;
              $modif = SQL_tableau_associatif ($res, "") ;
	      If (IsSet ($action_seance)) { $action_seance = $action = 3 ; $modif_seance = $modif ; } Else { $action_travail = $action = 3 ; $modif_travail = $modif ; }
              Break ;
     // Suppression d'un document seul
     Case 6 : $ok = SQL_commande ("SELECT document FROM cahier_documents WHERE id_cahier_document='".$_POST ["id_cahier_document"]."' LIMIT 1", $id_sql) ;
              If (SQL_nbr_lignes ($ok) == 1)
	       {
	        $ligne = SQL_ligne_suivante ($ok) ;
		$rep = cahier_textes_repertoire_stockage ($id_classe) ;
	        If (@UnLink ($repertoire_racine.$rep.$ligne [0]))
		 {
                  $ok = SQL_commande ("DELETE FROM cahier_documents WHERE id_cahier_document='".$_POST ["id_cahier_document"]."' LIMIT 1", $id_sql) ;
	          $message = 6 ;
		 }
		Else
		 {
		  If (File_Exists ($repertoire_racine.$rep.$ligne [0])) { $message = 7 ; }
		  Else
		   {
		    $ok = SQL_commande ("DELETE FROM cahier_documents WHERE id_cahier_document='".$_POST ["id_cahier_document"]."' LIMIT 1", $id_sql) ;
		    $message = 6 ;
		   }
		 }
	       }
	      Else { $message = 7 ; }
	      $res = SQL_commande ("SELECT * FROM cahier_textes WHERE id_cahier_texte='".$_POST ["id_cahier_texte"]."' LIMIT 1", $id_sql) ;
              $modif = SQL_tableau_associatif ($res, "") ;
	      If (IsSet ($action_seance)) { $action_seance = $action = 3 ; $modif_seance = $modif ; } Else { $action_travail = $action = 3 ; $modif_travail = $modif ; }
              Break ;
     // Rendre publique ou pas
     Case 7 : If ($_POST ["publication"] == 1) { $publication = 0 ; } Else { $publication = 1 ; }
              $ok = SQL_commande ("UPDATE cahier_textes SET publication='".$publication."' WHERE id_cahier_texte='".$_POST ["id_cahier_texte"]."' LIMIT 1", $id_sql) ;
	      $action_seance = $action_travail = $action = 1 ;
	      Break ;
     // Changement de date pour le cahier de texte
     Case 8 : $annee = var_courante ("annee", 0, Date ("Y")) ;
	      $mois = var_courante ("mois", 0, Date ("m")) ;
	      $jour = var_courante ("jour", 0, Date ("d")) ;
              $date_consultation = $annee."-".$mois."-".$jour." ".Date ("H:i:s") ;
              $action_seance = $action_travail = $action = 1 ;
	      Break ;
     // Effacement total du cahier de texte
     Case 9 : $res = SQL_commande ("SELECT DISTINCT d.id_cahier_document,d.document FROM cahier_documents d,cahier_textes t WHERE t.id_service_prof='".$_POST ["id_service_prof"]."' AND t.id_cahier_texte=d.id_cahier_texte", $id_sql) ;
              If (SQL_nbr_lignes ($res) > 0)
	       {
	        $rep = cahier_textes_repertoire_stockage ($id_classe) ;
	        For ($i = 0 ; $i < SQL_nbr_lignes ($res) ; $i++)
		 {
	          $ligne = SQL_ligne_suivante ($res) ;
		  //echo "rm ".$repertoire_racine.$rep.$ligne [1]."<br>" ;
		  $ok = @UnLink ($repertoire_racine.$rep.$ligne [1]) ;
		  //echo "DELETE FROM cahier_documents WHERE id_cahier_document='".$ligne [0]."' LIMIT 1<br>" ;
                  $ok = SQL_commande ("DELETE FROM cahier_documents WHERE id_cahier_document='".$ligne [0]."' LIMIT 1", $id_sql) ;
		 }
	       }
	      //echo "DELETE FROM cahier_textes WHERE id_service_prof='".$_POST ["id_service_prof"]."'<br>" ;
	      $ok = SQL_commande ("DELETE FROM cahier_textes WHERE id_service_prof='".$_POST ["id_service_prof"]."'", $id_sql) ;
	      $message = 6 ;
              $action = 1 ;
	      Break ;
    // Effacement partielle du cahier de texte
    Case 10 : $mdd = MkTime (12,0,0,$_POST ["mois_debut"],$_POST ["jour_debut"],$_POST ["jour_debut"]) ;
              $mdf = MkTime (12,0,0,$_POST ["mois_fin"],$_POST ["jour_fin"],$_POST ["jour_fin"]) ;
	      If ($mdd < $mdf)
	       {
	        $dd = $_POST ["annee_debut"]."-".$_POST ["mois_debut"]."-".$_POST ["jour_debut"] ;
                $df = $_POST ["annee_fin"]."-".$_POST ["mois_fin"]."-".$_POST ["jour_fin"] ;
	       }
	      Else
	       {
	        $dd = $_POST ["annee_fin"]."-".$_POST ["mois_fin"]."-".$_POST ["jour_fin"] ;
	        $df = $_POST ["annee_debut"]."-".$_POST ["mois_debut"]."-".$_POST ["jour_debut"] ;
	       }
              $res1 = SQL_commande ("SELECT id_cahier_texte FROM cahier_textes WHERE id_service_prof='".$_POST ["id_service_prof"]."' AND date>='".$dd."' AND date<='".$df."'", $id_sql) ;
              If (SQL_nbr_lignes ($res1) > 0)
	       {
	        $rep = cahier_textes_repertoire_stockage ($id_classe) ;
	        For ($i = 0 ; $i < SQL_nbr_lignes ($res1) ; $i++)
		 {
		  $l1 = SQL_ligne_suivante ($res1) ;
	          $res2 = SQL_commande ("SELECT id_cahier_document,document FROM cahier_documents WHERE id_cahier_texte='".$l1 [0]."'", $id_sql) ;
                  If (SQL_nbr_lignes ($res2) > 0)
	           {
	            For ($j = 0 ; $j < SQL_nbr_lignes ($res2) ; $j++)
		     {
	              $l2 = SQL_ligne_suivante ($res2) ;
		      //echo "rm ".$repertoire_racine.$rep.$l2 [1]."<br>" ;
		      $ok = @UnLink ($repertoire_racine.$rep.$l2 [1]) ;
		      //echo "DELETE FROM cahier_documents WHERE id_cahier_document='".$l2 [0]."' LIMIT 1<br>" ;
                      $ok = SQL_commande ("DELETE FROM cahier_documents WHERE id_cahier_document='".$l2 [0]."' LIMIT 1", $id_sql) ;
		     }
		   }
		  //echo "DELETE FROM cahier_textes WHERE id_cahier_texte='".$l1 [0]."'<br>" ;
		  $ok = SQL_commande ("DELETE FROM cahier_textes WHERE id_cahier_texte='".$l1 [0]."'", $id_sql) ;
                 }
	       }
	      $message = 6 ;
              $action = 1 ;
	      Break ;
    // Creation PDF progression/visualisation
    Case 11 :
    Case 12 : 
    Case 13 : 
    Case 14 : Include ($rep_themes.$param_theme ["nom_repertoire"]."/".$param_theme ["fichier_config"]) ;
	      If ($action < 13) { SQL_transmission (4) ; }
	      $lgn = "<html><body>" ;
	      If (($action == 11) Or ($action == 13))
	       {
                $lgn .= "<center><font color=\"".$theme [0][38]."\" size=\"+1\">Cahier&nbsp;de&nbsp;textes&nbsp;de&nbsp;la&nbsp;<b>".nom_classe_long_parid ($id_classe)."&nbsp;(".nom_classe_bref_parid ($id_classe).")</b><br>" ;
                If ($theme [0][39]) { $lgn .= "<b>" ; }
                If ($theme [0][40]) { $lgn .= "<i>" ; }
                $lgn .= nom_disc_long_parid ($sp ["discipline"]) ;
                If ($theme [0][40]) { $lgn .= "</i>" ; }
                If ($theme [0][39]) { $lgn .= "</b>" ; }
                $lgn .= "</font></center><br>" ;
	        $lgn .= generation_progression ("", $id_service_prof, $id_classe, 0, 0, "", "", 1) ;
		$nom_fichier = "progression" ;
	       }
	      ElseIf (($action == 12) Or ($action == 14))
	       {
                $lgn .= "<center><font color=\"".$theme [0][38]."\" size=\"+1\">Cahier&nbsp;de&nbsp;textes&nbsp;de&nbsp;la&nbsp;<b>".nom_classe_long_parid ($id_classe)."&nbsp;(".nom_classe_bref_parid ($id_classe).")</b><br>" ;
                $lgn .= "pour&nbsp;le&nbsp;".jour_html ($date_consultation, 1)."&nbsp;".decode_date_4 ($date_consultation).".</font></center><br>" ;
	        If (!IsSet ($date_consultation))
                 {
                  // Recherche de la derniere date valide
                  $resultat = SQL_commande ("SELECT t.date FROM cahier_textes t,services_prof s WHERE t.id_service_prof=s.id_service_prof AND s.classe='".$id_classe."' ORDER BY t.date DESC", $id_sql) ;
                  If (SQL_nbr_lignes ($resultat) > 0)
                   {
                    $ligne = SQL_ligne_suivante ($resultat) ;
                    $date_consultation = $ligne [0] ;
                   }
                  Else { $date_consultation = Date ("Y-m-d") ; }
                  $dcv = 1 ;
                 }
                Else { $dcv = 0 ; }
	        $lgn .= generation_progression ($date_consultation, "", $id_classe, 0, 0, "", "", 1) ;
		$nom_fichier = "visualisation" ;
	       }
	      
	      If ($action < 13)
	       {
	        $lgn .= "</body></html>" ;
	        Define ("RELATIVE_PATH", "../../include/") ;
	        Define ("FPDF_FONTPATH", RELATIVE_PATH."/font/") ;
	        
	        Require_Once ("../../include/html2fpdf.php") ;

                $pdf = New HTML2FPDF() ;
                $pdf->DisableTags() ;
                $lgn = Str_Replace ("<br/>", "<br>", $lgn) ;
                $pdf->AddPage () ;
                $pdf->WriteHTML ($lgn) ;
	        $pdf->AddPage () ;
	        //$pdf->SetFont('Arial','',10);
	        //$pdf->Write(5,$lgn) ;
	        $pdf->DisplayPreferences('CenterWindow,HideWindowUI') ;
                $pdf->Output ($nom_fichier.".pdf", "I") ;
	        
	        /*
	        Require_Once ("../../include/html2pdf.php") ;
	        $pdf=new PDF() ;
	        $pdf->Open() ;
	        $pdf->SetCreator("HTML2PDF") ;
	        $pdf->SetTitle ($titre) ;
	        $pdf->SetSubject ($sujet) ;
	        $pdf->SetAuthor ($auteur) ;
	        $pdf->SetFont ('Arial','',12) ;
	        $pdf->AddPage () ;
	        If (Ini_Get ('magic_quotes_gpc') == '1') { $texte = StripSlashes ($lgn) ; }
	        $pdf->WriteHTML ($lgn) ;
	        // Sauvegarde et redirection
	        $pdf->Output($nom_fichier.".pdf") ;
	        Header ("Location: ".$nom_fichier.".pdf") ;
	        */
	       }
	      Else { Echo $lgn."<script type=\"text/javascript\">window.print();window.close();</script></body></html>" ; }
              Exit ;
	      Break ;
    // Changement d'affichage
    Case 15 : $affiche = var_courante ("mois", 0, Date ("m")) ;
              If (IsSet ($action_seance)) { $nom_action = "seance" ; } Else { $nom_action = "travail" ; }
              sauvegarde_configuration ("CAHIER_TEXTES","AFFICHAGE",$nom_action."_".$id_service_prof,$affiche) ;
	      Break ;
    Case 16 : // Tri des editions
              If (IsSet ($action_seance)) { $nom = "SEANCES" ; } Else { $nom = "TRAVAIL" ; }
	      $tri = restaure_configuration ("CAHIER_TEXTES","AFFICHAGE","TRI_".$nom."_".$id_service_prof) ;
	      If ($tri == 0) { $tri = 1 ; } Else { $tri = 0 ; }
	      sauvegarde_configuration ("CAHIER_TEXTES","AFFICHAGE","TRI_".$nom."_".$id_service_prof,$tri) ;
              Break ;
    // Changement de date pour l'agenda
    Case 17 : $annee = var_courante ("annee", 0, Date ("Y")) ;
	      $mois = var_courante ("mois", 0, Date ("m")) ;
	      $jour = var_courante ("jour", 0, Date ("d")) ;
              $date_agenda_devoirs = $annee."-".$mois."-".$jour ;
              $action_seance = $action_travail = $action = 1 ;
	      Break ;
    // Changement de semaine pour l'agenda
    Case 18 : $date_agenda_devoirs = var_courante ("date_agenda_devoirs", 0, Date ("Y-m-d")) ;
              $action_seance = $action_travail = $action = 1 ;
	      Break ;
    // Nouveau devoir
    Case 19 : $date_entree = $date_maj = Date ("Y-m-d H:i:s") ;
              $annee = var_courante ("annee", 0, Date ("Y")) ;
	      $mois = var_courante ("mois", 0, Date ("m")) ;
	      $jour = var_courante ("jour", 0, Date ("d")) ;
	      $cahier_type = var_courante ("cahier_type", 0, 0) ;
	      $id_service_prof = var_courante ("id_service_prof", 0, 0) ;
	      $groupe = filtrage (var_courante ("groupe", 0, 0)) ;
	      $publication = var_courante ("publication", 0, 0) ;
	      $heure_debut =  var_courante ("heure_debut", 0, Date ("H:i:s")) ;
	      $duree = var_courante ("duree", 0, "30") ;
	      $date = $annee."-".$mois."-".$jour ;
              $ok = SQL_commande ("INSERT INTO cahier_devoirs (id_cahier_devoir,cahier_type,date,heure_debut,duree,id_service_prof,date_entree,date_maj,groupe,texte,publication)
                                   VALUES ('','".$cahier_type."','".$date."','".$heure_debut."','".$duree."','".$id_service_prof."','".$date_entree."','".$date_maj."','".$groupe."','".filtrage ($texte)."','".$publication."')",$id_sql) ;
              $res = SQL_commande ("SELECT * FROM cahier_devoirs WHERE cahier_type='".$cahier_type."' AND date='".$date."' AND heure_debut='".$heure_debut."' AND duree='".$duree."' AND id_service_prof='".$id_service_prof."'
	                                      AND date_entree='".$date_entree."' AND date_maj='".$date_maj."' AND publication='".$publication."' LIMIT 1", $id_sql) ;
              If (SQL_nbr_lignes ($res) == 1)
	       {
	        $modif = SQL_tableau_associatif ($res, "") ;
	        If (IsSet ($action_devoir)) { $action_devoir = $action = 5 ; $modif_devoir = $modif ; } Else { $action_devoir = $action = 5 ; $modif_devoir = $modif ; }
	        $message = 4 ;
	       } Else { $message = 5 ; $action_seance = $action_travail = $action_devoir = $action = 1 ; }
	      Break ;
    // Suppression du devoir
    Case 20 : $ok = SQL_commande ("DELETE FROM cahier_devoirs WHERE id_cahier_devoir='".$_POST ["id_cahier_devoir"]."' LIMIT 1", $id_sql) ;
	      $message = 6 ;
	      $action_seance = $action_travail = $action_devoir = $action = 1 ;
              Break ;
    // Debut modification devoir
    Case 21 : $id_cahier_devoir = var_courante ("id_cahier_devoir", 0, 0) ;
              If ($id_cahier_devoir > 0)
	       {
                $res = SQL_commande ("SELECT * FROM cahier_devoirs WHERE id_cahier_devoir='".$id_cahier_devoir."' LIMIT 1", $id_sql) ;
		If (SQL_nbr_lignes ($res) == 1)
		 {
                  $mdf = SQL_tableau_associatif ($res, "") ;
	          $racine = "cahier_textes.php" ;
	          $racine = Str_Replace ("/professeurs/pages/cahier_textes.php", "", $racine) ;
	          $mdf ["texte"] = Str_Replace ("../..", $racine, $mdf ["texte"]) ;
	          $modif_devoir = $mdf ;
		  $action_devoir = $action = 3 ;
		  UnSet ($action_seance) ;
		  UnSet ($action_travail) ;
		 }
	        Else { $action_seance = $action_travail = $action_devoir = $action = 1 ; }
	       }
	      Else { $action_seance = $action_travail = $action_devoir = $action = 1 ; }
              Break ;
    // Fin modification devoir
    Case 22 : $date_maj = Date ("Y-m-d H:i:s") ;
	      $annee = var_courante ("annee", 0, Date ("Y")) ;
	      $mois = var_courante ("mois", 0, Date ("m")) ;
	      $jour = var_courante ("jour", 0, Date ("d")) ;
	      $cahier_type = var_courante ("cahier_type", 0, 0) ;
	      $heure_debut = var_courante ("heure_debut", 0, Date ("H:i:s")) ;
	      $duree = var_courante ("duree", 0, "30") ;
	      $id_cahier_devoir = var_courante ("id_cahier_devoir", 0, 0) ;
	      $groupe = filtrage (var_courante ("groupe", 0, 0)) ;
	      $publication = var_courante ("publication", 0, 0) ;
	      $date = $annee."-".$mois."-".$jour ;
              $ok = SQL_commande ("UPDATE cahier_devoirs SET texte='".filtrage ($texte)."',date='".$date."',heure_debut='".$heure_debut."',duree='".$duree."',
	                                  date_maj='".$date_maj."',publication='".$publication."',groupe='".$groupe."'
				    WHERE id_cahier_devoir='".$id_cahier_devoir."' LIMIT 1", $id_sql) ;
              $message = 1 ;
	      Break ;
    // Tri des devoirs
    Case 23 : $tri = restaure_configuration ("CAHIER_TEXTES","AFFICHAGE","TRI_DEVOIRS_".$id_service_prof) ;
	      If ($tri == 0) { $tri = 1 ; } Else { $tri = 0 ; }
	      sauvegarde_configuration ("CAHIER_TEXTES","AFFICHAGE","TRI_DEVOIRS_".$id_service_prof,$tri) ;
              Break ;
    // Changement d'affichage des devoirs
    Case 24 : $affiche = var_courante ("mois", 0, Date ("m")) ;
              sauvegarde_configuration ("CAHIER_TEXTES","AFFICHAGE","devoir_".$id_service_prof,$affiche) ;
	      Break ;
    // Rendre publique ou pas
    Case 25 : If ($_POST ["publication"] == 1) { $publication = 0 ; } Else { $publication = 1 ; }
              $ok = SQL_commande ("UPDATE cahier_devoirs SET publication='".$publication."' WHERE id_cahier_devoir='".$_POST ["id_cahier_devoir"]."' LIMIT 1", $id_sql) ;
	      $action_seance = $action_travail = $action_devoir = $action = 1 ;
	      Break ;
    }
  }
 If ((IsSet ($action) And ($action != 3) And ($action != 5)) Or (!IsSet ($action)))
  {
   $modif ["id_cahier_texte"] = 0 ;
   $modif ["id_message"] = 0 ;
   $modif ["cahier_type"] = 0 ;
   $modif ["titre"] = "" ;
   $modif ["date"] = Date ("Y-m-d") ;
   $modif ["date_entree"] = Date ("Y-m-d H:i:s") ;
   $modif ["date_maj"] = Date ("Y-m-d H:i:s") ;
   $modif ["id_service_prof"] = $id_service_prof ;
   $modif ["heure_debut"] = Date ("H:i:s") ;
   $modif ["duree"] = 30 ;
   $modif ["texte"] = "" ;
   $modif ["publication"] = 1 ;
   $modif_seance = $modif_travail = $modif_devoir = $modif ;
   $modif ["id_cahier_devoir"] = 0 ;
   $action = $action_seance = $action_travail = $action_devoir = 1 ;
  }
 If (!IsSet ($action_seance)) { $action_seance = 1 ; }
 If (!IsSet ($action_travail)) { $action_travail = 1 ; }
 If (!IsSet ($action_devoir)) { $action_devoir = 1 ; }
 If ($id_utilisateur > 0)
  {
   If (!IsSet ($onglet_defaut)) { $onglet_defaut = restaure_configuration_defaut ("PROF_".$id_utilisateur,"ONGLET","CAHIER_TEXTES",0) ; }
   Else { sauvegarde_configuration ("PROF_".$id_utilisateur,"ONGLET","CAHIER_TEXTES",$onglet_defaut) ; }
  }
 Else { $onglet_defaut = 0 ; }
 
 
 Include ($rep_themes.$param_theme ["nom_repertoire"]."/".$param_theme ["fichier_config"]) ;
 $couleurs [0] = $theme [10][0] ;
 For ($i = 1 ; $i <= $theme [10][0] ; $i++) { $couleurs [$i] = $theme [10][$i] ; }
 $couleurs_v [0] = $theme [11][0] ;
 For ($i = 1 ; $i <= $theme [11][0] ; $i++) { $couleurs_v [$i] = $theme [11][$i] ; }
 
 // Fin reelle de session !
 verif_droits ($droit_courant, $_SESSION ["code"]) ;
 
 Echo "<html><head>" ;
 entete_html ("Garennes", "", 1) ;
 Echo styles ("none", "none", "none", $theme [0][32], "none") ;
 Include ("./cahier_textes.js") ;
 
 Include ("../../include/opacite.js") ;
 Echo "<script type=\"text/javascript\">" ;
 Include ("../../include/onglets.js") ;
 Echo "onglet_style('#000000','#000000','#000000','#000000','#000000','#000000','#000000','#000000','#000000','#000000','".$theme [0][3]."','#000000','#80add6','".$theme [0][3]."','".$theme [0][3]."','".$theme [0][3]."');" ;
 Echo "var onglets=new definition_onglet(\"onglets\",'','',50,25,".$onglet_defaut.",'".$theme [0][32]."');" ;
 Echo "onglets.ajouter(new item_onglet(\"Charte d'utilisation\", \"Charte d'utilisation du cahier de textes...\"));" ;
 Echo "onglets.ajouter(new item_onglet(\"Agenda Classe\", \"Agenda du travail &agrave; faire et des devoirs...\"));" ;
 Echo "onglets.ajouter(new item_onglet(\"Progression personnelle\", \"Visualisation de la progression personnelle...\"));" ;
 Echo "onglets.ajouter(new item_onglet(\"Cahier de la classe\", \"Visualisation du cahier de textes de la classe...\"));" ;
 Echo "onglets.ajouter(new item_onglet(\"Compte-rendus de s&eacute;ances\", \"Cr&eacute;er, ajouter, modifier une ou plusieurs s&eacute;ances...\"));" ;
 Echo "onglets.ajouter(new item_onglet(\"Travail &agrave; faire\", \"Cr&eacute;er, ajouter, modifier du travail &agrave; faire...\"));" ;
 Echo "onglets.ajouter(new item_onglet(\"Devoirs\", \"Cr&eacute;er, ajouter, modifier un devoir planifi&eacute;...\"));" ;
 Echo "onglets.ajouter(new item_onglet(\"Outils de gestion\", \"Quelques outils de gestion rapide...\"));" ;
 Echo "</script>" ;
 Echo "</head>" ;
 
 Echo "<body background=\"".$rep_themes.$param_theme ["nom_repertoire"]."/".$theme [9][10]."\" onContextMenu=\"return false\">" ;
 Echo "<div id=\"id_page\" onFocus=\"intensification_opacite();\">" ;
 Echo "<center><font color=\"".$theme [0][38]."\" size=\"+1\">Cahier&nbsp;de&nbsp;textes" ;
 $id_groupement_discipline_definition = groupement_service_prof ($id_service_prof,$millesime,$id_sql) ;
 If ($id_groupement_discipline_definition > 0)
  {
   $car_groupe = groupement_nom_groupe ($id_groupement_discipline_definition,$millesime,$id_sql) ;
   Echo "<br>".$car_groupe [1]."&nbsp;-&nbsp;C&oelig;fficient&nbsp;:&nbsp;".Str_Replace (".",",",$car_groupe [4]) ;
  }
 Echo "</font></center>" ;
 Echo "<form action=\"./cahier_textes.php\" method=\"post\" name=\"param\">" ;
 Echo "<input type=\"hidden\" name=\"onglet\" value=\"1\">" ;
 Echo "</form>" ;
 $non_centrer = 0 ;
 $titre_fenetre = "Classe : <b>".nom_classe_long_parid ($id_classe)."&nbsp;(".nom_classe_bref_parid ($id_classe).")</b>&nbsp;-&nbsp;Discipline&nbsp;:&nbsp;<b>".nom_disc_long_parid ($sp ["discipline"])."</b>&nbsp;(".$id_service_prof.")" ;
 Include ("../include/debut_theme.inc") ;
 If (IsSet ($message)) { Echo affiche_message ($message, 0) ; } Else { Echo "<br>" ; }
 Echo "<script>onglets.afficher_entete();</script>" ;
 
 $num_onglet = -1 ;
 // -------------------------------------------------------------------------------------------------------------------------------------------------
 // Charte d'utilisation
 $num_onglet++ ;
 Echo "<div id=\"onglets".$num_onglet."\" style=\"display:none;top:0px;left:0px;width:100%;height:100%;\">" ;
 Echo "<b>AVERTISSEMENT</b><br>" ;
 If (cahier_texte_type_acces_1 ($id_service_prof) == 2)
  {
   Echo "&nbsp;En raison du caract&egrave;re personnel du contenu, l'acc&egrave;s au site de consultation publique du cahier de texte est restreint</b>." ;
   Echo "<br>&nbsp;Pour acc&eacute;der aux cahiers de texte, le visiteur (&eacute;l&egrave;ve, parent, ...) doit &ecirc;tre en possession d'un nom d'utilisateur et d'un mot de passe valides.<br>" ;
  }
 Echo "<br>&nbsp;En utilisant le cahier de texte &eacute;lectronique de <b>GARENNES</b> :" ;
 Echo "<ul><li>vous acceptez que vos nom, pr&eacute;nom, classes et mati&egrave;res enseign&eacute;es apparaissent sur le site de consultation du cahier de texte,</li>" ;
 Echo "<li>vous acceptez que toutes les informations que vous fournissez dans ce module soient diffus&eacute;es sur ce m&ecirc;me site,</li>" ;
 Echo "<li>vous vous engagez &agrave; respecter les r&egrave;gles fix&eacute;es concernant les cahiers de texte,<br>(Circulaire du 3 mai 1961 adress&eacute;e aux recteurs - RLR, 550-1 b)</li>" ;
 Echo "<li>vous vous engagez &agrave; ne pas faire figurer d'informations nominatives concernant les &eacute;l&egrave;ves.</li>" ;
 Echo "</ul>" ;
 Echo "<b>RAPPEL</b><br>&nbsp;Le cahier de texte constitue un outil de communication pour l'&eacute;l&egrave;ve, les &eacute;quipes disciplinaires " ;
 Echo " et pluridisciplinaires,<br>&nbsp;l'administration, le chef d'&eacute;tablissement, les corps d'inspection et les familles.<br>" ;
 Echo "&nbsp;Il relate le travail r&eacute;alis&eacute; en classe :" ;
 Echo "<ul><li>Projet de l'&eacute;quipe p&eacute;dagogique,</li>" ;
 Echo "<li>Contenu p&eacute;dagogique de chaque s&eacute;ance, chronologie, objectif vis&eacute;, travail &agrave; faire ...</li>" ;
 Echo "<li>Documents divers,</li><li>&Eacute;valuations, ...</li></ul>" ;
 Echo "</div>" ;
 
 // -------------------------------------------------------------------------------------------------------------------------------------------------
 // Agenda des devoirs/travail
 $num_onglet++ ;
 Echo "<div id=\"onglets".$num_onglet."\" style=\"display:none;top:0px;left:0px;width:100%;height:100%;\">" ;
 If (!IsSet ($date_agenda_devoirs))
  {
   $date_agenda_devoirs = Date ("Y-m-d") ;
   // Recherche le premier jour : Lundi
   $dt = Explode ("-", $date_agenda_devoirs) ;
   $num_jour = Date ("w", MkTime (6,0,0,$dt [1],$dt [2],$dt [0])) ;
   If ($num_jour == 0) { $num_jour = 7 ; }
   $date_agenda_devoirs = Date ("Y-m-d", MkTime (6,0,0,$dt [1],$dt [2]-$num_jour+1,$dt [0])) ;
  }
 $date_courante = Explode ("-", $date_agenda_devoirs) ; 
 // Recherche le premier jour : Lundi
 $date_depart = $millesime."-09-01" ;
 $dt = Explode ("-", $date_depart) ;
 $num_jour = Date ("w", MkTime (6,0,0,$dt [1],$dt [2],$dt [0])) ;
 If ($num_jour == 0) { $num_jour = 7 ; }
 $date_depart = Date ("Y-m-d", MkTime (6,0,0,$dt [1],$dt [2]-$num_jour+1,$dt [0])) ;
 $dcourante = Explode ("-", $date_depart) ; 
 If (MkTime (6,0,0,$dcourante [1],$dcourante [2],$dcourante [0]) <= MkTime (6,0,0,8,30,$millesime))
  {
   $date_depart = Date ("Y-m-d", MkTime (6,0,0,$dcourante [1],$dcourante [2]+7,$dcourante [0])) ;
   $dcourante = Explode ("-", $date_depart) ; 
  }
 Echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\" style=\"border-collapse:collapse\" bgcolor=\"".$theme [10][2]."\">" ;
 Echo "<form action=\"./cahier_textes.php\" method=\"post\" name=\"choix_date_agenda\">" ;
 Echo "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$num_onglet."\">" ;
 Echo "<input type=\"hidden\" name=\"action\" value=\"18\">" ;
 Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
 Echo "<tr><td align=\"center\">&nbsp;Date&nbsp;:&nbsp;<select name=\"date_agenda_devoirs\" onchange=\"javascript:document.choix_date_agenda.submit();\">" ;
 While (MkTime (6,0,0,$dcourante [1],$dcourante [2],$dcourante [0]) < MkTime (6,0,0,8,30,$millesime+1))
  {
   $date_fin = Explode ("-", Date ("Y-m-d", MkTime (6,0,0,$dcourante [1],$dcourante [2]+6,$dcourante [0]))) ;
   Echo "<option value=\"".$date_depart."\"" ; If ($date_depart == $date_agenda_devoirs) { Echo " selected" ; }
   Echo ">Semaine du ".$dcourante [2]."/".$dcourante [1]."/".$dcourante [0]." au ".$date_fin [2]."/".$date_fin [1]."/".$date_fin [0]."</option>" ;
   $date_depart = Date ("Y-m-d", MkTime (6,0,0,$dcourante [1],$dcourante [2]+7,$dcourante [0])) ;
   $dcourante = Explode ("-", $date_depart) ; 
  }
 Echo "</select><input type=\"image\" src=\"../images/ajouter.png\" border=\"0\"></td></tr>" ;
 Echo "</form></table>" ;
 
 // Selecteurs
 Echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\" style=\"border-collapse:collapse\"><tr>" ;
 // Precedent
 If (MkTime (6,0,0,$date_courante [1],$date_courante [2]-7,$date_courante[0]) > MkTime (6,0,0,8,30,$millesime))
  {
   $dt = Date ("Y-m-d H:i:s", MkTime (12,0,0,$date_courante [1],$date_courante [2]-7,$date_courante[0])) ;
   $dct = Explode (" ", $dt) ;
   $dc = Explode ("-", $dct [0]) ;
   Echo "<form action=\"./cahier_textes.php\" method=\"post\" name=\"precedent_agenda\">" ;
   Echo "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$num_onglet."\">" ;
   Echo "<input type=\"hidden\" name=\"action\" value=\"17\">" ;
   Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
   Echo "<input type=\"hidden\" name=\"jour\" value=\"".$dc [2]."\">" ;
   Echo "<input type=\"hidden\" name=\"mois\" value=\"".$dc [1]."\">" ;
   Echo "<input type=\"hidden\" name=\"annee\" value=\"".$dc [0]."\">" ;
   Echo "<td><input type=\"image\" src=\"../images/fleche_gauche.png\" border=\"0\" title=\"Afficher l'agenda de la semaine du ".jour_html ($dt, 1)." ".decode_date_4 ($dt)."\"></td>" ;
   Echo "</form>" ;
  }
 // Suivant
 If (MkTime (6,0,0,$date_courante [1],$date_courante [2]+7,$date_courante[0]) <= MkTime (6,0,0,8,30,$millesime+1))
  {
   $dt = Date ("Y-m-d H:i:s", MkTime (12,0,0,$date_courante [1],$date_courante [2]+7,$date_courante[0])) ;
   $dct = Explode (" ", $dt) ;
   $dc = Explode ("-", $dct [0]) ;
   Echo "<form action=\"./cahier_textes.php\" method=\"post\" name=\"suivant_agenda\">" ;
   Echo "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$num_onglet."\">" ;
   Echo "<input type=\"hidden\" name=\"action\" value=\"17\">" ;
   Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
   Echo "<input type=\"hidden\" name=\"jour\" value=\"".$dc [2]."\">" ;
   Echo "<input type=\"hidden\" name=\"mois\" value=\"".$dc [1]."\">" ;
   Echo "<input type=\"hidden\" name=\"annee\" value=\"".$dc [0]."\">" ;
   Echo "<td align=\"right\"><input type=\"image\" src=\"../images/fleche_droite.png\" border=\"0\" title=\"Afficher l'agenda de la semaine du ".jour_html ($dt, 1)." ".decode_date_4 ($dt)."\"></td>" ;
   Echo "</form>" ;
  }
 Echo "</tr></table>" ;
 Echo generation_agenda (2,$id_classe,$date_agenda_devoirs,$couleurs,$couleurs_v) ;
 Echo "</div>" ;
 
 // -------------------------------------------------------------------------------------------------------------------------------------------------
 // Progression
 $num_onglet++ ;
 Echo "<div id=\"onglets".$num_onglet."\" style=\"display:none;top:0px;left:0px;width:100%;height:100%;\">" ;
 $html_avant = "<a href=\"./cahier_textes.php?action=11&id_service_prof=".$id_service_prof."&onglet_defaut=".$num_onglet."\">&nbsp;Cr&eacute;er&nbsp;un&nbsp;PDF&nbsp;de&nbsp;la&nbsp;progression&nbsp;</a><br>" ;
 $html_avant = "<a href=\"javascript:ouvrefenetre('./cahier_textes.php?action=13&id_service_prof=".$id_service_prof."&onglet_defaut=".$num_onglet."');\">&nbsp;Imprimer&nbsp;la&nbsp;progression&nbsp;</a><br><br>" ;
 $tri = restaure_configuration_defaut ("CAHIER_TEXTES","AFFICHAGE","TRI_PROGRESSION_".$id_service_prof,1) ;
 Echo generation_progression ("", $id_service_prof, $id_classe, 1, 0, $html_avant, "", $tri, $couleurs) ;
 Echo "</div>" ;

 // -------------------------------------------------------------------------------------------------------------------------------------------------
 // Cahier de textes de la classe : Visualisation
 $num_onglet++ ;
 Echo "<div id=\"onglets".$num_onglet."\" style=\"display:none;top:0px;left:0px;width:100%;height:100%;\">" ;
 // Recherche tous les cahiers de texte du jour de la classe
 If (!IsSet ($date_consultation))
  {
   // Recherche de la derniere date valide
   $resultat = SQL_commande ("SELECT t.date FROM cahier_textes t,services_prof s WHERE t.cahier_type='0' AND t.id_service_prof=s.id_service_prof AND s.classe='".$id_classe."' ORDER BY t.date DESC", $id_sql) ;
   If (SQL_nbr_lignes ($resultat) > 0)
    {
     $ligne = SQL_ligne_suivante ($resultat) ;
     $date_consultation = $ligne [0].Date (" H:i:s") ;
    }
   Else { $date_consultation = Date ("Y-m-d H:i:s") ; }
   $dcv = 1 ;
  }
 Else { $dcv = 0 ; }
 $dc = Explode (" ", $date_consultation) ; 
 $date_courante = Explode ("-", $dc [0]) ; 
 Echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\" style=\"border-collapse:collapse\" bgcolor=\"".$theme [10][2]."\">" ;
 Echo "<form action=\"./cahier_textes.php\" method=\"post\" name=\"choix_date\">" ;
 Echo "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$num_onglet."\">" ;
 Echo "<input type=\"hidden\" name=\"action\" value=\"8\">" ;
 //Echo "<input type=\"hidden\" name=\"id_cahier_texte\" value=\"".$modif ["id_cahier_texte"]."\">" ;
 Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
 Echo "<tr><td align=\"center\">&nbsp;Date&nbsp;:&nbsp;".saisie_date ($date_courante [2],$date_courante [1],$date_courante [0],$millesime,1,"jour","mois","annee") ;
 Echo "<input type=\"image\" src=\"../images/ajouter.png\" border=\"0\"></td></tr>" ;
 Echo "</form></table>" ;
 // Selecteurs
 Echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\" style=\"border-collapse:collapse\"><tr>" ;
 // Precedent
 $dt = Date ("Y-m-d H:i:s", MkTime (12,0,0,$date_courante [1],$date_courante [2]-1,$date_courante[0])) ;
 $dct = Explode (" ", $dt) ;
 $dc = Explode ("-", $dct [0]) ;
 Echo "<form action=\"./cahier_textes.php\" method=\"post\" name=\"precedent\">" ;
 Echo "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$num_onglet."\">" ;
 Echo "<input type=\"hidden\" name=\"action\" value=\"8\">" ;
 //Echo "<input type=\"hidden\" name=\"id_cahier_texte\" value=\"".$modif ["id_cahier_texte"]."\">" ;
 Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
 Echo "<input type=\"hidden\" name=\"jour\" value=\"".$dc [2]."\">" ;
 Echo "<input type=\"hidden\" name=\"mois\" value=\"".$dc [1]."\">" ;
 Echo "<input type=\"hidden\" name=\"annee\" value=\"".$dc [0]."\">" ;
 Echo "<td><input type=\"image\" src=\"../images/fleche_gauche.png\" border=\"0\" title=\"Afficher le cahier de textes du ".jour_html ($dt, 1)." ".decode_date_4 ($dt)."\"></td>" ;
 Echo "</form>" ;
 // Date
 Echo "<td align=\"center\"><font size=\"-6\"><b>Cahier&nbsp;de&nbsp;textes&nbsp;pour&nbsp;le&nbsp;".jour_html ($date_consultation, 1)." ".decode_date_4 ($date_consultation)."&nbsp;.&nbsp;</b></font></td>" ;
 // Suivant
 $dt = Date ("Y-m-d H:i:s", MkTime (12,0,0,$date_courante [1],$date_courante [2]+1,$date_courante[0])) ;
 $dct = Explode (" ", $dt) ;
 $dc = Explode ("-", $dct [0]) ;
 Echo "<form action=\"./cahier_textes.php\" method=\"post\" name=\"suivant\">" ;
 Echo "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$num_onglet."\">" ;
 Echo "<input type=\"hidden\" name=\"action\" value=\"8\">" ;
 //Echo "<input type=\"hidden\" name=\"id_cahier_texte\" value=\"".$modif ["id_cahier_texte"]."\">" ;
 Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
 Echo "<input type=\"hidden\" name=\"jour\" value=\"".$dc [2]."\">" ;
 Echo "<input type=\"hidden\" name=\"mois\" value=\"".$dc [1]."\">" ;
 Echo "<input type=\"hidden\" name=\"annee\" value=\"".$dc [0]."\">" ;
 Echo "<td align=\"right\"><input type=\"image\" src=\"../images/fleche_droite.png\" border=\"0\" title=\"Afficher le cahier de textes du ".jour_html ($dt, 1)." ".decode_date_4 ($dt)."\"></td>" ;
 Echo "</form></tr></table>" ;
 //Echo generation_visualisation ($date_consultation, $id_classe, 1, "<a href=\"./cahier_textes.php?action=12&id_service_prof=".$id_service_prof."&date_consultation=".$date_consultation."\">&nbsp;Cr&eacute;er&nbsp;un&nbsp;PDF&nbsp;de&nbsp;la&nbsp;visualisation&nbsp;</a><br><br>", "") ;
 $html_avant = "<a href=\"./cahier_textes.php?action=12&id_service_prof=".$id_service_prof."&date_consultation=".$date_consultation."&onglet_defaut=".$num_onglet."\">&nbsp;Cr&eacute;er&nbsp;un&nbsp;PDF&nbsp;de&nbsp;la&nbsp;visualisation&nbsp;</a><br>" ;
 $html_avant = "<a href=\"javascript:ouvrefenetre('./cahier_textes.php?action=14&id_service_prof=".$id_service_prof."&date_consultation=".$date_consultation."&onglet_defaut=".$num_onglet."');\">&nbsp;Imprimer&nbsp;la&nbsp;visualisation&nbsp;</a><br><br>" ;
 $tri = restaure_configuration_defaut ("CAHIER_TEXTES","AFFICHAGE","TRI_VISU_".$id_service_prof,0) ;
 Echo generation_progression ($date_consultation, "", $id_classe, 1, 0, $html_avant, "", $tri, $couleurs) ;
 Echo "</div>" ;
 
 $ok_activation_editeur = 0 ;
 // -------------------------------------------------------------------------------------------------------------------------------------------------
 // Edition du cahier de texte
 $num_onglet++ ;
 Echo "<div id=\"onglets".$num_onglet."\" style=\"display:none;top:0px;left:0px;width:100%;height:100%;\">" ;
 Echo "<form action=\"./cahier_textes.php\" method=\"post\" name=\"efface_doc_seance\">" ;
 Echo "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$num_onglet."\">" ;
 Echo "<input type=\"hidden\" name=\"action_seance\" value=\"6\">" ;
 Echo "<input type=\"hidden\" name=\"id_cahier_texte\" value=\"".$modif_seance ["id_cahier_texte"]."\">" ;
 Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
 Echo "<input type=\"hidden\" name=\"id_cahier_document\" value=\"0\">" ;
 Echo "</form>" ;
 Echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" style=\"border-collapse:collapse\">" ;
 // Menu du cahier de textes
 If ($onglet_defaut == $num_onglet)
  {
   Echo "<tr style=\"border-bottom:1px solid #000000;\"><td colspan=\"4\">" ;
   Echo "<a href=\"./cahier_textes.php?id_service_prof=".$id_service_prof."&onglet_defaut=".$num_onglet."\">" ;
   Echo "&nbsp;Cr&eacute;er&nbsp;une&nbsp;nouvelle&nbsp;notice&nbsp;</a></td></tr>" ;
  }
 Else { Echo "<tr style=\"border-bottom:1px solid #000000;\"><td colspan=\"4\"></td></tr>" ; }
 // Liste des notices
 $tri = restaure_configuration_defaut ("CAHIER_TEXTES","AFFICHAGE","TRI_SEANCES_".$id_service_prof,0) ;
 Echo "<tr><td valign=\"top\">".insertion_seance (0,$id_service_prof,$num_onglet,$tri,$theme)."</td>" ;
 // Separateur
 Echo "<td style=\"border-left:1px dotted #000000;\">&nbsp;</td>" ;
 // Fenetre de composition/modification
 Echo "<td valign=\"top\">" ;
 $fontes = "<font size=\"".$theme [0][28]."\">" ;
 
 //If ($modif_seance ["id_cahier_texte"] == 0) { $titre_fenetre = "Cr&eacute;ation d'une nouvelle s&eacute;ance..." ; }
 //Else { $titre_fenetre = "Modification du contenu d'une s&eacute;ance..." ; }
 //$non_centrer = 0 ;
 
 If ($onglet_defaut == $num_onglet)
  {
   Echo "<form action=\"./cahier_textes.php\" method=\"post\" name=\"seance\"";// onSubmit=\"return valide_saisie()\"" ;
   Echo " enctype=\"multipart/form-data\">" ;
   Echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">" ;
   Echo "<tr><td colspan=\"3\" bgcolor=\"".$theme [10][2]."\">&nbsp;<b>" ;
   If ($action_seance == 1) { Echo "Ajout d'une nouvelle notice de s&eacute;ance..." ; }
   ElseIf ($action_seance == 5) { Echo "Joindre un document support &agrave; la s&eacute;ance..." ; }
   ElseIf ($action_seance == 3) { Echo "Modification de la notice de la s&eacute;ance et ajout/suppression d'un document support..." ; }
   Echo "</b></td></tr><tr><td colspan=\"3\" height=\"5\">&nbsp;</td></tr>" ;
   If (($action_seance == 1) Or ($action_seance == 3) Or ($action_seance == 5))
    {
     If ($action_seance == 5)
       {
       $dd = Explode (":", $modif_seance ["heure_debut"]) ;
       $hd = $dd [0] ; $md = $dd [1] ; $sd = $dd [2] ;
       Echo "<tr><td colspan=\"4\"><table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\" style=\"border-top:1px solid #000000;border-bottom:1px solid #000000;border-collapse:collapse\">" ;
       Echo "<tr><td valign=\"middle\" bgcolor=\"".$theme [10][2]."\">".$fontes.jour_html ($modif_seance ["date"]." ".$modif_seance ["heure_debut"], 1)."&nbsp;".decode_date_4 ($modif_seance ["date"])."<br>" ;
       Echo "De&nbsp;".Str_Replace (":", "H", SubStr ($modif_seance ["heure_debut"], 0, 5))."&nbsp;&agrave;&nbsp;".Str_Replace (":", "H", Date ("H:i", MkTime ((integer)$hd,(integer)$md,(integer)($sd+$modif_seance ["duree"]),1,1,2006))).".</font></td>" ;
       If ($modif_seance ["groupe"]) { Echo "<td align=\"center\">".$fontes.$modif_seance ["groupe"]."</font></td>" ; }
       Echo "<td bgcolor=\"#ffffff\" style=\"border-left:1px solid #000000\" width=\"5\"></td><td bgcolor=\"#ffffff\" width=\"60%\">".$modif_seance ["texte"]."</td>" ;
       Echo "<td bgcolor=\"#ffffff\" width=\"5\"></td></tr></table></td></tr>" ;
      }
     Else
      {
       $dd = Explode ("-", $modif_seance ["date"]) ;
       $jour_courant = $dd [2] ;
       $mois_courant = $dd [1] ;
       $annee_courant = $dd [0] ;
       Echo "<tr><td align=\"right\" valign=\"top\">".$fontes."<b>Date&nbsp;de&nbsp;la&nbsp;s&eacute;ance&nbsp;:</b>&nbsp;</font></td>" ;
       Echo "<td>".saisie_date ($jour_courant,$mois_courant,$annee_courant,$millesime,1,"jour","mois","annee")."&nbsp;</font></td><td>&nbsp;</td></tr>" ;
       $h = cahier_textes_horaires ($id_service_prof) ;
       If ($h [0] == 0)
        {
         $h [0] = "08:00:00" ;
         $h [1] = "18:00:00" ;
         $h [2] = 30 ;
        }
       Else
        {
         If ($h [0] > $h [1]) { $p = $h [0] ; $h [0] = $h [1] ; $h [1] = $p ; }
         If ($h [2] < 15) { $h [2] = 15 ; }
        }
       $dd = Explode (":", $h [0]) ;
       $df = Explode (":", $h [1]) ;
       $hd = $dd [0] ; $md = $dd [1] ; $sd = $dd [2] ;
       $hf = $df [0] ; $mf = $df [1] ; $sf = $df [2] ;
       $cc = MkTime (Date ("H"),Date ("i"),Date ("s"),1,1,2006) ;
       $d0 = MkTime (0,0,0,1,1,2006) ;
       $d1 = MkTime ((integer)$hd,(integer)$md,(integer)$sd,1,1,2006) ;
       $d2 = MkTime ((integer)$hf,(integer)$mf,(integer)$sf,1,1,2006) ;
       // Heure de debut
       Echo "<tr><td align=\"right\" valign=\"middle\">".$fontes."<b>Heure&nbsp;de&nbsp;d&eacute;but&nbsp;:</b>&nbsp;</font></td>" ;
       Echo "<td colspan=\"2\"><select name=\"heure_debut\">" ;
       For ($i = $d1 ; $i <= $d2 ; $i+= $h [2]*60)
        {
         Echo "<option value=\"".Date ("H:i:s", $i)."\"" ; If (($modif_seance ["heure_debut"] >= Date ("H:i:s", $i)) And ($modif_seance ["heure_debut"] < Date ("H:i:s", $i)+$h [2]*60)) { Echo " selected" ; }
         Echo ">".Str_Replace (":", "H", Date ("H:i", $i))."</option>" ;
        }
       Echo "</select>&nbsp;</td><td></td></tr>" ;
       // Duree
       Echo "<tr><td align=\"right\" valign=\"middle\">".$fontes."<b>Dur&eacute;e&nbsp;:</b>&nbsp;</font></td>" ;
       Echo "<td colspan=\"2\"><select name=\"duree\">" ;
       If (IsSet ($modif_seance ["duree"]) And ($action_seance == 3)) { $selection = $modif_seance ["duree"] ; } Else { $selection = 3600 ; }
       For ($i = 0 ; $i < $d2-$d1 ; $i+= $h [2]*60)
        {
         Echo "<option value=\"".($i+$h [2]*60)."\"" ;
         If (($selection >= ($i+$h [2]*60)) And ($selection < $i+$h [2]*120)) { Echo " selected" ; }
         Echo ">".Str_Replace (":", "H", Date ("H:i", $i+82800+$h [2]*60))."</option>" ;
        }
       Echo "</select>&nbsp;</td><td></td></tr>" ;
       // Groupe
       Echo "<tr><td align=\"right\" valign=\"middle\">".$fontes."<b>Groupe/Classe ou <br> Type de cours :</b>&nbsp;</font></td>" ;
       Echo "<td colspan=\"2\" valign=\"middle\">".$fontes."<input type=\"text\" name=\"groupe\" value=\"".$modif_seance ["groupe"]."\" maxlength=\"49\" size=\"50\">&nbsp;</font></td><td></td></tr>" ;
       // Consultation public possible ou pas
       Echo "<tr><td align=\"right\" valign=\"middle\">".$fontes."<input type=\"checkbox\" name=\"publication\" value=\"1\"" ;
       If ($modif_seance ["publication"] == 1) { Echo " checked" ; }
       Echo "></font></td>" ;
       Echo "<td colspan=\"2\">".$fontes."&nbsp;<b>Si coch&eacute;, cette s&eacute;ance sera consultable par le public (Parents/&Eacute;l&egrave;ves,...).</b>&nbsp;</font></td><td></td></tr>" ;
       // Separateur
       Echo "<tr><td colspan=\"3\" height=\"5\"></td></tr>" ;
       // Editeur
       Echo "<tr><td colspan=\"3\" valign=\"top\" width=\"100%\">" ;
       Echo active_editeur ($hauteur_editeur,$largeur_editeur,"Simple",$param_theme ["nom_repertoire"],$modif_seance ["texte"],"texte_seance") ;
       $ok_activation_editeur = 1 ;
       Echo "</td></tr>" ;
      }
     // Insertion nouvelle doc
     If ($action_seance == 1) { Echo insertion_document ("Ins&eacute;rer&nbsp;un&nbsp;document") ; }
     $ok_doc [0][0] = 0 ;
     If ($action_seance != 1)
      {
       // Affichage des documents existants
       $resultat = SQL_commande ("SELECT id_cahier_document,titre,document,date,taille FROM cahier_documents WHERE id_cahier_texte='".$modif_seance ["id_cahier_texte"]."' ORDER BY date", $id_sql) ;
       $nbr_resultat = SQL_nbr_lignes ($resultat) ;
       If ($nbr_resultat > 0)
        {
         If ($nbr_resultat > 1) { $plus = "s" ; } Else { $plus = "" ; }
         $rep = cahier_textes_repertoire_stockage ($id_classe) ;
         Echo "<tr bgcolor=\"".$theme [10][2]."\"><td align=\"right\" valign=\"top\" style=\"border-top:1px #000000 solid;border-bottom:1px #000000 solid\">" ;
         Echo "<font size=\"-6\"><b>Document".$plus."&nbsp;pr&eacute;sent".$plus."&nbsp;:&nbsp;</b></font></td>" ;
         Echo "<td colspan=\"3\" style=\"border-top:1px #000000 solid;border-bottom:1px #000000 solid\"><font size=\"-6\">" ;
         For ($i = 0 ; $i < $nbr_resultat ; $i++)
          {
           $ligne = SQL_ligne_suivante ($resultat) ;
	   If (File_Exists ($repertoire_racine.$rep.$ligne [2]))
	    {
	     If ($ligne [1] == "")
	      {
	       $p = StrRPos ($ligne [2], "/") ;
	       $nom_doc = SubStr ($ligne [2], $p+1, StrLen ($ligne [2])-$p) ;
	      }
	     Else { $nom_doc = $ligne [1] ; }
	     If ($i > 0) { Echo "<br>" ; }
	     Echo "<a href=\"javascript:ouvrefenetre('".$http_garennes.$rep.$ligne [2]."')\" title=\"Visualiser...\"><i>".$nom_doc."</i></a>" ;
	     $aff = cahier_textes_arrondi_taille ($ligne [4], 2) ;
	     Echo "&nbsp;[".$aff [0].$aff [1]."o]&nbsp;(<a href=\"javascript:if(confirm('Voulez-vous effacer le document\\n".$nom_doc."\\nen date du ".jour_html ($ligne [3],0)." ".decode_date_4 ($ligne [3])." ?')){document.efface_doc_seance.id_cahier_document.value=".$ligne [0].";document.efface_doc_seance.submit()}\" title=\"Supprimer...\">Supprimer</a>)" ;
	     $ok_doc [0][0]++ ;
	     $ok_doc [$ok_doc [0][0]][0] = $ligne [0] ; // Id
	     $ok_doc [$ok_doc [0][0]][1] = $nom_doc ; // Nom du doc a changer
	    }
	   Else
	    {
	     // Nettoyage
	     $ok = SQL_commande ("DELETE FROM cahier_documents WHERE id_cahier_document='".$ligne [0]."' LIMIT 1", $id_sql) ;
	    }
	  }
         Echo "</font></td></tr>" ;
         // Action de renommage possible
         If ($ok_doc [0][0] > 0)
          {
	   Echo "<tr><td colspan=\"4\" height=\"5\">&nbsp;</td></tr>" ;
           Echo "<tr><td align=\"right\" valign=\"top\">".$fontes."<b>Renommer&nbsp;le&nbsp;document&nbsp;</b></font></td><td colspan=\"2\"><select name=\"id_cahier_document\"><option value=\"0\"></option>" ;
	   For ($i = 1 ; $i <= $ok_doc [0][0] ; $i++)
	    {
	     Echo "<option value=\"".$ok_doc [$i][0]."\">".$ok_doc [$i][1]."</option>" ;
	    }
	   Echo "</select>&nbsp;par&nbsp;<input type=\"text\" name=\"nouveau_nom\" size=\"30\"></td><td></td></tr>" ;
	  }
        }
       Else
        {
         Echo "<tr bgcolor=\"".$theme [10][2]."\"><td align=\"center\" colspan=\"4\" style=\"border-top:1px #000000 solid;border-bottom:1px #000000 solid\">" ;
         Echo "<font size=\"-6\"><b>Aucun&nbsp;document&nbsp;n'a&nbsp;&eacute;t&eacute;&nbsp;mis&nbsp;&agrave;&nbsp;disposition&nbsp;pour&nbsp;cette&nbsp;s&eacute;ance...&nbsp;</b></font></td></tr>" ;
        }
      }
    }
   If (($action_seance == 3) Or ($action_seance == 5))
    {
     // Insertion document
     Echo "<input type=\"hidden\" name=\"date\" value=\"".$modif_seance ["date"]."\">" ;
     Echo "<input type=\"hidden\" name=\"id_cahier_texte\" value=\"".$modif_seance ["id_cahier_texte"]."\">" ;
     Echo insertion_document ("Ins&eacute;rer&nbsp;un&nbsp;document") ;
    }
   Echo "<tr><td></td><td colspan=\"3\"><input type=\"image\" src=\"" ;
   If ($droit_courant != $droit_prof) { Echo "../images/valider.png" ; }
   Else { Echo $rep_themes.$param_theme ["nom_repertoire"]."/".$theme [9][0] ; }
   Echo "\" name=\"submit\" value=\" Valider le message \" border=\"0\"></td></tr></table>" ;
   Echo "<input type=\"hidden\" name=\"id_cahier_texte\" value=\"".$modif_seance ["id_cahier_texte"]."\">" ;
   Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$modif_seance ["id_service_prof"]."\">" ;
   Echo "<input type=\"hidden\" name=\"id_message\" value=\"".$modif_seance ["id_message"]."\">" ;
   Echo "<input type=\"hidden\" name=\"cahier_type\" value=\"0\">" ;
   Echo "<input type=\"hidden\" name=\"action_seance\" value=\"" ;
   If ($action_seance != 5) { If ($modif_seance ["id_cahier_texte"] == 0) { Echo "1" ; } Else { Echo "4" ; } } Else { Echo "5" ; }
   Echo "\">" ;
   Echo "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$num_onglet."\">" ;
   Echo "</form>" ;  
  }
 Else
  {
   // Bouton de creation d'un nouveau compte rendu
   Echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">" ;
   Echo "<tr><td colspan=\"3\" bgcolor=\"".$theme [10][2]."\">&nbsp;<b>" ;
   Echo "Ajouter une nouvelle notice de s&eacute;ance..." ;
   Echo "</td></tr>" ;
   Echo "<tr><td><br><br><a href=\"./cahier_textes.php?id_service_prof=".$id_service_prof."&onglet_defaut=".$num_onglet."\">" ;
   Echo "&nbsp;Cr&eacute;er&nbsp;une&nbsp;nouvelle&nbsp;notice&nbsp;</a></td></tr></table>" ;
  }
 Echo "</td></tr></table>" ;
 Echo "</div>" ;
 
 // -------------------------------------------------------------------------------------------------------------------------------------------------
 // Travail a faire
 $num_onglet++ ;
 Echo "<div id=\"onglets".$num_onglet."\" style=\"display:none;top:0px;left:0px;width:100%;height:100%;\">" ;
 Echo "<form action=\"./cahier_textes.php\" method=\"post\" name=\"efface_doc_travail\">" ;
 Echo "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$num_onglet."\">" ;
 Echo "<input type=\"hidden\" name=\"action_travail\" value=\"6\">" ;
 Echo "<input type=\"hidden\" name=\"id_cahier_texte\" value=\"".$modif_travail ["id_cahier_texte"]."\">" ;
 Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
 Echo "<input type=\"hidden\" name=\"id_cahier_document\" value=\"0\">" ;
 Echo "</form>" ;
 Echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" style=\"border-collapse:collapse\">" ;
 // Menu du cahier de textes
 If ($onglet_defaut == $num_onglet)
  {
   Echo "<tr style=\"border-bottom:1px solid #000000;\"><td colspan=\"4\">" ;
   Echo "<a href=\"./cahier_textes.php?id_service_prof=".$id_service_prof."&onglet_defaut=".$num_onglet."\">" ;
   Echo "&nbsp;Cr&eacute;er&nbsp;une&nbsp;nouvelle&nbsp;notice&nbsp;</a></td></tr>" ;
  }
 Else { Echo "<tr style=\"border-bottom:1px solid #000000;\"><td colspan=\"4\"></td></tr>" ; }
 // Liste des notices
 $tri = restaure_configuration_defaut ("CAHIER_TEXTES","AFFICHAGE","TRI_TRAVAIL_".$id_service_prof,0) ;
 Echo "<tr><td valign=\"top\">".insertion_seance (1,$id_service_prof,$num_onglet,$tri,$theme)."</td>" ;
 // Separateur
 Echo "<td style=\"border-left:1px dotted #000000;\">&nbsp;</td>" ;
 // Fenetre de composition/modification
 Echo "<td valign=\"top\">" ;
 
 If ($onglet_defaut == $num_onglet)
  {
   $fontes = "<font size=\"".$theme [0][28]."\">" ;
   Echo "<form action=\"./cahier_textes.php\" method=\"post\" name=\"travail\"";// onSubmit=\"return valide_saisie()\"" ;
   Echo " enctype=\"multipart/form-data\">" ;
   Echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">" ;
   Echo "<tr><td colspan=\"3\" bgcolor=\"".$theme [10][2]."\">&nbsp;<b>" ;
   If ($action_travail == 1) { Echo "Ajout d'une nouvelle notice de travail &agrave; faire..." ; }
   ElseIf ($action_travail == 5) { Echo "Joindre un nouveau document support au travail &agrave; faire..." ; }
   ElseIf ($action_travail == 3) { Echo "Modification de la notice du travail &agrave; faire et ajout/suppression d'un document support..." ; }
   Echo "</b></td></tr><tr><td colspan=\"3\" height=\"5\">&nbsp;</td></tr>" ;
   $ok_ins_doc = 0 ;
   If (($action_travail == 1) Or ($action_travail == 3) Or ($action_travail == 5))
    {
     If ($action_travail == 5)
      {
       Echo "<tr><td colspan=\"3\"><table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\" style=\"border-top:1px solid #000000;border-bottom:1px solid #000000;border-collapse:collapse\">" ;
       Echo "<tr><td valign=\"middle\" bgcolor=\"".$theme [10][2]."\">".$fontes."Pour&nbsp;le<br>".jour_html ($modif_travail ["date"]." ".$modif_travail ["heure_debut"], 1)."&nbsp;".decode_date_4 ($modif_travail ["date"]).".</font></td>" ;
       If ($modif_travail ["groupe"]) { Echo "<td align=\"center\">".$fontes.$modif_travail ["groupe"]."</font></td>" ; }
       Echo "<td bgcolor=\"#ffffff\" style=\"border-left:1px solid #000000\" width=\"5\"></td><td bgcolor=\"#ffffff\" width=\"60%\">".$modif_travail ["texte"]."</td>" ;
       Echo "<td bgcolor=\"#ffffff\" width=\"5\"></td></tr></table></td></tr>" ;
       Echo "<tr><td colspan=\"3\">&nbsp;</td></tr>" ;
       $ok_ins_doc = 1 ;
      }
     Else
      {
       $resultats = SQL_commande ("SELECT id_cahier_texte,date,heure_debut,duree FROM cahier_textes WHERE id_service_prof='".$id_service_prof."' AND cahier_type='0' ORDER BY date DESC,heure_debut ASC", $id_sql) ;
       $nbr = SQL_nbr_lignes ($resultats) ;
       If ($nbr > 0)
        {
         $ok_ins_doc = 1 ;
         Echo "<tr><td align=\"right\" valign=\"top\">".$fontes."<b>Attacher&nbsp;la&nbsp;notice&nbsp;&agrave;&nbsp;la&nbsp;s&eacute;ance&nbsp;du</b>&nbsp;</font></td>" ;
         Echo "<td><select name=\"cahier_type\">" ;
         For ($i = 0 ; $i < $nbr ; $i++)
          {
  	   $ligne = SQL_ligne_suivante ($resultats) ;
	   Echo "<option value=\"".$ligne [0]."\"" ; If ($modif_travail ["cahier_type"] == $ligne [0]) { Echo " selected" ; }
	   Echo ">".jour_html ($ligne [1]." ".$ligne [2], 1)."&nbsp;".decode_date_4 ($ligne [1])." a ".$ligne [2]."</option>" ;
	  }
         Echo "</select></font></td><td>&nbsp;</td></tr>" ;
         $dd = Explode ("-", $modif_travail ["date"]) ;
         $jour_courant = $dd [2] ;
         $mois_courant = $dd [1] ;
         $annee_courant = $dd [0] ;
         Echo "<tr><td align=\"right\" valign=\"top\">".$fontes."<b>&Agrave;&nbsp;faire&nbsp;pour&nbsp;le</b>&nbsp;</font></td>" ;
         Echo "<td>".saisie_date ($jour_courant,$mois_courant,$annee_courant,$millesime,1,"jour","mois","annee")."&nbsp;</font></td><td>&nbsp;</td></tr>" ;
         // Groupe
         Echo "<tr><td align=\"right\" valign=\"middle\">".$fontes."<b>Groupe/Classe ou <br> Type de cours :</b>&nbsp;</font></td>" ;
         Echo "<td colspan=\"2\" valign=\"middle\">".$fontes."<input type=\"text\" name=\"groupe\" value=\"".$modif_travail ["groupe"]."\" maxlength=\"49\" size=\"50\">&nbsp;</font></td><td></td></tr>" ;
         // Consultation public possible ou pas
         Echo "<tr><td align=\"right\" valign=\"middle\">".$fontes."<input type=\"checkbox\" name=\"publication\" value=\"1\"" ;
         If ($modif_travail ["publication"] == 1) { Echo " checked" ; }
         Echo "></font></td>" ;
         Echo "<td colspan=\"2\">".$fontes."&nbsp;<b>Si coch&eacute;, ce travail sera consultable par le public (Parents/&Eacute;l&egrave;ves,...).</b>&nbsp;</font></td><td></td></tr>" ;
         // Separateur
         Echo "<tr><td colspan=\"3\" height=\"5\"></td></tr>" ;
         // Editeur
         Echo "<tr><td colspan=\"3\" valign=\"top\" width=\"100%\">" ;
         Echo active_editeur (Round (2*$hauteur_editeur/3),$largeur_editeur,"Simple",$param_theme ["nom_repertoire"],$modif_travail ["texte"],"texte_travail") ;
         $ok_activation_editeur = 1 ;
         Echo "</td></tr>" ;
        }
       //Else { Echo "<input type=\"hidden\" name=\"cahier_type\" value=\"1\">" ; }
      }
     // Insertion nouvelle doc
     If (($action_travail == 1) And ($ok_ins_doc ==1)) { Echo insertion_document ("Ins&eacute;rer&nbsp;un&nbsp;document") ; }
     $ok_doc [0][0] = 0 ;
     If (($action_travail != 1) And ($ok_ins_doc == 1))
      {
       // Affichage des documents existants
       $resultat = SQL_commande ("SELECT id_cahier_document,titre,document,date,taille FROM cahier_documents WHERE id_cahier_texte='".$modif_travail ["id_cahier_texte"]."' ORDER BY date", $id_sql) ;
       $nbr_resultat = SQL_nbr_lignes ($resultat) ;
       If ($nbr_resultat > 0)
        {
         If ($nbr_resultat > 1) { $plus = "s" ; } Else { $plus = "" ; }
         $rep = cahier_textes_repertoire_stockage ($id_classe) ;
         Echo "<tr bgcolor=\"".$theme [10][2]."\"><td align=\"right\" valign=\"top\" style=\"border-top:1px #000000 solid;border-bottom:1px #000000 solid\">" ;
         Echo "<font size=\"-6\"><b>Document".$plus."&nbsp;pr&eacute;sent".$plus."&nbsp;:&nbsp;</b></font></td>" ;
         Echo "<td colspan=\"3\" style=\"border-top:1px #000000 solid;border-bottom:1px #000000 solid\"><font size=\"-6\">" ;
         For ($i = 0 ; $i < $nbr_resultat ; $i++)
          {
           $ligne = SQL_ligne_suivante ($resultat) ;
	   If (File_Exists ($repertoire_racine.$rep.$ligne [2]))
	    {
	     If ($ligne [1] == "")
	      {
	       $p = StrRPos ($ligne [2], "/") ;
	       $nom_doc = SubStr ($ligne [2], $p+1, StrLen ($ligne [2])-$p) ;
	      }
	     Else { $nom_doc = $ligne [1] ; }
	     If ($i > 0) { Echo "<br>" ; }
	     Echo "<a href=\"javascript:ouvrefenetre('".$http_garennes.$rep.$ligne [2]."')\" title=\"Visualiser...\"><i>".$nom_doc."</i></a>" ;
	     $aff = cahier_textes_arrondi_taille ($ligne [4], 2) ;
	     Echo "&nbsp;[".$aff [0].$aff [1]."o]&nbsp;(<a href=\"javascript:if(confirm('Voulez-vous effacer le document\\n".$nom_doc."\\nen date du ".jour_html ($ligne [3],0)." ".decode_date_4 ($ligne [3])." ?')){document.efface_doc_travail.id_cahier_document.value=".$ligne [0].";document.efface_doc_travail.submit()}\" title=\"Supprimer...\">Supprimer</a>)" ;
	     $ok_doc [0][0]++ ;
	     $ok_doc [$ok_doc [0][0]][0] = $ligne [0] ; // Id
	     $ok_doc [$ok_doc [0][0]][1] = $nom_doc ; // Nom du doc a changer
	    }
	   Else
	    {
	     // Nettoyage
	     $ok = SQL_commande ("DELETE FROM cahier_documents WHERE id_cahier_document='".$ligne [0]."' LIMIT 1", $id_sql) ;
	    }
  	  }
         Echo "</font></td></tr>" ;
         // Action de renommage possible
         If ($ok_doc [0][0] > 0)
          {
	   Echo "<tr><td colspan=\"4\" height=\"5\">&nbsp;</td></tr>" ;
           Echo "<tr><td align=\"right\" valign=\"top\">".$fontes."<b>Renommer&nbsp;le&nbsp;document&nbsp;</b></font></td><td colspan=\"2\"><select name=\"id_cahier_document\"><option value=\"0\"></option>" ;
	   For ($i = 1 ; $i <= $ok_doc [0][0] ; $i++)
	    {
	     Echo "<option value=\"".$ok_doc [$i][0]."\">".$ok_doc [$i][1]."</option>" ;
	    }
	   Echo "</select>&nbsp;par&nbsp;<input type=\"text\" name=\"nouveau_nom\" size=\"30\"></td><td></td></tr>" ;
	  }
        }
       Else
        {
         Echo "<tr bgcolor=\"".$theme [10][2]."\"><td align=\"center\" colspan=\"4\" style=\"border-top:1px #000000 solid;border-bottom:1px #000000 solid\">" ;
         Echo "<font size=\"-6\"><b>Aucun&nbsp;document&nbsp;n'a&nbsp;&eacute;t&eacute;&nbsp;mis&nbsp;&agrave;&nbsp;disposition&nbsp;pour&nbsp;cette&nbsp;notice...&nbsp;</b></font></td></tr>" ;
        }
      }
    }
   If ($ok_ins_doc == 1)
    {
     If (($action_travail == 3) Or ($action_travail == 5))
      {
       // Insertion document
       Echo "<input type=\"hidden\" name=\"date\" value=\"".$modif_travail ["date"]."\">" ;
       Echo "<input type=\"hidden\" name=\"id_cahier_texte\" value=\"".$modif_travail ["id_cahier_texte"]."\">" ;
       Echo insertion_document ("Ins&eacute;rer&nbsp;un&nbsp;document") ;
      }
     Echo "<tr><td></td><td colspan=\"3\"><input type=\"image\" src=\"" ;
     If ($droit_courant != $droit_prof) { Echo "../images/valider.png" ; }
     Else { Echo $rep_themes.$param_theme ["nom_repertoire"]."/".$theme [9][0] ; }
     Echo "\" name=\"submit\" value=\" Valider le message \" border=\"0\"></td></tr></table>" ;
    
     Echo "<input type=\"hidden\" name=\"id_cahier_texte\" value=\"".$modif_travail ["id_cahier_texte"]."\">" ;
     Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$modif_travail ["id_service_prof"]."\">" ;
     Echo "<input type=\"hidden\" name=\"id_message\" value=\"".$modif_travail ["id_message"]."\">" ;
     Echo "<input type=\"hidden\" name=\"heure_debut\" value=\"00:00:00\">" ;
     Echo "<input type=\"hidden\" name=\"duree\" value=\"0\">" ;
     Echo "<input type=\"hidden\" name=\"action_travail\" value=\"" ;
     If ($action_travail != 5) { If ($modif_travail ["id_cahier_texte"] == 0) { Echo "1" ; } Else { Echo "4" ; } } Else { Echo "5" ; }
     Echo "\"></td></tr>" ;
    }
   Else { Echo "<tr><td><br><b>&nbsp;Pour cr&eacute;er une nouvelle notice de travail &agrave; faire,&nbsp;<br>&nbsp;il faut d'abord ajouter une notice de compte rendu de s&eacute;ance...&nbsp;</b></td></tr></table></td></tr>" ; }
   Echo "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$num_onglet."\">" ;
   Echo "</form>" ;
  }
 Else
  {
   // Bouton de creation d'un nouveau compte rendu
   Echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">" ;
   Echo "<tr><td colspan=\"3\" bgcolor=\"".$theme [10][2]."\">&nbsp;<b>" ;
   Echo "Ajouter une nouvelle notice de travail &agrave; faire..." ;
   Echo "</td></tr>" ;
   Echo "<tr><td><br><br><a href=\"./cahier_textes.php?id_service_prof=".$id_service_prof."&onglet_defaut=".$num_onglet."\">" ;
   Echo "&nbsp;Cr&eacute;er&nbsp;une&nbsp;nouvelle&nbsp;notice&nbsp;</a></td></tr></table>" ;
  }
 Echo "</table>" ;
 Echo "</div>" ;
 
 // -------------------------------------------------------------------------------------------------------------------------------------------------
 // Devoir planifie
 $num_onglet++ ;
 Echo "<div id=\"onglets".$num_onglet."\" style=\"display:none;top:0px;left:0px;width:100%;height:100%;\">" ;
 Echo "<form action=\"./cahier_textes.php\" method=\"post\" name=\"efface_doc_devoir\">" ;
 Echo "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$num_onglet."\">" ;
 Echo "<input type=\"hidden\" name=\"action_travail\" value=\"6\">" ;
 Echo "<input type=\"hidden\" name=\"id_cahier_texte\" value=\"".$modif_devoir ["id_cahier_texte"]."\">" ;
 Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
 Echo "<input type=\"hidden\" name=\"id_cahier_document\" value=\"0\">" ;
 Echo "</form>" ;
 Echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" style=\"border-collapse:collapse\">" ;
 // Menu du cahier de textes
 If ($onglet_defaut == $num_onglet)
  {
   Echo "<tr style=\"border-bottom:1px solid #000000;\"><td colspan=\"4\">" ;
   Echo "<a href=\"./cahier_textes.php?id_service_prof=".$id_service_prof."&onglet_defaut=".$num_onglet."\">" ;
   Echo "&nbsp;Cr&eacute;er&nbsp;une&nbsp;nouvelle&nbsp;notice&nbsp;</a></td></tr>" ;
  }
 Else { Echo "<tr style=\"border-bottom:1px solid #000000;\"><td colspan=\"4\"></td></tr>" ; }
 // Liste des notices
 $tri = restaure_configuration_defaut ("CAHIER_TEXTES","AFFICHAGE","TRI_DEVOIRS_".$id_service_prof,0) ;
 Echo "<tr><td valign=\"top\">".insertion_seance (-1,$id_service_prof,$num_onglet,$tri,$theme)."</td>" ;
 // Separateur
 Echo "<td style=\"border-left:1px dotted #000000;\">&nbsp;</td>" ;
 // Fenetre de composition/modification
 Echo "<td valign=\"top\">" ;
 
 If ($onglet_defaut == $num_onglet)
  {
   $fontes = "<font size=\"".$theme [0][28]."\">" ;
   Echo "<form action=\"./cahier_textes.php\" method=\"post\" name=\"devoir\" enctype=\"multipart/form-data\">" ;
   Echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">" ;
   Echo "<tr><td colspan=\"3\" bgcolor=\"".$theme [10][2]."\">&nbsp;<b>" ;
   If ($action_devoir == 1) { Echo "Ajout d'une nouvelle notice de devoir planifi&eacute;..." ; }
   ElseIf ($action_devoir == 3) { Echo "Modification de la notice de devoir..." ; }
   Echo "</b></td></tr><tr><td colspan=\"3\" height=\"5\">&nbsp;</td></tr>" ;
   If (($action_devoir == 1) Or ($action_devoir == 3) Or ($action_devoir == 5))
    {
     $resultats = SQL_commande ("SELECT id_cahier_devoir,date,heure_debut,duree FROM cahier_devoirs WHERE id_service_prof='".$id_service_prof."' ORDER BY date DESC,heure_debut ASC", $id_sql) ;
     $nbr = SQL_nbr_lignes ($resultats) ;
     //If ($nbr > 0)
  //    {
       $dd = Explode ("-", $modif_devoir ["date"]) ;
       $jour_courant = $dd [2] ;
       $mois_courant = $dd [1] ;
       $annee_courant = $dd [0] ;
       Echo "<tr><td align=\"right\" valign=\"top\">".$fontes."<b>Date&nbsp;du&nbsp;devoir</b>&nbsp;</font></td>" ;
       Echo "<td>".saisie_date ($jour_courant,$mois_courant,$annee_courant,$millesime,1,"jour","mois","annee")."&nbsp;</font></td><td>&nbsp;</td></tr>" ;
       $h = cahier_textes_horaires ($id_service_prof) ;
       If ($h [0] == 0)
        {
         $h [0] = "08:00:00" ;
         $h [1] = "18:00:00" ;
         $h [2] = 30 ;
        }
       Else
        {
         If ($h [0] > $h [1]) { $p = $h [0] ; $h [0] = $h [1] ; $h [1] = $p ; }
         If ($h [2] < 15) { $h [2] = 15 ; }
        }
       $dd = Explode (":", $h [0]) ;
       $df = Explode (":", $h [1]) ;
       $hd = $dd [0] ; $md = $dd [1] ; $sd = $dd [2] ;
       $hf = $df [0] ; $mf = $df [1] ; $sf = $df [2] ;
       $cc = MkTime (Date ("H"),Date ("i"),Date ("s"),1,1,2006) ;
       $d0 = MkTime (0,0,0,1,1,2006) ;
       $d1 = MkTime ((integer)$hd,(integer)$md,(integer)$sd,1,1,2006) ;
       $d2 = MkTime ((integer)$hf,(integer)$mf,(integer)$sf,1,1,2006) ;
       // Heure de debut
       Echo "<tr><td align=\"right\" valign=\"middle\">".$fontes."<b>Heure&nbsp;de&nbsp;d&eacute;but&nbsp;:</b>&nbsp;</font></td>" ;
       Echo "<td colspan=\"2\"><select name=\"heure_debut\">" ;
       For ($i = $d1 ; $i <= $d2 ; $i+= $h [2]*60)
        {
         Echo "<option value=\"".Date ("H:i:s", $i)."\"" ; If (($modif_devoir ["heure_debut"] >= Date ("H:i:s", $i)) And ($modif_devoir ["heure_debut"] < Date ("H:i:s", $i)+$h [2]*60)) { Echo " selected" ; }
         Echo ">".Str_Replace (":", "H", Date ("H:i", $i))."</option>" ;
        }
       Echo "</select>&nbsp;</td><td></td></tr>" ;
       // Duree
       Echo "<tr><td align=\"right\" valign=\"middle\">".$fontes."<b>Dur&eacute;e&nbsp;:</b>&nbsp;</font></td>" ;
       Echo "<td colspan=\"2\"><select name=\"duree\">" ;
       If (IsSet ($modif_devoir ["duree"]) And (($action_devoir == 3) Or ($action_devoir == 5))) { $selection = $modif_devoir ["duree"] ; } Else { $selection = 3600 ; }
       For ($i = 0 ; $i < $d2-$d1 ; $i += $h [2]*60)
        {
         Echo "<option value=\"".($i+$h [2]*60)."\"" ;
         If (($selection >= ($i+$h [2]*60)) And ($selection < $i+$h [2]*120)) { Echo " selected" ; }
         Echo ">".Str_Replace (":", "H", Date ("H:i", $i+82800+$h [2]*60))."</option>" ;
        }
       Echo "</select>&nbsp;</td><td></td></tr>" ;
       // Groupe
       Echo "<tr><td align=\"right\" valign=\"middle\">".$fontes."<b>Groupe/Classe ou <br> Type de cours :</b>&nbsp;</font></td>" ;
       Echo "<td colspan=\"2\" valign=\"middle\">".$fontes."<input type=\"text\" name=\"groupe\" value=\"".$modif_devoir ["groupe"]."\" maxlength=\"49\" size=\"50\">&nbsp;</font></td><td></td></tr>" ;
       // Consultation public possible ou pas
       Echo "<tr><td align=\"right\" valign=\"middle\">".$fontes."<input type=\"checkbox\" name=\"publication\" value=\"1\"" ;
       If ($modif_devoir ["publication"] == 1) { Echo " checked" ; }
       Echo "></font></td>" ;
       Echo "<td colspan=\"2\">".$fontes."&nbsp;<b>Si coch&eacute;, ce devoir sera consultable sur l'agenda par le public (Parents/&Eacute;l&egrave;ves,...).</b>&nbsp;</font></td><td></td></tr>" ;
       // Separateur
       Echo "<tr><td colspan=\"3\" height=\"5\"></td></tr>" ;
       // Editeur
       Echo "<tr><td colspan=\"3\" valign=\"top\" width=\"100%\">" ;
       Echo active_editeur (Round (2*$hauteur_editeur/3),$largeur_editeur,"Simple",$param_theme ["nom_repertoire"],$modif_devoir ["texte"],"texte_devoir") ;
       $ok_activation_editeur = 1 ;
       Echo "</td></tr>" ;
      //}
    }
   Echo "<tr><td></td><td colspan=\"3\"><input type=\"image\" src=\"" ;
   If ($droit_courant != $droit_prof) { Echo "../images/valider.png" ; }
   Else { Echo $rep_themes.$param_theme ["nom_repertoire"]."/".$theme [9][0] ; }
   Echo "\" name=\"submit\" value=\" Valider le message \" border=\"0\"></td></tr></table>" ;
   Echo "<input type=\"hidden\" name=\"id_cahier_devoir\" value=\"".$modif_devoir ["id_cahier_devoir"]."\">" ;
   Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$modif_devoir ["id_service_prof"]."\">" ;
   Echo "<input type=\"hidden\" name=\"id_message\" value=\"".$modif_travail ["id_message"]."\">" ;
   Echo "<input type=\"hidden\" name=\"action_devoir\" value=\"" ; If ($modif_devoir ["id_cahier_devoir"] == 0) { Echo "19" ; } Else { Echo "22" ; }
   Echo "\"></td></tr>" ;
   Echo "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$num_onglet."\">" ;
   Echo "</form>" ;
  }
 Else
  {
   // Bouton de creation d'un nouveau compte rendu
   Echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">" ;
   Echo "<tr><td colspan=\"3\" bgcolor=\"".$theme [10][2]."\">&nbsp;<b>" ;
   Echo "Ajouter une nouvelle notice de devoir planifi&eacute;..." ;
   Echo "</td></tr>" ;
   Echo "<tr><td><br><br><a href=\"./cahier_textes.php?id_service_prof=".$id_service_prof."&onglet_defaut=".$num_onglet."\">" ;
   Echo "&nbsp;Cr&eacute;er&nbsp;une&nbsp;nouvelle&nbsp;notice&nbsp;</a></td></tr></table>" ;
  }
 Echo "</table>" ;
 Echo "</div>" ;
 
 // -------------------------------------------------------------------------------------------------------------------------------------------------
 // Outils
 $num_onglet++ ;
 Echo "<div id=\"onglets".$num_onglet."\" style=\"display:none;top:0px;left:0px;width:100%;height:100%;\">" ;
 Echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" style=\"border-collapse:collapse\">" ;
 // Taux de remplissage de l'ensemble de votre cahier de textes
 $tf = cahier_textes_tailles ($id_classe) ;
 //$teu = cahier_textes_taille_espace_utilise ($id_service_prof) ;
 $teu = cahier_textes_nombre_fichiers ($id_service_prof) ;
 //$aff_teu = cahier_textes_arrondi_taille ($teu [1], 2) ;
 $aff_tfic = cahier_textes_arrondi_taille ($teu [0], 2) ;
 $aff_tesp = cahier_textes_arrondi_taille ($tf [1], 2) ;
 //$aff_tfic2 = cahier_textes_arrondi_taille ($tf [1]-$teu, 2) ;
 If ($tf [1] != 0) { $pourcentage = Round ($teu [0]/$tf [1]*100,2) ; } Else { $pourcentage = 0 ; $teu [0] = $teu [1] = 0 ; }
 Echo "<tr bgcolor=\"".$theme [10][2]."\"><td colspan=\"3\"><b>Taux&nbsp;de&nbsp;remplissage&nbsp;de&nbsp;l'espace&nbsp;de&nbsp;stockage&nbsp;:</b>&nbsp;</td></tr>" ;
 Echo "<tr bgcolor=\"".$theme [10][2]."\"><td colspan=\"3\" align=\"center\">&nbsp;<b>Nombre&nbsp;de&nbsp;fichiers&nbsp;:</b>&nbsp;".$teu [1]."&nbsp;</td></tr>" ;
 Echo "<tr bgcolor=\"".$theme [10][2]."\"><td colspan=\"3\" align=\"center\">&nbsp;<b>Taille&nbsp;totale&nbsp;:</b>&nbsp;".$aff_tfic [0].$aff_tfic [1]."o&nbsp;sur&nbsp;".$aff_tesp [0].$aff_tesp [1]."o&nbsp;</td></tr>" ;
 Echo "<tr bgcolor=\"".$theme [10][2]."\"><td colspan=\"3\"><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" align=\"center\"><tr><td>" ;
 Echo "<table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\" style=\"border:1px solid #000000;border-collapse:collapse\" height=\"8\"><tr><td>" ;
 Echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" height=\"100%\"><tr><td width=\"".(2*$pourcentage)."\" bgcolor=\"" ;
 If ($pourcentage > 50) { If ($pourcentage > 75) { Echo "#FF0000" ; } Else { Echo "#FFC62F" ; } } Else { Echo "#00FF00" ; }
 Echo "\"></td><td width=\"".(2*(100-$pourcentage))."\" bgcolor=\"#FFFFFF\"></td></tr></table>" ;
 Echo "</td></tr></table></td><td>&nbsp;".Str_Replace (".",",",$pourcentage)."%&nbsp;</td></tr></table></td></tr>" ;
 Echo "<tr><td colspan=\"3\" width=\"5\"style=\"border-top:1px #000000 dotted\">&nbsp;</td></tr>" ;
 // Destruction partielle 1 : Cahier de texte
 $date_eloignee = Explode ("-", cahier_textes_date_plus_eloignee ($id_service_prof)) ;
 $date_courante = Explode ("-", Date ("Y-m-d")) ;
 Echo "<form action=\"./cahier_textes.php\" method=\"post\" name=\"tout_effacer_0\" onSubmit=\"return valider_eff_partielle()\">" ;
 Echo "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$num_onglet."\">" ;
 Echo "<input type=\"hidden\" name=\"action\" value=\"10\">" ;
 Echo "<input type=\"hidden\" name=\"id_cahier_texte\" value=\"0\">" ;
 Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
 Echo "<tr><td colspan=\"3\"><b>Outil&nbsp;1</b>&nbsp;:&nbsp;Suppression&nbsp;<b>TOTALE</b>&nbsp;et&nbsp;<b>D&Eacute;FINITIVE</b>&nbsp;d'une&nbsp;<b>PARTIE</b>&nbsp;de&nbsp;votre&nbsp;cahier&nbsp;de&nbsp;texte.&nbsp;</td></tr>" ;
 Echo "<tr><td>&nbsp;</td><td>Pour r&eacute;aliser cette op&eacute;ration, s&eacute;lectionner les dates de d&eacute;but et fin de destruction.</td><td></td></tr>" ;
 Echo "<tr><td align=\"right\" valign=\"middle\">&nbsp;<b>Date&nbsp;de&nbsp;d&eacute;but&nbsp;:</b>&nbsp;</td>" ;
 Echo "<td>Du".saisie_date ($date_eloignee [2],$date_eloignee [1],$date_eloignee [0],$millesime,1,"jour_debut","mois_debut","annee_debut")."&nbsp;&agrave;&nbsp;00H00m00s</td>" ;
 Echo "<td rowspan=\"2\" valign=\"middle\" align=\"center\"><input type=\"image\" src=\"" ;
 If ($droit_courant != $droit_prof) { Echo "../images/supprimer.png" ; }
 Else { Echo $rep_themes.$param_theme ["nom_repertoire"]."/".$theme [9][2] ; }
 Echo "\" name=\"submit\" value=\" Effacement partielle du cahier de textes \" border=\"0\"></td></tr>" ;
 Echo "<tr><td align=\"right\" valign=\"middle\">&nbsp;<b>Date&nbsp;de&nbsp;fin&nbsp;:</b>&nbsp;</td>" ;
 Echo "<td>Au".saisie_date ($date_courante [2],$date_courante [1],$date_courante [0],$millesime,1,"jour_fin","mois_fin","annee_fin")."&nbsp;&agrave;&nbsp;23H59m59s</td></tr>" ;
 Echo "<tr><td colspan=\"3\" width=\"5\"style=\"border-bottom:1px #000000 dotted\">&nbsp;</td></tr>" ;
 Echo "</form>" ;
 // Destruction totale 1 : cahier de texte
 Echo "<form action=\"./cahier_textes.php\" method=\"post\" name=\"tout_effacer_1\" onSubmit=\"return valider_eff_global()\">" ;
 Echo "<input type=\"hidden\" name=\"onglet_defaut\" value=\"".$num_onglet."\">" ;
 Echo "<input type=\"hidden\" name=\"action\" value=\"9\">" ;
 Echo "<input type=\"hidden\" name=\"id_cahier_texte\" value=\"0\">" ;
 Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
 Echo "<tr bgcolor=\"".$theme [10][2]."\">" ;
 Echo "<td colspan=\"3\"><b>Outil&nbsp;2</b>&nbsp;:&nbsp;Suppression&nbsp;<b>TOTALE</b>&nbsp;et&nbsp;<b>D&Eacute;FINITIVE</b>&nbsp;de&nbsp;<b>TOUT</b>&nbsp;votre&nbsp;cahier&nbsp;de&nbsp;texte.&nbsp;</td></tr>" ;
 Echo "<tr bgcolor=\"".$theme [10][2]."\"><td>&nbsp;</td><td>Pour r&eacute;aliser cette op&eacute;ration, cliquez sur le bouton </td><td valign=\"top\"><input type=\"image\" src=\"" ;
 If ($droit_courant != $droit_prof) { Echo "../images/supprimer.png" ; }
 Else { Echo $rep_themes.$param_theme ["nom_repertoire"]."/".$theme [9][2] ; }
 Echo "\" name=\"submit\" value=\" Effacement de tout le cahier de textes \" border=\"0\"></td></tr>" ;
 //Echo "<tr><td colspan=\"3\" width=\"5\"style=\"border-top:1px #000000 dotted\">&nbsp;</td></tr>" ;
 Echo "</form>" ;
 Echo "</table>" ;
 Echo "</div>" ;
  
 Echo "<script>onglets.afficher_pied();</script>" ;
 Include ("../include/fin_theme.inc") ;
 Echo "</div>" ;

 // Limites et restrictions
 $tf = cahier_textes_tailles ($id_classe) ;
 $teu = cahier_textes_taille_espace_utilise ($id_service_prof) ;
 $tnf = cahier_textes_nombre_fichiers ($id_service_prof) ;
 $tf2 = cahier_textes_arrondi_taille ($tf [0], 2) ;
 $tf3 = cahier_textes_arrondi_taille ($tf [1], 2) ;
 $teu2 = cahier_textes_arrondi_taille ($teu, 2) ;
 $titre_complexe = 1 ;
 $titre_fenetre = "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\"><tr><td><font color=\"".$theme [2][3]."\">GARENNES - Limites et restrictions du cahier de textes.</font></td>" ;
 $titre_fenetre .= "<td align=\"right\"><a onclick=\"javascript:document.getElementById('limites').style.display='none';document.getElementById('id_page').className='gar101';\"><img src=\"../../images/quitter.png\" border=\"0\" alt=\"Fermer\" title=\"Fermer la fen&egrave;tre\"></a></td></tr></table>" ;
 Echo "<div id=\"limites\" style=\"display:none;position:absolute;top:30px;left:0px;width:100%;height:100%;\">" ;
 Include ("../include/debut_theme.inc") ;
 Echo "<h2 style=\"background-color:".$theme [10][2]."\">Espace disque</h2>" ;
 Echo "<p>La taille maximale autoris&eacute;e pour un fichier est de <b>".$tf2 [0]." ".$tf2 [1]."o</b></p>" ;
 Echo "<p>L'espace disque maximal autoris&eacute; est de <b>".$tf3 [0]." ".$tf3 [1]."o</b>." ;
 Echo "<p>La taille totale des fichiers actuellement stock&eacute;s est de <b>".$teu2 [0]." ".$teu2 [1]."o</b>.</p>" ;
 // Taux de remplissage de l'ensemble de votre cahier de textes
 If ($tf [1] != 0) { $pourcentage = Round ($tnf [0]/$tf [1]*100,2) ; } Else { $pourcentage = 0 ; $tnf [0] = $tnf [1] = 0 ; }
 Echo "<p>Nombre&nbsp;de&nbsp;fichiers&nbsp;:&nbsp;<b>".$tnf [1]."</b>&nbsp;</p>" ;
 Echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" align=\"center\">" ;
 Echo "<tr><td align=\"center\">Taux&nbsp;de&nbsp;remplissage&nbsp;:</td><td></td></tr><tr><td>" ;
 Echo "<table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\" style=\"border:1px solid #000000;border-collapse:collapse\" height=\"8\"><tr><td>" ;
 Echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" height=\"100%\"><tr><td width=\"".(2*$pourcentage)."\" bgcolor=\"" ;
 If ($pourcentage > 50) { If ($pourcentage > 75) { Echo "#FF0000" ; } Else { Echo "#FFC62F" ; } } Else { Echo "#00FF00" ; }
 Echo "\"></td><td width=\"".(2*(100-$pourcentage))."\" bgcolor=\"#FFFFFF\"></td></tr></table>" ;
 Echo "</td></tr></table></td><td>&nbsp;".Str_Replace (".",",",$pourcentage)."%&nbsp;</td></tr></table>" ;
 Echo "<h2 style=\"background-color:".$theme [10][2]."\">Types de fichiers autoris&eacute;s en t&eacute;l&eacute;chargement</h2>" ;
 Echo "<p>Ci-dessous le tableau des extensions autoris&eacute;es.</p>" ;
 Echo "<p><font size=\"".$l ["titre"]."\">&nbsp;Voir : <b>\"".$texte_reglementaire."\"</b></font></p>" ;
 Echo "<center><table style=\"border:solid 1px ".$theme [0][4].";border-collapse:collapse\" width=\"100%\"><tr bgcolor=\"".$theme [0][29]."\">" ; //#6F6968
 Echo "<td style=\"font-weight:bold;\"><font color=\"".$theme [0][35]."\">Nom</font></td>" ;
 Echo "<td style=\"font-weight:bold;\"><font color=\"".$theme [0][35]."\">Extension</font></td>" ;
 Echo "<td style=\"text-align:center;font-weight:bold;\"><font color=\"".$theme [0][35]."\">Commentaires</font></td>" ;
 Echo "</tr>" ;
 $resultats = SQL_commande ("SELECT nom,extension,commentaires FROM cahier_type_documents WHERE actif='1' ORDER BY nom,extension", $id_sql) ;
 $nbr = SQL_nbr_lignes ($resultats) ;
 For ($i = 0 ; $i < $nbr ; $i++)
  {
   $ligne = SQL_ligne_suivante ($resultats) ;
   Echo "<tr" ; If ($i%$theme [10][0] == 1) { Echo " bgcolor=\"".$theme [10][2]."\"" ; }
   Echo "><td>".$ligne [0]."</td><td>".$ligne [1]."</td><td>".$ligne [2]."</td></tr>";
  }
 Echo "</table></center>" ;
 Include ("../include/fin_theme.inc") ;
 Echo "</div>" ;
 
 Echo "</body><html>" ;
?>